// services/network/public/mojom/first_party_sets.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_FIRST_PARTY_SETS_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_FIRST_PARTY_SETS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/first_party_sets.mojom-shared.h"
#include "services/network/public/mojom/first_party_sets.mojom-forward.h"
#include "services/network/public/mojom/schemeful_site.mojom.h"
#include <string>
#include <vector>




#include "services/network/public/cpp/first_party_sets_mojom_traits.h"




namespace network {
namespace mojom {





class  SiteIndex {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SiteIndex, T>::value>;
  using DataView = SiteIndexDataView;
  using Data_ = internal::SiteIndex_Data;

  template <typename... Args>
  static SiteIndexPtr New(Args&&... args) {
    return SiteIndexPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SiteIndexPtr From(const U& u) {
    return mojo::TypeConverter<SiteIndexPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SiteIndex>::Convert(*this);
  }


  SiteIndex();

  explicit SiteIndex(
      uint32_t value);


  ~SiteIndex();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SiteIndexPtr>
  SiteIndexPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SiteIndex::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SiteIndex::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SiteIndex::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SiteIndex::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SiteIndex_UnserializedMessageContext<
            UserType, SiteIndex::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SiteIndex::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SiteIndex::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SiteIndex_UnserializedMessageContext<
            UserType, SiteIndex::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SiteIndex::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SiteIndex::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SiteIndex::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SiteIndex::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SiteIndex::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  SamePartyContext {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SamePartyContext, T>::value>;
  using DataView = SamePartyContextDataView;
  using Data_ = internal::SamePartyContext_Data;

  template <typename... Args>
  static SamePartyContextPtr New(Args&&... args) {
    return SamePartyContextPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SamePartyContextPtr From(const U& u) {
    return mojo::TypeConverter<SamePartyContextPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SamePartyContext>::Convert(*this);
  }


  SamePartyContext();

  explicit SamePartyContext(
      ::net::SamePartyContext::Type context_type);


  ~SamePartyContext();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SamePartyContextPtr>
  SamePartyContextPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SamePartyContext::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SamePartyContext::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SamePartyContext::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SamePartyContext::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SamePartyContext_UnserializedMessageContext<
            UserType, SamePartyContext::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SamePartyContext::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SamePartyContext::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SamePartyContext_UnserializedMessageContext<
            UserType, SamePartyContext::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SamePartyContext::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::SamePartyContext::Type context_type;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SamePartyContext::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SamePartyContext::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SamePartyContext::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SamePartyContext::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}












class  FirstPartySetEntry {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FirstPartySetEntry, T>::value>;
  using DataView = FirstPartySetEntryDataView;
  using Data_ = internal::FirstPartySetEntry_Data;

  template <typename... Args>
  static FirstPartySetEntryPtr New(Args&&... args) {
    return FirstPartySetEntryPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FirstPartySetEntryPtr From(const U& u) {
    return mojo::TypeConverter<FirstPartySetEntryPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FirstPartySetEntry>::Convert(*this);
  }


  FirstPartySetEntry();

  FirstPartySetEntry(
      const ::net::SchemefulSite& primary,
      ::net::SiteType site_type,
      const absl::optional<::net::FirstPartySetEntry::SiteIndex>& site_index);


  ~FirstPartySetEntry();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FirstPartySetEntryPtr>
  FirstPartySetEntryPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FirstPartySetEntry::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FirstPartySetEntry::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FirstPartySetEntry::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FirstPartySetEntry::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FirstPartySetEntry_UnserializedMessageContext<
            UserType, FirstPartySetEntry::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FirstPartySetEntry::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FirstPartySetEntry::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FirstPartySetEntry_UnserializedMessageContext<
            UserType, FirstPartySetEntry::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FirstPartySetEntry::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::SchemefulSite primary;
  
  ::net::SiteType site_type;
  
  absl::optional<::net::FirstPartySetEntry::SiteIndex> site_index;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FirstPartySetEntry::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FirstPartySetEntry::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FirstPartySetEntry::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FirstPartySetEntry::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  FirstPartySetMetadata {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FirstPartySetMetadata, T>::value>;
  using DataView = FirstPartySetMetadataDataView;
  using Data_ = internal::FirstPartySetMetadata_Data;

  template <typename... Args>
  static FirstPartySetMetadataPtr New(Args&&... args) {
    return FirstPartySetMetadataPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FirstPartySetMetadataPtr From(const U& u) {
    return mojo::TypeConverter<FirstPartySetMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FirstPartySetMetadata>::Convert(*this);
  }


  FirstPartySetMetadata();

  FirstPartySetMetadata(
      const ::net::SamePartyContext& context,
      const absl::optional<::net::FirstPartySetEntry>& frame_entry,
      const absl::optional<::net::FirstPartySetEntry>& top_frame_entry);


  ~FirstPartySetMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FirstPartySetMetadataPtr>
  FirstPartySetMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FirstPartySetMetadata::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FirstPartySetMetadata::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FirstPartySetMetadata::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FirstPartySetMetadata::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FirstPartySetMetadata_UnserializedMessageContext<
            UserType, FirstPartySetMetadata::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FirstPartySetMetadata::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FirstPartySetMetadata::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FirstPartySetMetadata_UnserializedMessageContext<
            UserType, FirstPartySetMetadata::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FirstPartySetMetadata::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::SamePartyContext context;
  
  absl::optional<::net::FirstPartySetEntry> frame_entry;
  
  absl::optional<::net::FirstPartySetEntry> top_frame_entry;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FirstPartySetMetadata::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FirstPartySetMetadata::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FirstPartySetMetadata::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FirstPartySetMetadata::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  FirstPartySetsContextConfig {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FirstPartySetsContextConfig, T>::value>;
  using DataView = FirstPartySetsContextConfigDataView;
  using Data_ = internal::FirstPartySetsContextConfig_Data;

  template <typename... Args>
  static FirstPartySetsContextConfigPtr New(Args&&... args) {
    return FirstPartySetsContextConfigPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FirstPartySetsContextConfigPtr From(const U& u) {
    return mojo::TypeConverter<FirstPartySetsContextConfigPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FirstPartySetsContextConfig>::Convert(*this);
  }


  FirstPartySetsContextConfig();

  explicit FirstPartySetsContextConfig(
      const base::flat_map<::net::SchemefulSite, absl::optional<::net::FirstPartySetEntry>>& customizations);


  ~FirstPartySetsContextConfig();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FirstPartySetsContextConfigPtr>
  FirstPartySetsContextConfigPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FirstPartySetsContextConfig::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FirstPartySetsContextConfig::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FirstPartySetsContextConfig_UnserializedMessageContext<
            UserType, FirstPartySetsContextConfig::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FirstPartySetsContextConfig::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FirstPartySetsContextConfig::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FirstPartySetsContextConfig_UnserializedMessageContext<
            UserType, FirstPartySetsContextConfig::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FirstPartySetsContextConfig::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  base::flat_map<::net::SchemefulSite, absl::optional<::net::FirstPartySetEntry>> customizations;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  FirstPartySetsCacheFilter {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FirstPartySetsCacheFilter, T>::value>;
  using DataView = FirstPartySetsCacheFilterDataView;
  using Data_ = internal::FirstPartySetsCacheFilter_Data;

  template <typename... Args>
  static FirstPartySetsCacheFilterPtr New(Args&&... args) {
    return FirstPartySetsCacheFilterPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FirstPartySetsCacheFilterPtr From(const U& u) {
    return mojo::TypeConverter<FirstPartySetsCacheFilterPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FirstPartySetsCacheFilter>::Convert(*this);
  }


  FirstPartySetsCacheFilter();

  FirstPartySetsCacheFilter(
      const base::flat_map<::net::SchemefulSite, int64_t>& filter,
      int64_t browser_run_id);


  ~FirstPartySetsCacheFilter();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FirstPartySetsCacheFilterPtr>
  FirstPartySetsCacheFilterPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FirstPartySetsCacheFilter::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FirstPartySetsCacheFilter::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FirstPartySetsCacheFilter_UnserializedMessageContext<
            UserType, FirstPartySetsCacheFilter::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FirstPartySetsCacheFilter::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FirstPartySetsCacheFilter::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FirstPartySetsCacheFilter_UnserializedMessageContext<
            UserType, FirstPartySetsCacheFilter::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FirstPartySetsCacheFilter::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  base::flat_map<::net::SchemefulSite, int64_t> filter;
  
  int64_t browser_run_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  GlobalFirstPartySets {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GlobalFirstPartySets, T>::value>;
  using DataView = GlobalFirstPartySetsDataView;
  using Data_ = internal::GlobalFirstPartySets_Data;

  template <typename... Args>
  static GlobalFirstPartySetsPtr New(Args&&... args) {
    return GlobalFirstPartySetsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GlobalFirstPartySetsPtr From(const U& u) {
    return mojo::TypeConverter<GlobalFirstPartySetsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GlobalFirstPartySets>::Convert(*this);
  }


  GlobalFirstPartySets();

  GlobalFirstPartySets(
      const base::flat_map<::net::SchemefulSite, ::net::FirstPartySetEntry>& sets,
      const base::flat_map<::net::SchemefulSite, ::net::SchemefulSite>& aliases,
      ::net::FirstPartySetsContextConfig manual_config);

GlobalFirstPartySets(const GlobalFirstPartySets&) = delete;
GlobalFirstPartySets& operator=(const GlobalFirstPartySets&) = delete;

  ~GlobalFirstPartySets();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GlobalFirstPartySetsPtr>
  GlobalFirstPartySetsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GlobalFirstPartySets::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, GlobalFirstPartySets::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GlobalFirstPartySets::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GlobalFirstPartySets::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GlobalFirstPartySets_UnserializedMessageContext<
            UserType, GlobalFirstPartySets::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<GlobalFirstPartySets::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GlobalFirstPartySets::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GlobalFirstPartySets_UnserializedMessageContext<
            UserType, GlobalFirstPartySets::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GlobalFirstPartySets::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  base::flat_map<::net::SchemefulSite, ::net::FirstPartySetEntry> sets;
  
  base::flat_map<::net::SchemefulSite, ::net::SchemefulSite> aliases;
  
  ::net::FirstPartySetsContextConfig manual_config;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GlobalFirstPartySets::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GlobalFirstPartySets::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GlobalFirstPartySets::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GlobalFirstPartySets::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
SiteIndexPtr SiteIndex::Clone() const {
  return New(
      mojo::Clone(value)
  );
}

template <typename T, SiteIndex::EnableIfSame<T>*>
bool SiteIndex::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, SiteIndex::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
FirstPartySetEntryPtr FirstPartySetEntry::Clone() const {
  return New(
      mojo::Clone(primary),
      mojo::Clone(site_type),
      mojo::Clone(site_index)
  );
}

template <typename T, FirstPartySetEntry::EnableIfSame<T>*>
bool FirstPartySetEntry::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->primary, other_struct.primary))
    return false;
  if (!mojo::Equals(this->site_type, other_struct.site_type))
    return false;
  if (!mojo::Equals(this->site_index, other_struct.site_index))
    return false;
  return true;
}

template <typename T, FirstPartySetEntry::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.primary < rhs.primary)
    return true;
  if (rhs.primary < lhs.primary)
    return false;
  if (lhs.site_type < rhs.site_type)
    return true;
  if (rhs.site_type < lhs.site_type)
    return false;
  if (lhs.site_index < rhs.site_index)
    return true;
  if (rhs.site_index < lhs.site_index)
    return false;
  return false;
}
template <typename StructPtrType>
SamePartyContextPtr SamePartyContext::Clone() const {
  return New(
      mojo::Clone(context_type)
  );
}

template <typename T, SamePartyContext::EnableIfSame<T>*>
bool SamePartyContext::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->context_type, other_struct.context_type))
    return false;
  return true;
}

template <typename T, SamePartyContext::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.context_type < rhs.context_type)
    return true;
  if (rhs.context_type < lhs.context_type)
    return false;
  return false;
}
template <typename StructPtrType>
FirstPartySetMetadataPtr FirstPartySetMetadata::Clone() const {
  return New(
      mojo::Clone(context),
      mojo::Clone(frame_entry),
      mojo::Clone(top_frame_entry)
  );
}

template <typename T, FirstPartySetMetadata::EnableIfSame<T>*>
bool FirstPartySetMetadata::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->context, other_struct.context))
    return false;
  if (!mojo::Equals(this->frame_entry, other_struct.frame_entry))
    return false;
  if (!mojo::Equals(this->top_frame_entry, other_struct.top_frame_entry))
    return false;
  return true;
}

template <typename T, FirstPartySetMetadata::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.context < rhs.context)
    return true;
  if (rhs.context < lhs.context)
    return false;
  if (lhs.frame_entry < rhs.frame_entry)
    return true;
  if (rhs.frame_entry < lhs.frame_entry)
    return false;
  if (lhs.top_frame_entry < rhs.top_frame_entry)
    return true;
  if (rhs.top_frame_entry < lhs.top_frame_entry)
    return false;
  return false;
}
template <typename StructPtrType>
FirstPartySetsContextConfigPtr FirstPartySetsContextConfig::Clone() const {
  return New(
      mojo::Clone(customizations)
  );
}

template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>*>
bool FirstPartySetsContextConfig::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->customizations, other_struct.customizations))
    return false;
  return true;
}

template <typename T, FirstPartySetsContextConfig::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.customizations < rhs.customizations)
    return true;
  if (rhs.customizations < lhs.customizations)
    return false;
  return false;
}
template <typename StructPtrType>
FirstPartySetsCacheFilterPtr FirstPartySetsCacheFilter::Clone() const {
  return New(
      mojo::Clone(filter),
      mojo::Clone(browser_run_id)
  );
}

template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>*>
bool FirstPartySetsCacheFilter::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->filter, other_struct.filter))
    return false;
  if (!mojo::Equals(this->browser_run_id, other_struct.browser_run_id))
    return false;
  return true;
}

template <typename T, FirstPartySetsCacheFilter::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.filter < rhs.filter)
    return true;
  if (rhs.filter < lhs.filter)
    return false;
  if (lhs.browser_run_id < rhs.browser_run_id)
    return true;
  if (rhs.browser_run_id < lhs.browser_run_id)
    return false;
  return false;
}
template <typename StructPtrType>
GlobalFirstPartySetsPtr GlobalFirstPartySets::Clone() const {
  return New(
      mojo::Clone(sets),
      mojo::Clone(aliases),
      mojo::Clone(manual_config)
  );
}

template <typename T, GlobalFirstPartySets::EnableIfSame<T>*>
bool GlobalFirstPartySets::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->sets, other_struct.sets))
    return false;
  if (!mojo::Equals(this->aliases, other_struct.aliases))
    return false;
  if (!mojo::Equals(this->manual_config, other_struct.manual_config))
    return false;
  return true;
}

template <typename T, GlobalFirstPartySets::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.sets < rhs.sets)
    return true;
  if (rhs.sets < lhs.sets)
    return false;
  if (lhs.aliases < rhs.aliases)
    return true;
  if (rhs.aliases < lhs.aliases)
    return false;
  if (lhs.manual_config < rhs.manual_config)
    return true;
  if (rhs.manual_config < lhs.manual_config)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct  StructTraits<::network::mojom::SiteIndex::DataView,
                                         ::network::mojom::SiteIndexPtr> {
  static bool IsNull(const ::network::mojom::SiteIndexPtr& input) { return !input; }
  static void SetToNull(::network::mojom::SiteIndexPtr* output) { output->reset(); }

  static decltype(::network::mojom::SiteIndex::value) value(
      const ::network::mojom::SiteIndexPtr& input) {
    return input->value;
  }

  static bool Read(::network::mojom::SiteIndex::DataView input, ::network::mojom::SiteIndexPtr* output);
};


template <>
struct  StructTraits<::network::mojom::FirstPartySetEntry::DataView,
                                         ::network::mojom::FirstPartySetEntryPtr> {
  static bool IsNull(const ::network::mojom::FirstPartySetEntryPtr& input) { return !input; }
  static void SetToNull(::network::mojom::FirstPartySetEntryPtr* output) { output->reset(); }

  static const decltype(::network::mojom::FirstPartySetEntry::primary)& primary(
      const ::network::mojom::FirstPartySetEntryPtr& input) {
    return input->primary;
  }

  static decltype(::network::mojom::FirstPartySetEntry::site_type) site_type(
      const ::network::mojom::FirstPartySetEntryPtr& input) {
    return input->site_type;
  }

  static const decltype(::network::mojom::FirstPartySetEntry::site_index)& site_index(
      const ::network::mojom::FirstPartySetEntryPtr& input) {
    return input->site_index;
  }

  static bool Read(::network::mojom::FirstPartySetEntry::DataView input, ::network::mojom::FirstPartySetEntryPtr* output);
};


template <>
struct  StructTraits<::network::mojom::SamePartyContext::DataView,
                                         ::network::mojom::SamePartyContextPtr> {
  static bool IsNull(const ::network::mojom::SamePartyContextPtr& input) { return !input; }
  static void SetToNull(::network::mojom::SamePartyContextPtr* output) { output->reset(); }

  static decltype(::network::mojom::SamePartyContext::context_type) context_type(
      const ::network::mojom::SamePartyContextPtr& input) {
    return input->context_type;
  }

  static bool Read(::network::mojom::SamePartyContext::DataView input, ::network::mojom::SamePartyContextPtr* output);
};


template <>
struct  StructTraits<::network::mojom::FirstPartySetMetadata::DataView,
                                         ::network::mojom::FirstPartySetMetadataPtr> {
  static bool IsNull(const ::network::mojom::FirstPartySetMetadataPtr& input) { return !input; }
  static void SetToNull(::network::mojom::FirstPartySetMetadataPtr* output) { output->reset(); }

  static const decltype(::network::mojom::FirstPartySetMetadata::context)& context(
      const ::network::mojom::FirstPartySetMetadataPtr& input) {
    return input->context;
  }

  static const decltype(::network::mojom::FirstPartySetMetadata::frame_entry)& frame_entry(
      const ::network::mojom::FirstPartySetMetadataPtr& input) {
    return input->frame_entry;
  }

  static const decltype(::network::mojom::FirstPartySetMetadata::top_frame_entry)& top_frame_entry(
      const ::network::mojom::FirstPartySetMetadataPtr& input) {
    return input->top_frame_entry;
  }

  static bool Read(::network::mojom::FirstPartySetMetadata::DataView input, ::network::mojom::FirstPartySetMetadataPtr* output);
};


template <>
struct  StructTraits<::network::mojom::FirstPartySetsContextConfig::DataView,
                                         ::network::mojom::FirstPartySetsContextConfigPtr> {
  static bool IsNull(const ::network::mojom::FirstPartySetsContextConfigPtr& input) { return !input; }
  static void SetToNull(::network::mojom::FirstPartySetsContextConfigPtr* output) { output->reset(); }

  static const decltype(::network::mojom::FirstPartySetsContextConfig::customizations)& customizations(
      const ::network::mojom::FirstPartySetsContextConfigPtr& input) {
    return input->customizations;
  }

  static bool Read(::network::mojom::FirstPartySetsContextConfig::DataView input, ::network::mojom::FirstPartySetsContextConfigPtr* output);
};


template <>
struct  StructTraits<::network::mojom::FirstPartySetsCacheFilter::DataView,
                                         ::network::mojom::FirstPartySetsCacheFilterPtr> {
  static bool IsNull(const ::network::mojom::FirstPartySetsCacheFilterPtr& input) { return !input; }
  static void SetToNull(::network::mojom::FirstPartySetsCacheFilterPtr* output) { output->reset(); }

  static const decltype(::network::mojom::FirstPartySetsCacheFilter::filter)& filter(
      const ::network::mojom::FirstPartySetsCacheFilterPtr& input) {
    return input->filter;
  }

  static decltype(::network::mojom::FirstPartySetsCacheFilter::browser_run_id) browser_run_id(
      const ::network::mojom::FirstPartySetsCacheFilterPtr& input) {
    return input->browser_run_id;
  }

  static bool Read(::network::mojom::FirstPartySetsCacheFilter::DataView input, ::network::mojom::FirstPartySetsCacheFilterPtr* output);
};


template <>
struct  StructTraits<::network::mojom::GlobalFirstPartySets::DataView,
                                         ::network::mojom::GlobalFirstPartySetsPtr> {
  static bool IsNull(const ::network::mojom::GlobalFirstPartySetsPtr& input) { return !input; }
  static void SetToNull(::network::mojom::GlobalFirstPartySetsPtr* output) { output->reset(); }

  static const decltype(::network::mojom::GlobalFirstPartySets::sets)& sets(
      const ::network::mojom::GlobalFirstPartySetsPtr& input) {
    return input->sets;
  }

  static const decltype(::network::mojom::GlobalFirstPartySets::aliases)& aliases(
      const ::network::mojom::GlobalFirstPartySetsPtr& input) {
    return input->aliases;
  }

  static const decltype(::network::mojom::GlobalFirstPartySets::manual_config)& manual_config(
      const ::network::mojom::GlobalFirstPartySetsPtr& input) {
    return input->manual_config;
  }

  static bool Read(::network::mojom::GlobalFirstPartySets::DataView input, ::network::mojom::GlobalFirstPartySetsPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_FIRST_PARTY_SETS_MOJOM_H_