// services/network/public/mojom/network_isolation_key.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_ISOLATION_KEY_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_ISOLATION_KEY_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/network_isolation_key.mojom-shared.h"
#include "services/network/public/mojom/network_isolation_key.mojom-blink-forward.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-blink.h"
#include "services/network/public/mojom/schemeful_site.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"




namespace network {
namespace mojom {
namespace blink {








class BLINK_PLATFORM_EXPORT NetworkIsolationKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<NetworkIsolationKey, T>::value>;
  using DataView = NetworkIsolationKeyDataView;
  using Data_ = internal::NetworkIsolationKey_Data;

  template <typename... Args>
  static NetworkIsolationKeyPtr New(Args&&... args) {
    return NetworkIsolationKeyPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static NetworkIsolationKeyPtr From(const U& u) {
    return mojo::TypeConverter<NetworkIsolationKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NetworkIsolationKey>::Convert(*this);
  }


  NetworkIsolationKey();

  NetworkIsolationKey(
      const absl::optional<::blink::BlinkSchemefulSite>& top_frame_site,
      const absl::optional<::blink::BlinkSchemefulSite>& frame_site,
      const absl::optional<::base::UnguessableToken>& nonce);


  ~NetworkIsolationKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NetworkIsolationKeyPtr>
  NetworkIsolationKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        NetworkIsolationKey::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        NetworkIsolationKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::NetworkIsolationKey_UnserializedMessageContext<
            UserType, NetworkIsolationKey::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<NetworkIsolationKey::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return NetworkIsolationKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::NetworkIsolationKey_UnserializedMessageContext<
            UserType, NetworkIsolationKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<NetworkIsolationKey::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  absl::optional<::blink::BlinkSchemefulSite> top_frame_site;
  
  absl::optional<::blink::BlinkSchemefulSite> frame_site;
  
  absl::optional<::base::UnguessableToken> nonce;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
NetworkIsolationKeyPtr NetworkIsolationKey::Clone() const {
  return New(
      mojo::Clone(top_frame_site),
      mojo::Clone(frame_site),
      mojo::Clone(nonce)
  );
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>*>
bool NetworkIsolationKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->top_frame_site, other_struct.top_frame_site))
    return false;
  if (!mojo::Equals(this->frame_site, other_struct.frame_site))
    return false;
  if (!mojo::Equals(this->nonce, other_struct.nonce))
    return false;
  return true;
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.top_frame_site < rhs.top_frame_site)
    return true;
  if (rhs.top_frame_site < lhs.top_frame_site)
    return false;
  if (lhs.frame_site < rhs.frame_site)
    return true;
  if (rhs.frame_site < lhs.frame_site)
    return false;
  if (lhs.nonce < rhs.nonce)
    return true;
  if (rhs.nonce < lhs.nonce)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::NetworkIsolationKey::DataView,
                                         ::network::mojom::blink::NetworkIsolationKeyPtr> {
  static bool IsNull(const ::network::mojom::blink::NetworkIsolationKeyPtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::NetworkIsolationKeyPtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::NetworkIsolationKey::top_frame_site)& top_frame_site(
      const ::network::mojom::blink::NetworkIsolationKeyPtr& input) {
    return input->top_frame_site;
  }

  static const decltype(::network::mojom::blink::NetworkIsolationKey::frame_site)& frame_site(
      const ::network::mojom::blink::NetworkIsolationKeyPtr& input) {
    return input->frame_site;
  }

  static const decltype(::network::mojom::blink::NetworkIsolationKey::nonce)& nonce(
      const ::network::mojom::blink::NetworkIsolationKeyPtr& input) {
    return input->nonce;
  }

  static bool Read(::network::mojom::blink::NetworkIsolationKey::DataView input, ::network::mojom::blink::NetworkIsolationKeyPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_ISOLATION_KEY_MOJOM_BLINK_H_