// third_party/blink/public/mojom/payments/payment_credential.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAYMENTS_PAYMENT_CREDENTIAL_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAYMENTS_PAYMENT_CREDENTIAL_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/payments/payment_credential.mojom-shared.h"
#include "third_party/blink/public/mojom/payments/payment_credential.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace payments {
namespace mojom {

class PaymentCredentialProxy;

template <typename ImplRefTraits>
class PaymentCredentialStub;

class PaymentCredentialRequestValidator;
class PaymentCredentialResponseValidator;


class BLINK_COMMON_EXPORT PaymentCredential
    : public PaymentCredentialInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = PaymentCredentialInterfaceBase;
  using Proxy_ = PaymentCredentialProxy;

  template <typename ImplRefTraits>
  using Stub_ = PaymentCredentialStub<ImplRefTraits>;

  using RequestValidator_ = PaymentCredentialRequestValidator;
  using ResponseValidator_ = PaymentCredentialResponseValidator;
  enum MethodMinVersions : uint32_t {
    kStorePaymentCredentialMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct StorePaymentCredential_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~PaymentCredential() = default;


  using StorePaymentCredentialCallback = base::OnceCallback<void(PaymentCredentialStorageStatus)>;
  
  virtual void StorePaymentCredential(const std::vector<uint8_t>& credential_id, const std::string& rp_id, const std::vector<uint8_t>& user_id, StorePaymentCredentialCallback callback) = 0;
};



class BLINK_COMMON_EXPORT PaymentCredentialProxy
    : public PaymentCredential {
 public:
  using InterfaceType = PaymentCredential;

  explicit PaymentCredentialProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void StorePaymentCredential(const std::vector<uint8_t>& credential_id, const std::string& rp_id, const std::vector<uint8_t>& user_id, StorePaymentCredentialCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT PaymentCredentialStubDispatch {
 public:
  static bool Accept(PaymentCredential* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PaymentCredential* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PaymentCredential>>
class PaymentCredentialStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PaymentCredentialStub() = default;
  ~PaymentCredentialStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PaymentCredentialStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PaymentCredentialStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PaymentCredentialRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT PaymentCredentialResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace payments

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAYMENTS_PAYMENT_CREDENTIAL_MOJOM_H_