// Copyright 2023 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   extensions/common/api/networking_private.idl
// by tools/json_schema_compiler.
// DO NOT EDIT.

#include "extensions/common/api/networking_private.h"

#include <memory>
#include <ostream>
#include <string>
#include <utility>
#include <vector>

#include "base/check.h"
#include "base/check_op.h"
#include "base/notreached.h"
#include "base/strings/string_number_conversions.h"
#include "base/strings/utf_string_conversions.h"
#include "base/values.h"
#include "tools/json_schema_compiler/util.h"

using base::UTF8ToUTF16;

namespace extensions {
namespace api {
namespace networking_private {
//
// Types
//

const char* ToString(ActivationStateType enum_param) {
  switch (enum_param) {
    case ACTIVATION_STATE_TYPE_ACTIVATED:
      return "Activated";
    case ACTIVATION_STATE_TYPE_ACTIVATING:
      return "Activating";
    case ACTIVATION_STATE_TYPE_NOTACTIVATED:
      return "NotActivated";
    case ACTIVATION_STATE_TYPE_PARTIALLYACTIVATED:
      return "PartiallyActivated";
    case ACTIVATION_STATE_TYPE_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

ActivationStateType ParseActivationStateType(const std::string& enum_string) {
  if (enum_string == "Activated")
    return ACTIVATION_STATE_TYPE_ACTIVATED;
  if (enum_string == "Activating")
    return ACTIVATION_STATE_TYPE_ACTIVATING;
  if (enum_string == "NotActivated")
    return ACTIVATION_STATE_TYPE_NOTACTIVATED;
  if (enum_string == "PartiallyActivated")
    return ACTIVATION_STATE_TYPE_PARTIALLYACTIVATED;
  return ACTIVATION_STATE_TYPE_NONE;
}


const char* ToString(CaptivePortalStatus enum_param) {
  switch (enum_param) {
    case CAPTIVE_PORTAL_STATUS_UNKNOWN:
      return "Unknown";
    case CAPTIVE_PORTAL_STATUS_OFFLINE:
      return "Offline";
    case CAPTIVE_PORTAL_STATUS_ONLINE:
      return "Online";
    case CAPTIVE_PORTAL_STATUS_PORTAL:
      return "Portal";
    case CAPTIVE_PORTAL_STATUS_PROXYAUTHREQUIRED:
      return "ProxyAuthRequired";
    case CAPTIVE_PORTAL_STATUS_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

CaptivePortalStatus ParseCaptivePortalStatus(const std::string& enum_string) {
  if (enum_string == "Unknown")
    return CAPTIVE_PORTAL_STATUS_UNKNOWN;
  if (enum_string == "Offline")
    return CAPTIVE_PORTAL_STATUS_OFFLINE;
  if (enum_string == "Online")
    return CAPTIVE_PORTAL_STATUS_ONLINE;
  if (enum_string == "Portal")
    return CAPTIVE_PORTAL_STATUS_PORTAL;
  if (enum_string == "ProxyAuthRequired")
    return CAPTIVE_PORTAL_STATUS_PROXYAUTHREQUIRED;
  return CAPTIVE_PORTAL_STATUS_NONE;
}


const char* ToString(ConnectionStateType enum_param) {
  switch (enum_param) {
    case CONNECTION_STATE_TYPE_CONNECTED:
      return "Connected";
    case CONNECTION_STATE_TYPE_CONNECTING:
      return "Connecting";
    case CONNECTION_STATE_TYPE_NOTCONNECTED:
      return "NotConnected";
    case CONNECTION_STATE_TYPE_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

ConnectionStateType ParseConnectionStateType(const std::string& enum_string) {
  if (enum_string == "Connected")
    return CONNECTION_STATE_TYPE_CONNECTED;
  if (enum_string == "Connecting")
    return CONNECTION_STATE_TYPE_CONNECTING;
  if (enum_string == "NotConnected")
    return CONNECTION_STATE_TYPE_NOTCONNECTED;
  return CONNECTION_STATE_TYPE_NONE;
}


const char* ToString(DeviceStateType enum_param) {
  switch (enum_param) {
    case DEVICE_STATE_TYPE_UNINITIALIZED:
      return "Uninitialized";
    case DEVICE_STATE_TYPE_DISABLED:
      return "Disabled";
    case DEVICE_STATE_TYPE_ENABLING:
      return "Enabling";
    case DEVICE_STATE_TYPE_ENABLED:
      return "Enabled";
    case DEVICE_STATE_TYPE_PROHIBITED:
      return "Prohibited";
    case DEVICE_STATE_TYPE_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

DeviceStateType ParseDeviceStateType(const std::string& enum_string) {
  if (enum_string == "Uninitialized")
    return DEVICE_STATE_TYPE_UNINITIALIZED;
  if (enum_string == "Disabled")
    return DEVICE_STATE_TYPE_DISABLED;
  if (enum_string == "Enabling")
    return DEVICE_STATE_TYPE_ENABLING;
  if (enum_string == "Enabled")
    return DEVICE_STATE_TYPE_ENABLED;
  if (enum_string == "Prohibited")
    return DEVICE_STATE_TYPE_PROHIBITED;
  return DEVICE_STATE_TYPE_NONE;
}


const char* ToString(IPConfigType enum_param) {
  switch (enum_param) {
    case IP_CONFIG_TYPE_DHCP:
      return "DHCP";
    case IP_CONFIG_TYPE_STATIC:
      return "Static";
    case IP_CONFIG_TYPE_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

IPConfigType ParseIPConfigType(const std::string& enum_string) {
  if (enum_string == "DHCP")
    return IP_CONFIG_TYPE_DHCP;
  if (enum_string == "Static")
    return IP_CONFIG_TYPE_STATIC;
  return IP_CONFIG_TYPE_NONE;
}


const char* ToString(NetworkType enum_param) {
  switch (enum_param) {
    case NETWORK_TYPE_ALL:
      return "All";
    case NETWORK_TYPE_CELLULAR:
      return "Cellular";
    case NETWORK_TYPE_ETHERNET:
      return "Ethernet";
    case NETWORK_TYPE_TETHER:
      return "Tether";
    case NETWORK_TYPE_VPN:
      return "VPN";
    case NETWORK_TYPE_WIRELESS:
      return "Wireless";
    case NETWORK_TYPE_WIFI:
      return "WiFi";
    case NETWORK_TYPE_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

NetworkType ParseNetworkType(const std::string& enum_string) {
  if (enum_string == "All")
    return NETWORK_TYPE_ALL;
  if (enum_string == "Cellular")
    return NETWORK_TYPE_CELLULAR;
  if (enum_string == "Ethernet")
    return NETWORK_TYPE_ETHERNET;
  if (enum_string == "Tether")
    return NETWORK_TYPE_TETHER;
  if (enum_string == "VPN")
    return NETWORK_TYPE_VPN;
  if (enum_string == "Wireless")
    return NETWORK_TYPE_WIRELESS;
  if (enum_string == "WiFi")
    return NETWORK_TYPE_WIFI;
  return NETWORK_TYPE_NONE;
}


const char* ToString(ProxySettingsType enum_param) {
  switch (enum_param) {
    case PROXY_SETTINGS_TYPE_DIRECT:
      return "Direct";
    case PROXY_SETTINGS_TYPE_MANUAL:
      return "Manual";
    case PROXY_SETTINGS_TYPE_PAC:
      return "PAC";
    case PROXY_SETTINGS_TYPE_WPAD:
      return "WPAD";
    case PROXY_SETTINGS_TYPE_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

ProxySettingsType ParseProxySettingsType(const std::string& enum_string) {
  if (enum_string == "Direct")
    return PROXY_SETTINGS_TYPE_DIRECT;
  if (enum_string == "Manual")
    return PROXY_SETTINGS_TYPE_MANUAL;
  if (enum_string == "PAC")
    return PROXY_SETTINGS_TYPE_PAC;
  if (enum_string == "WPAD")
    return PROXY_SETTINGS_TYPE_WPAD;
  return PROXY_SETTINGS_TYPE_NONE;
}


ManagedBoolean::ManagedBoolean()
 {}

ManagedBoolean::~ManagedBoolean() = default;
ManagedBoolean::ManagedBoolean(ManagedBoolean&& rhs) = default;
ManagedBoolean& ManagedBoolean::operator=(ManagedBoolean&& rhs) = default;
// static
bool ManagedBoolean::Populate(
    const base::Value& value, ManagedBoolean* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* active_value = dict.Find("Active");
  if (active_value) {
    {
      auto temp = (*active_value).GetIfBool();
      if (!temp.has_value()) {
        out->active = absl::nullopt;
        return false;
      }
      out->active = *temp;
    }
  }

  const base::Value* effective_value = dict.Find("Effective");
  if (effective_value) {
    {
      auto* temp = (*effective_value).GetIfString();
      if (!temp) {
        out->effective = absl::nullopt;
        return false;
      }
      out->effective = *temp;
    }
  }

  const base::Value* user_policy_value = dict.Find("UserPolicy");
  if (user_policy_value) {
    {
      auto temp = (*user_policy_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_policy = absl::nullopt;
        return false;
      }
      out->user_policy = *temp;
    }
  }

  const base::Value* device_policy_value = dict.Find("DevicePolicy");
  if (device_policy_value) {
    {
      auto temp = (*device_policy_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_policy = absl::nullopt;
        return false;
      }
      out->device_policy = *temp;
    }
  }

  const base::Value* user_setting_value = dict.Find("UserSetting");
  if (user_setting_value) {
    {
      auto temp = (*user_setting_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_setting = absl::nullopt;
        return false;
      }
      out->user_setting = *temp;
    }
  }

  const base::Value* shared_setting_value = dict.Find("SharedSetting");
  if (shared_setting_value) {
    {
      auto temp = (*shared_setting_value).GetIfBool();
      if (!temp.has_value()) {
        out->shared_setting = absl::nullopt;
        return false;
      }
      out->shared_setting = *temp;
    }
  }

  const base::Value* user_editable_value = dict.Find("UserEditable");
  if (user_editable_value) {
    {
      auto temp = (*user_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_editable = absl::nullopt;
        return false;
      }
      out->user_editable = *temp;
    }
  }

  const base::Value* device_editable_value = dict.Find("DeviceEditable");
  if (device_editable_value) {
    {
      auto temp = (*device_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_editable = absl::nullopt;
        return false;
      }
      out->device_editable = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedBoolean> ManagedBoolean::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedBoolean>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedBoolean::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->active) {
    to_value_result.Set("Active", *this->active);

  }
  if (this->effective) {
    to_value_result.Set("Effective", *this->effective);

  }
  if (this->user_policy) {
    to_value_result.Set("UserPolicy", *this->user_policy);

  }
  if (this->device_policy) {
    to_value_result.Set("DevicePolicy", *this->device_policy);

  }
  if (this->user_setting) {
    to_value_result.Set("UserSetting", *this->user_setting);

  }
  if (this->shared_setting) {
    to_value_result.Set("SharedSetting", *this->shared_setting);

  }
  if (this->user_editable) {
    to_value_result.Set("UserEditable", *this->user_editable);

  }
  if (this->device_editable) {
    to_value_result.Set("DeviceEditable", *this->device_editable);

  }

  return to_value_result;
}


ManagedLong::ManagedLong()
 {}

ManagedLong::~ManagedLong() = default;
ManagedLong::ManagedLong(ManagedLong&& rhs) = default;
ManagedLong& ManagedLong::operator=(ManagedLong&& rhs) = default;
// static
bool ManagedLong::Populate(
    const base::Value& value, ManagedLong* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* active_value = dict.Find("Active");
  if (active_value) {
    {
      auto temp = (*active_value).GetIfInt();
      if (!temp.has_value()) {
        out->active = absl::nullopt;
        return false;
      }
      out->active = *temp;
    }
  }

  const base::Value* effective_value = dict.Find("Effective");
  if (effective_value) {
    {
      auto* temp = (*effective_value).GetIfString();
      if (!temp) {
        out->effective = absl::nullopt;
        return false;
      }
      out->effective = *temp;
    }
  }

  const base::Value* user_policy_value = dict.Find("UserPolicy");
  if (user_policy_value) {
    {
      auto temp = (*user_policy_value).GetIfInt();
      if (!temp.has_value()) {
        out->user_policy = absl::nullopt;
        return false;
      }
      out->user_policy = *temp;
    }
  }

  const base::Value* device_policy_value = dict.Find("DevicePolicy");
  if (device_policy_value) {
    {
      auto temp = (*device_policy_value).GetIfInt();
      if (!temp.has_value()) {
        out->device_policy = absl::nullopt;
        return false;
      }
      out->device_policy = *temp;
    }
  }

  const base::Value* user_setting_value = dict.Find("UserSetting");
  if (user_setting_value) {
    {
      auto temp = (*user_setting_value).GetIfInt();
      if (!temp.has_value()) {
        out->user_setting = absl::nullopt;
        return false;
      }
      out->user_setting = *temp;
    }
  }

  const base::Value* shared_setting_value = dict.Find("SharedSetting");
  if (shared_setting_value) {
    {
      auto temp = (*shared_setting_value).GetIfInt();
      if (!temp.has_value()) {
        out->shared_setting = absl::nullopt;
        return false;
      }
      out->shared_setting = *temp;
    }
  }

  const base::Value* user_editable_value = dict.Find("UserEditable");
  if (user_editable_value) {
    {
      auto temp = (*user_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_editable = absl::nullopt;
        return false;
      }
      out->user_editable = *temp;
    }
  }

  const base::Value* device_editable_value = dict.Find("DeviceEditable");
  if (device_editable_value) {
    {
      auto temp = (*device_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_editable = absl::nullopt;
        return false;
      }
      out->device_editable = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedLong> ManagedLong::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedLong>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedLong::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->active) {
    to_value_result.Set("Active", *this->active);

  }
  if (this->effective) {
    to_value_result.Set("Effective", *this->effective);

  }
  if (this->user_policy) {
    to_value_result.Set("UserPolicy", *this->user_policy);

  }
  if (this->device_policy) {
    to_value_result.Set("DevicePolicy", *this->device_policy);

  }
  if (this->user_setting) {
    to_value_result.Set("UserSetting", *this->user_setting);

  }
  if (this->shared_setting) {
    to_value_result.Set("SharedSetting", *this->shared_setting);

  }
  if (this->user_editable) {
    to_value_result.Set("UserEditable", *this->user_editable);

  }
  if (this->device_editable) {
    to_value_result.Set("DeviceEditable", *this->device_editable);

  }

  return to_value_result;
}


ManagedDOMString::ManagedDOMString()
 {}

ManagedDOMString::~ManagedDOMString() = default;
ManagedDOMString::ManagedDOMString(ManagedDOMString&& rhs) = default;
ManagedDOMString& ManagedDOMString::operator=(ManagedDOMString&& rhs) = default;
// static
bool ManagedDOMString::Populate(
    const base::Value& value, ManagedDOMString* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* active_value = dict.Find("Active");
  if (active_value) {
    {
      auto* temp = (*active_value).GetIfString();
      if (!temp) {
        out->active = absl::nullopt;
        return false;
      }
      out->active = *temp;
    }
  }

  const base::Value* effective_value = dict.Find("Effective");
  if (effective_value) {
    {
      auto* temp = (*effective_value).GetIfString();
      if (!temp) {
        out->effective = absl::nullopt;
        return false;
      }
      out->effective = *temp;
    }
  }

  const base::Value* user_policy_value = dict.Find("UserPolicy");
  if (user_policy_value) {
    {
      auto* temp = (*user_policy_value).GetIfString();
      if (!temp) {
        out->user_policy = absl::nullopt;
        return false;
      }
      out->user_policy = *temp;
    }
  }

  const base::Value* device_policy_value = dict.Find("DevicePolicy");
  if (device_policy_value) {
    {
      auto* temp = (*device_policy_value).GetIfString();
      if (!temp) {
        out->device_policy = absl::nullopt;
        return false;
      }
      out->device_policy = *temp;
    }
  }

  const base::Value* user_setting_value = dict.Find("UserSetting");
  if (user_setting_value) {
    {
      auto* temp = (*user_setting_value).GetIfString();
      if (!temp) {
        out->user_setting = absl::nullopt;
        return false;
      }
      out->user_setting = *temp;
    }
  }

  const base::Value* shared_setting_value = dict.Find("SharedSetting");
  if (shared_setting_value) {
    {
      auto* temp = (*shared_setting_value).GetIfString();
      if (!temp) {
        out->shared_setting = absl::nullopt;
        return false;
      }
      out->shared_setting = *temp;
    }
  }

  const base::Value* user_editable_value = dict.Find("UserEditable");
  if (user_editable_value) {
    {
      auto temp = (*user_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_editable = absl::nullopt;
        return false;
      }
      out->user_editable = *temp;
    }
  }

  const base::Value* device_editable_value = dict.Find("DeviceEditable");
  if (device_editable_value) {
    {
      auto temp = (*device_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_editable = absl::nullopt;
        return false;
      }
      out->device_editable = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedDOMString> ManagedDOMString::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedDOMString>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedDOMString::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->active) {
    to_value_result.Set("Active", *this->active);

  }
  if (this->effective) {
    to_value_result.Set("Effective", *this->effective);

  }
  if (this->user_policy) {
    to_value_result.Set("UserPolicy", *this->user_policy);

  }
  if (this->device_policy) {
    to_value_result.Set("DevicePolicy", *this->device_policy);

  }
  if (this->user_setting) {
    to_value_result.Set("UserSetting", *this->user_setting);

  }
  if (this->shared_setting) {
    to_value_result.Set("SharedSetting", *this->shared_setting);

  }
  if (this->user_editable) {
    to_value_result.Set("UserEditable", *this->user_editable);

  }
  if (this->device_editable) {
    to_value_result.Set("DeviceEditable", *this->device_editable);

  }

  return to_value_result;
}


ManagedDOMStringList::ManagedDOMStringList()
 {}

ManagedDOMStringList::~ManagedDOMStringList() = default;
ManagedDOMStringList::ManagedDOMStringList(ManagedDOMStringList&& rhs) = default;
ManagedDOMStringList& ManagedDOMStringList::operator=(ManagedDOMStringList&& rhs) = default;
// static
bool ManagedDOMStringList::Populate(
    const base::Value& value, ManagedDOMStringList* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* active_value = dict.Find("Active");
  if (active_value) {
    {
      if (!(*active_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*active_value).GetList(), &out->active)) {
          return false;
        }
      }
    }
  }

  const base::Value* effective_value = dict.Find("Effective");
  if (effective_value) {
    {
      auto* temp = (*effective_value).GetIfString();
      if (!temp) {
        out->effective = absl::nullopt;
        return false;
      }
      out->effective = *temp;
    }
  }

  const base::Value* user_policy_value = dict.Find("UserPolicy");
  if (user_policy_value) {
    {
      if (!(*user_policy_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*user_policy_value).GetList(), &out->user_policy)) {
          return false;
        }
      }
    }
  }

  const base::Value* device_policy_value = dict.Find("DevicePolicy");
  if (device_policy_value) {
    {
      if (!(*device_policy_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*device_policy_value).GetList(), &out->device_policy)) {
          return false;
        }
      }
    }
  }

  const base::Value* user_setting_value = dict.Find("UserSetting");
  if (user_setting_value) {
    {
      if (!(*user_setting_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*user_setting_value).GetList(), &out->user_setting)) {
          return false;
        }
      }
    }
  }

  const base::Value* shared_setting_value = dict.Find("SharedSetting");
  if (shared_setting_value) {
    {
      if (!(*shared_setting_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*shared_setting_value).GetList(), &out->shared_setting)) {
          return false;
        }
      }
    }
  }

  const base::Value* user_editable_value = dict.Find("UserEditable");
  if (user_editable_value) {
    {
      auto temp = (*user_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_editable = absl::nullopt;
        return false;
      }
      out->user_editable = *temp;
    }
  }

  const base::Value* device_editable_value = dict.Find("DeviceEditable");
  if (device_editable_value) {
    {
      auto temp = (*device_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_editable = absl::nullopt;
        return false;
      }
      out->device_editable = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedDOMStringList> ManagedDOMStringList::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedDOMStringList>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedDOMStringList::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->active) {
    to_value_result.Set("Active", json_schema_compiler::util::CreateValueFromArray(*this->active));

  }
  if (this->effective) {
    to_value_result.Set("Effective", *this->effective);

  }
  if (this->user_policy) {
    to_value_result.Set("UserPolicy", json_schema_compiler::util::CreateValueFromArray(*this->user_policy));

  }
  if (this->device_policy) {
    to_value_result.Set("DevicePolicy", json_schema_compiler::util::CreateValueFromArray(*this->device_policy));

  }
  if (this->user_setting) {
    to_value_result.Set("UserSetting", json_schema_compiler::util::CreateValueFromArray(*this->user_setting));

  }
  if (this->shared_setting) {
    to_value_result.Set("SharedSetting", json_schema_compiler::util::CreateValueFromArray(*this->shared_setting));

  }
  if (this->user_editable) {
    to_value_result.Set("UserEditable", *this->user_editable);

  }
  if (this->device_editable) {
    to_value_result.Set("DeviceEditable", *this->device_editable);

  }

  return to_value_result;
}


ManagedIPConfigType::ManagedIPConfigType()
: active(IP_CONFIG_TYPE_NONE),
user_policy(IP_CONFIG_TYPE_NONE),
device_policy(IP_CONFIG_TYPE_NONE),
user_setting(IP_CONFIG_TYPE_NONE),
shared_setting(IP_CONFIG_TYPE_NONE) {}

ManagedIPConfigType::~ManagedIPConfigType() = default;
ManagedIPConfigType::ManagedIPConfigType(ManagedIPConfigType&& rhs) = default;
ManagedIPConfigType& ManagedIPConfigType::operator=(ManagedIPConfigType&& rhs) = default;
// static
bool ManagedIPConfigType::Populate(
    const base::Value& value, ManagedIPConfigType* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->active = IP_CONFIG_TYPE_NONE;
  out->user_policy = IP_CONFIG_TYPE_NONE;
  out->device_policy = IP_CONFIG_TYPE_NONE;
  out->user_setting = IP_CONFIG_TYPE_NONE;
  out->shared_setting = IP_CONFIG_TYPE_NONE;
  const base::Value* active_value = dict.Find("Active");
  if (active_value) {
    {
      const std::string* ip_config_type_as_string = (*active_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->active = ParseIPConfigType(*ip_config_type_as_string);
      if (out->active == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->active = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* effective_value = dict.Find("Effective");
  if (effective_value) {
    {
      auto* temp = (*effective_value).GetIfString();
      if (!temp) {
        out->effective = absl::nullopt;
        return false;
      }
      out->effective = *temp;
    }
  }

  const base::Value* user_policy_value = dict.Find("UserPolicy");
  if (user_policy_value) {
    {
      const std::string* ip_config_type_as_string = (*user_policy_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->user_policy = ParseIPConfigType(*ip_config_type_as_string);
      if (out->user_policy == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->user_policy = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* device_policy_value = dict.Find("DevicePolicy");
  if (device_policy_value) {
    {
      const std::string* ip_config_type_as_string = (*device_policy_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->device_policy = ParseIPConfigType(*ip_config_type_as_string);
      if (out->device_policy == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->device_policy = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* user_setting_value = dict.Find("UserSetting");
  if (user_setting_value) {
    {
      const std::string* ip_config_type_as_string = (*user_setting_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->user_setting = ParseIPConfigType(*ip_config_type_as_string);
      if (out->user_setting == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->user_setting = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* shared_setting_value = dict.Find("SharedSetting");
  if (shared_setting_value) {
    {
      const std::string* ip_config_type_as_string = (*shared_setting_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->shared_setting = ParseIPConfigType(*ip_config_type_as_string);
      if (out->shared_setting == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->shared_setting = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* user_editable_value = dict.Find("UserEditable");
  if (user_editable_value) {
    {
      auto temp = (*user_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_editable = absl::nullopt;
        return false;
      }
      out->user_editable = *temp;
    }
  }

  const base::Value* device_editable_value = dict.Find("DeviceEditable");
  if (device_editable_value) {
    {
      auto temp = (*device_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_editable = absl::nullopt;
        return false;
      }
      out->device_editable = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedIPConfigType> ManagedIPConfigType::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedIPConfigType>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedIPConfigType::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->active != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("Active", networking_private::ToString(this->active));

  }
  if (this->effective) {
    to_value_result.Set("Effective", *this->effective);

  }
  if (this->user_policy != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("UserPolicy", networking_private::ToString(this->user_policy));

  }
  if (this->device_policy != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("DevicePolicy", networking_private::ToString(this->device_policy));

  }
  if (this->user_setting != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("UserSetting", networking_private::ToString(this->user_setting));

  }
  if (this->shared_setting != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("SharedSetting", networking_private::ToString(this->shared_setting));

  }
  if (this->user_editable) {
    to_value_result.Set("UserEditable", *this->user_editable);

  }
  if (this->device_editable) {
    to_value_result.Set("DeviceEditable", *this->device_editable);

  }

  return to_value_result;
}


ManagedProxySettingsType::ManagedProxySettingsType()
: active(PROXY_SETTINGS_TYPE_NONE),
user_policy(PROXY_SETTINGS_TYPE_NONE),
device_policy(PROXY_SETTINGS_TYPE_NONE),
user_setting(PROXY_SETTINGS_TYPE_NONE),
shared_setting(PROXY_SETTINGS_TYPE_NONE) {}

ManagedProxySettingsType::~ManagedProxySettingsType() = default;
ManagedProxySettingsType::ManagedProxySettingsType(ManagedProxySettingsType&& rhs) = default;
ManagedProxySettingsType& ManagedProxySettingsType::operator=(ManagedProxySettingsType&& rhs) = default;
// static
bool ManagedProxySettingsType::Populate(
    const base::Value& value, ManagedProxySettingsType* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->active = PROXY_SETTINGS_TYPE_NONE;
  out->user_policy = PROXY_SETTINGS_TYPE_NONE;
  out->device_policy = PROXY_SETTINGS_TYPE_NONE;
  out->user_setting = PROXY_SETTINGS_TYPE_NONE;
  out->shared_setting = PROXY_SETTINGS_TYPE_NONE;
  const base::Value* active_value = dict.Find("Active");
  if (active_value) {
    {
      const std::string* proxy_settings_type_as_string = (*active_value).GetIfString();
      if (!proxy_settings_type_as_string) {
        return false;
      }
      out->active = ParseProxySettingsType(*proxy_settings_type_as_string);
      if (out->active == PROXY_SETTINGS_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->active = PROXY_SETTINGS_TYPE_NONE;
  }

  const base::Value* effective_value = dict.Find("Effective");
  if (effective_value) {
    {
      auto* temp = (*effective_value).GetIfString();
      if (!temp) {
        out->effective = absl::nullopt;
        return false;
      }
      out->effective = *temp;
    }
  }

  const base::Value* user_policy_value = dict.Find("UserPolicy");
  if (user_policy_value) {
    {
      const std::string* proxy_settings_type_as_string = (*user_policy_value).GetIfString();
      if (!proxy_settings_type_as_string) {
        return false;
      }
      out->user_policy = ParseProxySettingsType(*proxy_settings_type_as_string);
      if (out->user_policy == PROXY_SETTINGS_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->user_policy = PROXY_SETTINGS_TYPE_NONE;
  }

  const base::Value* device_policy_value = dict.Find("DevicePolicy");
  if (device_policy_value) {
    {
      const std::string* proxy_settings_type_as_string = (*device_policy_value).GetIfString();
      if (!proxy_settings_type_as_string) {
        return false;
      }
      out->device_policy = ParseProxySettingsType(*proxy_settings_type_as_string);
      if (out->device_policy == PROXY_SETTINGS_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->device_policy = PROXY_SETTINGS_TYPE_NONE;
  }

  const base::Value* user_setting_value = dict.Find("UserSetting");
  if (user_setting_value) {
    {
      const std::string* proxy_settings_type_as_string = (*user_setting_value).GetIfString();
      if (!proxy_settings_type_as_string) {
        return false;
      }
      out->user_setting = ParseProxySettingsType(*proxy_settings_type_as_string);
      if (out->user_setting == PROXY_SETTINGS_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->user_setting = PROXY_SETTINGS_TYPE_NONE;
  }

  const base::Value* shared_setting_value = dict.Find("SharedSetting");
  if (shared_setting_value) {
    {
      const std::string* proxy_settings_type_as_string = (*shared_setting_value).GetIfString();
      if (!proxy_settings_type_as_string) {
        return false;
      }
      out->shared_setting = ParseProxySettingsType(*proxy_settings_type_as_string);
      if (out->shared_setting == PROXY_SETTINGS_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->shared_setting = PROXY_SETTINGS_TYPE_NONE;
  }

  const base::Value* user_editable_value = dict.Find("UserEditable");
  if (user_editable_value) {
    {
      auto temp = (*user_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_editable = absl::nullopt;
        return false;
      }
      out->user_editable = *temp;
    }
  }

  const base::Value* device_editable_value = dict.Find("DeviceEditable");
  if (device_editable_value) {
    {
      auto temp = (*device_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_editable = absl::nullopt;
        return false;
      }
      out->device_editable = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedProxySettingsType> ManagedProxySettingsType::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedProxySettingsType>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedProxySettingsType::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->active != PROXY_SETTINGS_TYPE_NONE) {
    to_value_result.Set("Active", networking_private::ToString(this->active));

  }
  if (this->effective) {
    to_value_result.Set("Effective", *this->effective);

  }
  if (this->user_policy != PROXY_SETTINGS_TYPE_NONE) {
    to_value_result.Set("UserPolicy", networking_private::ToString(this->user_policy));

  }
  if (this->device_policy != PROXY_SETTINGS_TYPE_NONE) {
    to_value_result.Set("DevicePolicy", networking_private::ToString(this->device_policy));

  }
  if (this->user_setting != PROXY_SETTINGS_TYPE_NONE) {
    to_value_result.Set("UserSetting", networking_private::ToString(this->user_setting));

  }
  if (this->shared_setting != PROXY_SETTINGS_TYPE_NONE) {
    to_value_result.Set("SharedSetting", networking_private::ToString(this->shared_setting));

  }
  if (this->user_editable) {
    to_value_result.Set("UserEditable", *this->user_editable);

  }
  if (this->device_editable) {
    to_value_result.Set("DeviceEditable", *this->device_editable);

  }

  return to_value_result;
}


APNProperties::APNProperties()
 {}

APNProperties::~APNProperties() = default;
APNProperties::APNProperties(APNProperties&& rhs) = default;
APNProperties& APNProperties::operator=(APNProperties&& rhs) = default;
// static
bool APNProperties::Populate(
    const base::Value& value, APNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* access_point_name_value = dict.Find("AccessPointName");
  if (!access_point_name_value) {
    return false;
  }
  {
    auto* temp = (*access_point_name_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->access_point_name = *temp;
  }

  const base::Value* authentication_value = dict.Find("Authentication");
  if (authentication_value) {
    {
      auto* temp = (*authentication_value).GetIfString();
      if (!temp) {
        out->authentication = absl::nullopt;
        return false;
      }
      out->authentication = *temp;
    }
  }

  const base::Value* language_value = dict.Find("Language");
  if (language_value) {
    {
      auto* temp = (*language_value).GetIfString();
      if (!temp) {
        out->language = absl::nullopt;
        return false;
      }
      out->language = *temp;
    }
  }

  const base::Value* localized_name_value = dict.Find("LocalizedName");
  if (localized_name_value) {
    {
      auto* temp = (*localized_name_value).GetIfString();
      if (!temp) {
        out->localized_name = absl::nullopt;
        return false;
      }
      out->localized_name = *temp;
    }
  }

  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      auto* temp = (*name_value).GetIfString();
      if (!temp) {
        out->name = absl::nullopt;
        return false;
      }
      out->name = *temp;
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      auto* temp = (*password_value).GetIfString();
      if (!temp) {
        out->password = absl::nullopt;
        return false;
      }
      out->password = *temp;
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      auto* temp = (*username_value).GetIfString();
      if (!temp) {
        out->username = absl::nullopt;
        return false;
      }
      out->username = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<APNProperties> APNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<APNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict APNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("AccessPointName", this->access_point_name);

  if (this->authentication) {
    to_value_result.Set("Authentication", *this->authentication);

  }
  if (this->language) {
    to_value_result.Set("Language", *this->language);

  }
  if (this->localized_name) {
    to_value_result.Set("LocalizedName", *this->localized_name);

  }
  if (this->name) {
    to_value_result.Set("Name", *this->name);

  }
  if (this->password) {
    to_value_result.Set("Password", *this->password);

  }
  if (this->username) {
    to_value_result.Set("Username", *this->username);

  }

  return to_value_result;
}


ManagedAPNProperties::ManagedAPNProperties()
 {}

ManagedAPNProperties::~ManagedAPNProperties() = default;
ManagedAPNProperties::ManagedAPNProperties(ManagedAPNProperties&& rhs) = default;
ManagedAPNProperties& ManagedAPNProperties::operator=(ManagedAPNProperties&& rhs) = default;
// static
bool ManagedAPNProperties::Populate(
    const base::Value& value, ManagedAPNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* access_point_name_value = dict.Find("AccessPointName");
  if (!access_point_name_value) {
    return false;
  }
  {
    if (!(*access_point_name_value).is_dict()) {
      return false;
    }
    if (!ManagedDOMString::Populate((*access_point_name_value), &out->access_point_name)) {
      return false;
    }
  }

  const base::Value* authentication_value = dict.Find("Authentication");
  if (authentication_value) {
    {
      if (!(*authentication_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*authentication_value), &temp))
          return false;
        out->authentication = std::move(temp);
      }
    }
  }

  const base::Value* language_value = dict.Find("Language");
  if (language_value) {
    {
      if (!(*language_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*language_value), &temp))
          return false;
        out->language = std::move(temp);
      }
    }
  }

  const base::Value* localized_name_value = dict.Find("LocalizedName");
  if (localized_name_value) {
    {
      if (!(*localized_name_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*localized_name_value), &temp))
          return false;
        out->localized_name = std::move(temp);
      }
    }
  }

  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      if (!(*name_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*name_value), &temp))
          return false;
        out->name = std::move(temp);
      }
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      if (!(*password_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*password_value), &temp))
          return false;
        out->password = std::move(temp);
      }
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      if (!(*username_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*username_value), &temp))
          return false;
        out->username = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedAPNProperties> ManagedAPNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedAPNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedAPNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("AccessPointName", (this->access_point_name).ToValue());

  if (this->authentication) {
    to_value_result.Set("Authentication", (this->authentication)->ToValue());

  }
  if (this->language) {
    to_value_result.Set("Language", (this->language)->ToValue());

  }
  if (this->localized_name) {
    to_value_result.Set("LocalizedName", (this->localized_name)->ToValue());

  }
  if (this->name) {
    to_value_result.Set("Name", (this->name)->ToValue());

  }
  if (this->password) {
    to_value_result.Set("Password", (this->password)->ToValue());

  }
  if (this->username) {
    to_value_result.Set("Username", (this->username)->ToValue());

  }

  return to_value_result;
}


ManagedAPNList::ManagedAPNList()
 {}

ManagedAPNList::~ManagedAPNList() = default;
ManagedAPNList::ManagedAPNList(ManagedAPNList&& rhs) = default;
ManagedAPNList& ManagedAPNList::operator=(ManagedAPNList&& rhs) = default;
// static
bool ManagedAPNList::Populate(
    const base::Value& value, ManagedAPNList* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* active_value = dict.Find("Active");
  if (active_value) {
    {
      if (!(*active_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*active_value).GetList(), &out->active)) {
          return false;
        }
      }
    }
  }

  const base::Value* effective_value = dict.Find("Effective");
  if (effective_value) {
    {
      auto* temp = (*effective_value).GetIfString();
      if (!temp) {
        out->effective = absl::nullopt;
        return false;
      }
      out->effective = *temp;
    }
  }

  const base::Value* user_policy_value = dict.Find("UserPolicy");
  if (user_policy_value) {
    {
      if (!(*user_policy_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*user_policy_value).GetList(), &out->user_policy)) {
          return false;
        }
      }
    }
  }

  const base::Value* device_policy_value = dict.Find("DevicePolicy");
  if (device_policy_value) {
    {
      if (!(*device_policy_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*device_policy_value).GetList(), &out->device_policy)) {
          return false;
        }
      }
    }
  }

  const base::Value* user_setting_value = dict.Find("UserSetting");
  if (user_setting_value) {
    {
      if (!(*user_setting_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*user_setting_value).GetList(), &out->user_setting)) {
          return false;
        }
      }
    }
  }

  const base::Value* shared_setting_value = dict.Find("SharedSetting");
  if (shared_setting_value) {
    {
      if (!(*shared_setting_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*shared_setting_value).GetList(), &out->shared_setting)) {
          return false;
        }
      }
    }
  }

  const base::Value* user_editable_value = dict.Find("UserEditable");
  if (user_editable_value) {
    {
      auto temp = (*user_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->user_editable = absl::nullopt;
        return false;
      }
      out->user_editable = *temp;
    }
  }

  const base::Value* device_editable_value = dict.Find("DeviceEditable");
  if (device_editable_value) {
    {
      auto temp = (*device_editable_value).GetIfBool();
      if (!temp.has_value()) {
        out->device_editable = absl::nullopt;
        return false;
      }
      out->device_editable = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedAPNList> ManagedAPNList::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedAPNList>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedAPNList::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->active) {
    to_value_result.Set("Active", json_schema_compiler::util::CreateValueFromArray(*this->active));

  }
  if (this->effective) {
    to_value_result.Set("Effective", *this->effective);

  }
  if (this->user_policy) {
    to_value_result.Set("UserPolicy", json_schema_compiler::util::CreateValueFromArray(*this->user_policy));

  }
  if (this->device_policy) {
    to_value_result.Set("DevicePolicy", json_schema_compiler::util::CreateValueFromArray(*this->device_policy));

  }
  if (this->user_setting) {
    to_value_result.Set("UserSetting", json_schema_compiler::util::CreateValueFromArray(*this->user_setting));

  }
  if (this->shared_setting) {
    to_value_result.Set("SharedSetting", json_schema_compiler::util::CreateValueFromArray(*this->shared_setting));

  }
  if (this->user_editable) {
    to_value_result.Set("UserEditable", *this->user_editable);

  }
  if (this->device_editable) {
    to_value_result.Set("DeviceEditable", *this->device_editable);

  }

  return to_value_result;
}


CellularProviderProperties::CellularProviderProperties()
 {}

CellularProviderProperties::~CellularProviderProperties() = default;
CellularProviderProperties::CellularProviderProperties(CellularProviderProperties&& rhs) = default;
CellularProviderProperties& CellularProviderProperties::operator=(CellularProviderProperties&& rhs) = default;
// static
bool CellularProviderProperties::Populate(
    const base::Value& value, CellularProviderProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* name_value = dict.Find("Name");
  if (!name_value) {
    return false;
  }
  {
    auto* temp = (*name_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->name = *temp;
  }

  const base::Value* code_value = dict.Find("Code");
  if (!code_value) {
    return false;
  }
  {
    auto* temp = (*code_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->code = *temp;
  }

  const base::Value* country_value = dict.Find("Country");
  if (country_value) {
    {
      auto* temp = (*country_value).GetIfString();
      if (!temp) {
        out->country = absl::nullopt;
        return false;
      }
      out->country = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<CellularProviderProperties> CellularProviderProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<CellularProviderProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict CellularProviderProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Name", this->name);

  to_value_result.Set("Code", this->code);

  if (this->country) {
    to_value_result.Set("Country", *this->country);

  }

  return to_value_result;
}


CellularSimState::CellularSimState()
: require_pin(false) {}

CellularSimState::~CellularSimState() = default;
CellularSimState::CellularSimState(CellularSimState&& rhs) = default;
CellularSimState& CellularSimState::operator=(CellularSimState&& rhs) = default;
// static
bool CellularSimState::Populate(
    const base::Value& value, CellularSimState* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* require_pin_value = dict.Find("requirePin");
  if (!require_pin_value) {
    return false;
  }
  {
    auto temp = (*require_pin_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->require_pin = *temp;
  }

  const base::Value* current_pin_value = dict.Find("currentPin");
  if (!current_pin_value) {
    return false;
  }
  {
    auto* temp = (*current_pin_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->current_pin = *temp;
  }

  const base::Value* new_pin_value = dict.Find("newPin");
  if (new_pin_value) {
    {
      auto* temp = (*new_pin_value).GetIfString();
      if (!temp) {
        out->new_pin = absl::nullopt;
        return false;
      }
      out->new_pin = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<CellularSimState> CellularSimState::FromValue(const base::Value& value) {
  auto out = std::make_unique<CellularSimState>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict CellularSimState::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("requirePin", this->require_pin);

  to_value_result.Set("currentPin", this->current_pin);

  if (this->new_pin) {
    to_value_result.Set("newPin", *this->new_pin);

  }

  return to_value_result;
}


IssuerSubjectPattern::IssuerSubjectPattern()
 {}

IssuerSubjectPattern::~IssuerSubjectPattern() = default;
IssuerSubjectPattern::IssuerSubjectPattern(IssuerSubjectPattern&& rhs) = default;
IssuerSubjectPattern& IssuerSubjectPattern::operator=(IssuerSubjectPattern&& rhs) = default;
// static
bool IssuerSubjectPattern::Populate(
    const base::Value& value, IssuerSubjectPattern* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* common_name_value = dict.Find("CommonName");
  if (common_name_value) {
    {
      auto* temp = (*common_name_value).GetIfString();
      if (!temp) {
        out->common_name = absl::nullopt;
        return false;
      }
      out->common_name = *temp;
    }
  }

  const base::Value* locality_value = dict.Find("Locality");
  if (locality_value) {
    {
      auto* temp = (*locality_value).GetIfString();
      if (!temp) {
        out->locality = absl::nullopt;
        return false;
      }
      out->locality = *temp;
    }
  }

  const base::Value* organization_value = dict.Find("Organization");
  if (organization_value) {
    {
      auto* temp = (*organization_value).GetIfString();
      if (!temp) {
        out->organization = absl::nullopt;
        return false;
      }
      out->organization = *temp;
    }
  }

  const base::Value* organizational_unit_value = dict.Find("OrganizationalUnit");
  if (organizational_unit_value) {
    {
      auto* temp = (*organizational_unit_value).GetIfString();
      if (!temp) {
        out->organizational_unit = absl::nullopt;
        return false;
      }
      out->organizational_unit = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<IssuerSubjectPattern> IssuerSubjectPattern::FromValue(const base::Value& value) {
  auto out = std::make_unique<IssuerSubjectPattern>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict IssuerSubjectPattern::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->common_name) {
    to_value_result.Set("CommonName", *this->common_name);

  }
  if (this->locality) {
    to_value_result.Set("Locality", *this->locality);

  }
  if (this->organization) {
    to_value_result.Set("Organization", *this->organization);

  }
  if (this->organizational_unit) {
    to_value_result.Set("OrganizationalUnit", *this->organizational_unit);

  }

  return to_value_result;
}


ManagedIssuerSubjectPattern::ManagedIssuerSubjectPattern()
 {}

ManagedIssuerSubjectPattern::~ManagedIssuerSubjectPattern() = default;
ManagedIssuerSubjectPattern::ManagedIssuerSubjectPattern(ManagedIssuerSubjectPattern&& rhs) = default;
ManagedIssuerSubjectPattern& ManagedIssuerSubjectPattern::operator=(ManagedIssuerSubjectPattern&& rhs) = default;
// static
bool ManagedIssuerSubjectPattern::Populate(
    const base::Value& value, ManagedIssuerSubjectPattern* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* common_name_value = dict.Find("CommonName");
  if (common_name_value) {
    {
      if (!(*common_name_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*common_name_value), &temp))
          return false;
        out->common_name = std::move(temp);
      }
    }
  }

  const base::Value* locality_value = dict.Find("Locality");
  if (locality_value) {
    {
      if (!(*locality_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*locality_value), &temp))
          return false;
        out->locality = std::move(temp);
      }
    }
  }

  const base::Value* organization_value = dict.Find("Organization");
  if (organization_value) {
    {
      if (!(*organization_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*organization_value), &temp))
          return false;
        out->organization = std::move(temp);
      }
    }
  }

  const base::Value* organizational_unit_value = dict.Find("OrganizationalUnit");
  if (organizational_unit_value) {
    {
      if (!(*organizational_unit_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*organizational_unit_value), &temp))
          return false;
        out->organizational_unit = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedIssuerSubjectPattern> ManagedIssuerSubjectPattern::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedIssuerSubjectPattern>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedIssuerSubjectPattern::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->common_name) {
    to_value_result.Set("CommonName", (this->common_name)->ToValue());

  }
  if (this->locality) {
    to_value_result.Set("Locality", (this->locality)->ToValue());

  }
  if (this->organization) {
    to_value_result.Set("Organization", (this->organization)->ToValue());

  }
  if (this->organizational_unit) {
    to_value_result.Set("OrganizationalUnit", (this->organizational_unit)->ToValue());

  }

  return to_value_result;
}


CertificatePattern::CertificatePattern()
 {}

CertificatePattern::~CertificatePattern() = default;
CertificatePattern::CertificatePattern(CertificatePattern&& rhs) = default;
CertificatePattern& CertificatePattern::operator=(CertificatePattern&& rhs) = default;
// static
bool CertificatePattern::Populate(
    const base::Value& value, CertificatePattern* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* enrollment_uri_value = dict.Find("EnrollmentURI");
  if (enrollment_uri_value) {
    {
      if (!(*enrollment_uri_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*enrollment_uri_value).GetList(), &out->enrollment_uri)) {
          return false;
        }
      }
    }
  }

  const base::Value* issuer_value = dict.Find("Issuer");
  if (issuer_value) {
    {
      if (!(*issuer_value).is_dict()) {
        return false;
      }
      else {
        IssuerSubjectPattern temp;
        if (!IssuerSubjectPattern::Populate((*issuer_value), &temp))
          return false;
        out->issuer = std::move(temp);
      }
    }
  }

  const base::Value* issuer_cape_ms_value = dict.Find("IssuerCAPEMs");
  if (issuer_cape_ms_value) {
    {
      if (!(*issuer_cape_ms_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*issuer_cape_ms_value).GetList(), &out->issuer_cape_ms)) {
          return false;
        }
      }
    }
  }

  const base::Value* issuer_ca_ref_value = dict.Find("IssuerCARef");
  if (issuer_ca_ref_value) {
    {
      if (!(*issuer_ca_ref_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*issuer_ca_ref_value).GetList(), &out->issuer_ca_ref)) {
          return false;
        }
      }
    }
  }

  const base::Value* subject_value = dict.Find("Subject");
  if (subject_value) {
    {
      if (!(*subject_value).is_dict()) {
        return false;
      }
      else {
        IssuerSubjectPattern temp;
        if (!IssuerSubjectPattern::Populate((*subject_value), &temp))
          return false;
        out->subject = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<CertificatePattern> CertificatePattern::FromValue(const base::Value& value) {
  auto out = std::make_unique<CertificatePattern>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict CertificatePattern::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->enrollment_uri) {
    to_value_result.Set("EnrollmentURI", json_schema_compiler::util::CreateValueFromArray(*this->enrollment_uri));

  }
  if (this->issuer) {
    to_value_result.Set("Issuer", (this->issuer)->ToValue());

  }
  if (this->issuer_cape_ms) {
    to_value_result.Set("IssuerCAPEMs", json_schema_compiler::util::CreateValueFromArray(*this->issuer_cape_ms));

  }
  if (this->issuer_ca_ref) {
    to_value_result.Set("IssuerCARef", json_schema_compiler::util::CreateValueFromArray(*this->issuer_ca_ref));

  }
  if (this->subject) {
    to_value_result.Set("Subject", (this->subject)->ToValue());

  }

  return to_value_result;
}


ManagedCertificatePattern::ManagedCertificatePattern()
 {}

ManagedCertificatePattern::~ManagedCertificatePattern() = default;
ManagedCertificatePattern::ManagedCertificatePattern(ManagedCertificatePattern&& rhs) = default;
ManagedCertificatePattern& ManagedCertificatePattern::operator=(ManagedCertificatePattern&& rhs) = default;
// static
bool ManagedCertificatePattern::Populate(
    const base::Value& value, ManagedCertificatePattern* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* enrollment_uri_value = dict.Find("EnrollmentURI");
  if (enrollment_uri_value) {
    {
      if (!(*enrollment_uri_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*enrollment_uri_value), &temp))
          return false;
        out->enrollment_uri = std::move(temp);
      }
    }
  }

  const base::Value* issuer_value = dict.Find("Issuer");
  if (issuer_value) {
    {
      if (!(*issuer_value).is_dict()) {
        return false;
      }
      else {
        ManagedIssuerSubjectPattern temp;
        if (!ManagedIssuerSubjectPattern::Populate((*issuer_value), &temp))
          return false;
        out->issuer = std::move(temp);
      }
    }
  }

  const base::Value* issuer_ca_ref_value = dict.Find("IssuerCARef");
  if (issuer_ca_ref_value) {
    {
      if (!(*issuer_ca_ref_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*issuer_ca_ref_value), &temp))
          return false;
        out->issuer_ca_ref = std::move(temp);
      }
    }
  }

  const base::Value* subject_value = dict.Find("Subject");
  if (subject_value) {
    {
      if (!(*subject_value).is_dict()) {
        return false;
      }
      else {
        ManagedIssuerSubjectPattern temp;
        if (!ManagedIssuerSubjectPattern::Populate((*subject_value), &temp))
          return false;
        out->subject = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedCertificatePattern> ManagedCertificatePattern::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedCertificatePattern>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedCertificatePattern::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->enrollment_uri) {
    to_value_result.Set("EnrollmentURI", (this->enrollment_uri)->ToValue());

  }
  if (this->issuer) {
    to_value_result.Set("Issuer", (this->issuer)->ToValue());

  }
  if (this->issuer_ca_ref) {
    to_value_result.Set("IssuerCARef", (this->issuer_ca_ref)->ToValue());

  }
  if (this->subject) {
    to_value_result.Set("Subject", (this->subject)->ToValue());

  }

  return to_value_result;
}


EAPProperties::EAPProperties()
 {}

EAPProperties::~EAPProperties() = default;
EAPProperties::EAPProperties(EAPProperties&& rhs) = default;
EAPProperties& EAPProperties::operator=(EAPProperties&& rhs) = default;
// static
bool EAPProperties::Populate(
    const base::Value& value, EAPProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* anonymous_identity_value = dict.Find("AnonymousIdentity");
  if (anonymous_identity_value) {
    {
      auto* temp = (*anonymous_identity_value).GetIfString();
      if (!temp) {
        out->anonymous_identity = absl::nullopt;
        return false;
      }
      out->anonymous_identity = *temp;
    }
  }

  const base::Value* client_cert_pattern_value = dict.Find("ClientCertPattern");
  if (client_cert_pattern_value) {
    {
      if (!(*client_cert_pattern_value).is_dict()) {
        return false;
      }
      else {
        CertificatePattern temp;
        if (!CertificatePattern::Populate((*client_cert_pattern_value), &temp))
          return false;
        out->client_cert_pattern = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_pkcs11_id_value = dict.Find("ClientCertPKCS11Id");
  if (client_cert_pkcs11_id_value) {
    {
      auto* temp = (*client_cert_pkcs11_id_value).GetIfString();
      if (!temp) {
        out->client_cert_pkcs11_id = absl::nullopt;
        return false;
      }
      out->client_cert_pkcs11_id = *temp;
    }
  }

  const base::Value* client_cert_provisioning_profile_id_value = dict.Find("ClientCertProvisioningProfileId");
  if (client_cert_provisioning_profile_id_value) {
    {
      auto* temp = (*client_cert_provisioning_profile_id_value).GetIfString();
      if (!temp) {
        out->client_cert_provisioning_profile_id = absl::nullopt;
        return false;
      }
      out->client_cert_provisioning_profile_id = *temp;
    }
  }

  const base::Value* client_cert_ref_value = dict.Find("ClientCertRef");
  if (client_cert_ref_value) {
    {
      auto* temp = (*client_cert_ref_value).GetIfString();
      if (!temp) {
        out->client_cert_ref = absl::nullopt;
        return false;
      }
      out->client_cert_ref = *temp;
    }
  }

  const base::Value* client_cert_type_value = dict.Find("ClientCertType");
  if (client_cert_type_value) {
    {
      auto* temp = (*client_cert_type_value).GetIfString();
      if (!temp) {
        out->client_cert_type = absl::nullopt;
        return false;
      }
      out->client_cert_type = *temp;
    }
  }

  const base::Value* identity_value = dict.Find("Identity");
  if (identity_value) {
    {
      auto* temp = (*identity_value).GetIfString();
      if (!temp) {
        out->identity = absl::nullopt;
        return false;
      }
      out->identity = *temp;
    }
  }

  const base::Value* inner_value = dict.Find("Inner");
  if (inner_value) {
    {
      auto* temp = (*inner_value).GetIfString();
      if (!temp) {
        out->inner = absl::nullopt;
        return false;
      }
      out->inner = *temp;
    }
  }

  const base::Value* outer_value = dict.Find("Outer");
  if (outer_value) {
    {
      auto* temp = (*outer_value).GetIfString();
      if (!temp) {
        out->outer = absl::nullopt;
        return false;
      }
      out->outer = *temp;
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      auto* temp = (*password_value).GetIfString();
      if (!temp) {
        out->password = absl::nullopt;
        return false;
      }
      out->password = *temp;
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      auto temp = (*save_credentials_value).GetIfBool();
      if (!temp.has_value()) {
        out->save_credentials = absl::nullopt;
        return false;
      }
      out->save_credentials = *temp;
    }
  }

  const base::Value* server_cape_ms_value = dict.Find("ServerCAPEMs");
  if (server_cape_ms_value) {
    {
      if (!(*server_cape_ms_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*server_cape_ms_value).GetList(), &out->server_cape_ms)) {
          return false;
        }
      }
    }
  }

  const base::Value* server_ca_refs_value = dict.Find("ServerCARefs");
  if (server_ca_refs_value) {
    {
      if (!(*server_ca_refs_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*server_ca_refs_value).GetList(), &out->server_ca_refs)) {
          return false;
        }
      }
    }
  }

  const base::Value* subject_match_value = dict.Find("SubjectMatch");
  if (subject_match_value) {
    {
      auto* temp = (*subject_match_value).GetIfString();
      if (!temp) {
        out->subject_match = absl::nullopt;
        return false;
      }
      out->subject_match = *temp;
    }
  }

  const base::Value* tls_version_max_value = dict.Find("TLSVersionMax");
  if (tls_version_max_value) {
    {
      auto* temp = (*tls_version_max_value).GetIfString();
      if (!temp) {
        out->tls_version_max = absl::nullopt;
        return false;
      }
      out->tls_version_max = *temp;
    }
  }

  const base::Value* use_proactive_key_caching_value = dict.Find("UseProactiveKeyCaching");
  if (use_proactive_key_caching_value) {
    {
      auto temp = (*use_proactive_key_caching_value).GetIfBool();
      if (!temp.has_value()) {
        out->use_proactive_key_caching = absl::nullopt;
        return false;
      }
      out->use_proactive_key_caching = *temp;
    }
  }

  const base::Value* use_system_c_as_value = dict.Find("UseSystemCAs");
  if (use_system_c_as_value) {
    {
      auto temp = (*use_system_c_as_value).GetIfBool();
      if (!temp.has_value()) {
        out->use_system_c_as = absl::nullopt;
        return false;
      }
      out->use_system_c_as = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<EAPProperties> EAPProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<EAPProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict EAPProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->anonymous_identity) {
    to_value_result.Set("AnonymousIdentity", *this->anonymous_identity);

  }
  if (this->client_cert_pattern) {
    to_value_result.Set("ClientCertPattern", (this->client_cert_pattern)->ToValue());

  }
  if (this->client_cert_pkcs11_id) {
    to_value_result.Set("ClientCertPKCS11Id", *this->client_cert_pkcs11_id);

  }
  if (this->client_cert_provisioning_profile_id) {
    to_value_result.Set("ClientCertProvisioningProfileId", *this->client_cert_provisioning_profile_id);

  }
  if (this->client_cert_ref) {
    to_value_result.Set("ClientCertRef", *this->client_cert_ref);

  }
  if (this->client_cert_type) {
    to_value_result.Set("ClientCertType", *this->client_cert_type);

  }
  if (this->identity) {
    to_value_result.Set("Identity", *this->identity);

  }
  if (this->inner) {
    to_value_result.Set("Inner", *this->inner);

  }
  if (this->outer) {
    to_value_result.Set("Outer", *this->outer);

  }
  if (this->password) {
    to_value_result.Set("Password", *this->password);

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", *this->save_credentials);

  }
  if (this->server_cape_ms) {
    to_value_result.Set("ServerCAPEMs", json_schema_compiler::util::CreateValueFromArray(*this->server_cape_ms));

  }
  if (this->server_ca_refs) {
    to_value_result.Set("ServerCARefs", json_schema_compiler::util::CreateValueFromArray(*this->server_ca_refs));

  }
  if (this->subject_match) {
    to_value_result.Set("SubjectMatch", *this->subject_match);

  }
  if (this->tls_version_max) {
    to_value_result.Set("TLSVersionMax", *this->tls_version_max);

  }
  if (this->use_proactive_key_caching) {
    to_value_result.Set("UseProactiveKeyCaching", *this->use_proactive_key_caching);

  }
  if (this->use_system_c_as) {
    to_value_result.Set("UseSystemCAs", *this->use_system_c_as);

  }

  return to_value_result;
}


ManagedEAPProperties::ManagedEAPProperties()
 {}

ManagedEAPProperties::~ManagedEAPProperties() = default;
ManagedEAPProperties::ManagedEAPProperties(ManagedEAPProperties&& rhs) = default;
ManagedEAPProperties& ManagedEAPProperties::operator=(ManagedEAPProperties&& rhs) = default;
// static
bool ManagedEAPProperties::Populate(
    const base::Value& value, ManagedEAPProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* anonymous_identity_value = dict.Find("AnonymousIdentity");
  if (anonymous_identity_value) {
    {
      if (!(*anonymous_identity_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*anonymous_identity_value), &temp))
          return false;
        out->anonymous_identity = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_pattern_value = dict.Find("ClientCertPattern");
  if (client_cert_pattern_value) {
    {
      if (!(*client_cert_pattern_value).is_dict()) {
        return false;
      }
      else {
        ManagedCertificatePattern temp;
        if (!ManagedCertificatePattern::Populate((*client_cert_pattern_value), &temp))
          return false;
        out->client_cert_pattern = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_pkcs11_id_value = dict.Find("ClientCertPKCS11Id");
  if (client_cert_pkcs11_id_value) {
    {
      if (!(*client_cert_pkcs11_id_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_pkcs11_id_value), &temp))
          return false;
        out->client_cert_pkcs11_id = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_provisioning_profile_id_value = dict.Find("ClientCertProvisioningProfileId");
  if (client_cert_provisioning_profile_id_value) {
    {
      if (!(*client_cert_provisioning_profile_id_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_provisioning_profile_id_value), &temp))
          return false;
        out->client_cert_provisioning_profile_id = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_ref_value = dict.Find("ClientCertRef");
  if (client_cert_ref_value) {
    {
      if (!(*client_cert_ref_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_ref_value), &temp))
          return false;
        out->client_cert_ref = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_type_value = dict.Find("ClientCertType");
  if (client_cert_type_value) {
    {
      if (!(*client_cert_type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_type_value), &temp))
          return false;
        out->client_cert_type = std::move(temp);
      }
    }
  }

  const base::Value* identity_value = dict.Find("Identity");
  if (identity_value) {
    {
      if (!(*identity_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*identity_value), &temp))
          return false;
        out->identity = std::move(temp);
      }
    }
  }

  const base::Value* inner_value = dict.Find("Inner");
  if (inner_value) {
    {
      if (!(*inner_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*inner_value), &temp))
          return false;
        out->inner = std::move(temp);
      }
    }
  }

  const base::Value* outer_value = dict.Find("Outer");
  if (outer_value) {
    {
      if (!(*outer_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*outer_value), &temp))
          return false;
        out->outer = std::move(temp);
      }
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      if (!(*password_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*password_value), &temp))
          return false;
        out->password = std::move(temp);
      }
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      if (!(*save_credentials_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*save_credentials_value), &temp))
          return false;
        out->save_credentials = std::move(temp);
      }
    }
  }

  const base::Value* server_cape_ms_value = dict.Find("ServerCAPEMs");
  if (server_cape_ms_value) {
    {
      if (!(*server_cape_ms_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*server_cape_ms_value), &temp))
          return false;
        out->server_cape_ms = std::move(temp);
      }
    }
  }

  const base::Value* server_ca_refs_value = dict.Find("ServerCARefs");
  if (server_ca_refs_value) {
    {
      if (!(*server_ca_refs_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*server_ca_refs_value), &temp))
          return false;
        out->server_ca_refs = std::move(temp);
      }
    }
  }

  const base::Value* subject_match_value = dict.Find("SubjectMatch");
  if (subject_match_value) {
    {
      if (!(*subject_match_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*subject_match_value), &temp))
          return false;
        out->subject_match = std::move(temp);
      }
    }
  }

  const base::Value* tls_version_max_value = dict.Find("TLSVersionMax");
  if (tls_version_max_value) {
    {
      if (!(*tls_version_max_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*tls_version_max_value), &temp))
          return false;
        out->tls_version_max = std::move(temp);
      }
    }
  }

  const base::Value* use_proactive_key_caching_value = dict.Find("UseProactiveKeyCaching");
  if (use_proactive_key_caching_value) {
    {
      if (!(*use_proactive_key_caching_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*use_proactive_key_caching_value), &temp))
          return false;
        out->use_proactive_key_caching = std::move(temp);
      }
    }
  }

  const base::Value* use_system_c_as_value = dict.Find("UseSystemCAs");
  if (use_system_c_as_value) {
    {
      if (!(*use_system_c_as_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*use_system_c_as_value), &temp))
          return false;
        out->use_system_c_as = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedEAPProperties> ManagedEAPProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedEAPProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedEAPProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->anonymous_identity) {
    to_value_result.Set("AnonymousIdentity", (this->anonymous_identity)->ToValue());

  }
  if (this->client_cert_pattern) {
    to_value_result.Set("ClientCertPattern", (this->client_cert_pattern)->ToValue());

  }
  if (this->client_cert_pkcs11_id) {
    to_value_result.Set("ClientCertPKCS11Id", (this->client_cert_pkcs11_id)->ToValue());

  }
  if (this->client_cert_provisioning_profile_id) {
    to_value_result.Set("ClientCertProvisioningProfileId", (this->client_cert_provisioning_profile_id)->ToValue());

  }
  if (this->client_cert_ref) {
    to_value_result.Set("ClientCertRef", (this->client_cert_ref)->ToValue());

  }
  if (this->client_cert_type) {
    to_value_result.Set("ClientCertType", (this->client_cert_type)->ToValue());

  }
  if (this->identity) {
    to_value_result.Set("Identity", (this->identity)->ToValue());

  }
  if (this->inner) {
    to_value_result.Set("Inner", (this->inner)->ToValue());

  }
  if (this->outer) {
    to_value_result.Set("Outer", (this->outer)->ToValue());

  }
  if (this->password) {
    to_value_result.Set("Password", (this->password)->ToValue());

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", (this->save_credentials)->ToValue());

  }
  if (this->server_cape_ms) {
    to_value_result.Set("ServerCAPEMs", (this->server_cape_ms)->ToValue());

  }
  if (this->server_ca_refs) {
    to_value_result.Set("ServerCARefs", (this->server_ca_refs)->ToValue());

  }
  if (this->subject_match) {
    to_value_result.Set("SubjectMatch", (this->subject_match)->ToValue());

  }
  if (this->tls_version_max) {
    to_value_result.Set("TLSVersionMax", (this->tls_version_max)->ToValue());

  }
  if (this->use_proactive_key_caching) {
    to_value_result.Set("UseProactiveKeyCaching", (this->use_proactive_key_caching)->ToValue());

  }
  if (this->use_system_c_as) {
    to_value_result.Set("UseSystemCAs", (this->use_system_c_as)->ToValue());

  }

  return to_value_result;
}


FoundNetworkProperties::FoundNetworkProperties()
 {}

FoundNetworkProperties::~FoundNetworkProperties() = default;
FoundNetworkProperties::FoundNetworkProperties(FoundNetworkProperties&& rhs) = default;
FoundNetworkProperties& FoundNetworkProperties::operator=(FoundNetworkProperties&& rhs) = default;
// static
bool FoundNetworkProperties::Populate(
    const base::Value& value, FoundNetworkProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* status_value = dict.Find("Status");
  if (!status_value) {
    return false;
  }
  {
    auto* temp = (*status_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->status = *temp;
  }

  const base::Value* network_id_value = dict.Find("NetworkId");
  if (!network_id_value) {
    return false;
  }
  {
    auto* temp = (*network_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->network_id = *temp;
  }

  const base::Value* technology_value = dict.Find("Technology");
  if (!technology_value) {
    return false;
  }
  {
    auto* temp = (*technology_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->technology = *temp;
  }

  const base::Value* short_name_value = dict.Find("ShortName");
  if (short_name_value) {
    {
      auto* temp = (*short_name_value).GetIfString();
      if (!temp) {
        out->short_name = absl::nullopt;
        return false;
      }
      out->short_name = *temp;
    }
  }

  const base::Value* long_name_value = dict.Find("LongName");
  if (long_name_value) {
    {
      auto* temp = (*long_name_value).GetIfString();
      if (!temp) {
        out->long_name = absl::nullopt;
        return false;
      }
      out->long_name = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<FoundNetworkProperties> FoundNetworkProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<FoundNetworkProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict FoundNetworkProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Status", this->status);

  to_value_result.Set("NetworkId", this->network_id);

  to_value_result.Set("Technology", this->technology);

  if (this->short_name) {
    to_value_result.Set("ShortName", *this->short_name);

  }
  if (this->long_name) {
    to_value_result.Set("LongName", *this->long_name);

  }

  return to_value_result;
}


IPConfigProperties::IPConfigProperties()
 {}

IPConfigProperties::~IPConfigProperties() = default;
IPConfigProperties::IPConfigProperties(IPConfigProperties&& rhs) = default;
IPConfigProperties& IPConfigProperties::operator=(IPConfigProperties&& rhs) = default;
// static
bool IPConfigProperties::Populate(
    const base::Value& value, IPConfigProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* gateway_value = dict.Find("Gateway");
  if (gateway_value) {
    {
      auto* temp = (*gateway_value).GetIfString();
      if (!temp) {
        out->gateway = absl::nullopt;
        return false;
      }
      out->gateway = *temp;
    }
  }

  const base::Value* ip_address_value = dict.Find("IPAddress");
  if (ip_address_value) {
    {
      auto* temp = (*ip_address_value).GetIfString();
      if (!temp) {
        out->ip_address = absl::nullopt;
        return false;
      }
      out->ip_address = *temp;
    }
  }

  const base::Value* excluded_routes_value = dict.Find("ExcludedRoutes");
  if (excluded_routes_value) {
    {
      if (!(*excluded_routes_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*excluded_routes_value).GetList(), &out->excluded_routes)) {
          return false;
        }
      }
    }
  }

  const base::Value* included_routes_value = dict.Find("IncludedRoutes");
  if (included_routes_value) {
    {
      if (!(*included_routes_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*included_routes_value).GetList(), &out->included_routes)) {
          return false;
        }
      }
    }
  }

  const base::Value* name_servers_value = dict.Find("NameServers");
  if (name_servers_value) {
    {
      if (!(*name_servers_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*name_servers_value).GetList(), &out->name_servers)) {
          return false;
        }
      }
    }
  }

  const base::Value* search_domains_value = dict.Find("SearchDomains");
  if (search_domains_value) {
    {
      if (!(*search_domains_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*search_domains_value).GetList(), &out->search_domains)) {
          return false;
        }
      }
    }
  }

  const base::Value* routing_prefix_value = dict.Find("RoutingPrefix");
  if (routing_prefix_value) {
    {
      auto temp = (*routing_prefix_value).GetIfInt();
      if (!temp.has_value()) {
        out->routing_prefix = absl::nullopt;
        return false;
      }
      out->routing_prefix = *temp;
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (type_value) {
    {
      auto* temp = (*type_value).GetIfString();
      if (!temp) {
        out->type = absl::nullopt;
        return false;
      }
      out->type = *temp;
    }
  }

  const base::Value* web_proxy_auto_discovery_url_value = dict.Find("WebProxyAutoDiscoveryUrl");
  if (web_proxy_auto_discovery_url_value) {
    {
      auto* temp = (*web_proxy_auto_discovery_url_value).GetIfString();
      if (!temp) {
        out->web_proxy_auto_discovery_url = absl::nullopt;
        return false;
      }
      out->web_proxy_auto_discovery_url = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<IPConfigProperties> IPConfigProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<IPConfigProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict IPConfigProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->gateway) {
    to_value_result.Set("Gateway", *this->gateway);

  }
  if (this->ip_address) {
    to_value_result.Set("IPAddress", *this->ip_address);

  }
  if (this->excluded_routes) {
    to_value_result.Set("ExcludedRoutes", json_schema_compiler::util::CreateValueFromArray(*this->excluded_routes));

  }
  if (this->included_routes) {
    to_value_result.Set("IncludedRoutes", json_schema_compiler::util::CreateValueFromArray(*this->included_routes));

  }
  if (this->name_servers) {
    to_value_result.Set("NameServers", json_schema_compiler::util::CreateValueFromArray(*this->name_servers));

  }
  if (this->search_domains) {
    to_value_result.Set("SearchDomains", json_schema_compiler::util::CreateValueFromArray(*this->search_domains));

  }
  if (this->routing_prefix) {
    to_value_result.Set("RoutingPrefix", *this->routing_prefix);

  }
  if (this->type) {
    to_value_result.Set("Type", *this->type);

  }
  if (this->web_proxy_auto_discovery_url) {
    to_value_result.Set("WebProxyAutoDiscoveryUrl", *this->web_proxy_auto_discovery_url);

  }

  return to_value_result;
}


ManagedIPConfigProperties::ManagedIPConfigProperties()
 {}

ManagedIPConfigProperties::~ManagedIPConfigProperties() = default;
ManagedIPConfigProperties::ManagedIPConfigProperties(ManagedIPConfigProperties&& rhs) = default;
ManagedIPConfigProperties& ManagedIPConfigProperties::operator=(ManagedIPConfigProperties&& rhs) = default;
// static
bool ManagedIPConfigProperties::Populate(
    const base::Value& value, ManagedIPConfigProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* gateway_value = dict.Find("Gateway");
  if (gateway_value) {
    {
      if (!(*gateway_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*gateway_value), &temp))
          return false;
        out->gateway = std::move(temp);
      }
    }
  }

  const base::Value* ip_address_value = dict.Find("IPAddress");
  if (ip_address_value) {
    {
      if (!(*ip_address_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*ip_address_value), &temp))
          return false;
        out->ip_address = std::move(temp);
      }
    }
  }

  const base::Value* name_servers_value = dict.Find("NameServers");
  if (name_servers_value) {
    {
      if (!(*name_servers_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*name_servers_value), &temp))
          return false;
        out->name_servers = std::move(temp);
      }
    }
  }

  const base::Value* routing_prefix_value = dict.Find("RoutingPrefix");
  if (routing_prefix_value) {
    {
      if (!(*routing_prefix_value).is_dict()) {
        return false;
      }
      else {
        ManagedLong temp;
        if (!ManagedLong::Populate((*routing_prefix_value), &temp))
          return false;
        out->routing_prefix = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (type_value) {
    {
      if (!(*type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*type_value), &temp))
          return false;
        out->type = std::move(temp);
      }
    }
  }

  const base::Value* web_proxy_auto_discovery_url_value = dict.Find("WebProxyAutoDiscoveryUrl");
  if (web_proxy_auto_discovery_url_value) {
    {
      if (!(*web_proxy_auto_discovery_url_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*web_proxy_auto_discovery_url_value), &temp))
          return false;
        out->web_proxy_auto_discovery_url = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedIPConfigProperties> ManagedIPConfigProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedIPConfigProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedIPConfigProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->gateway) {
    to_value_result.Set("Gateway", (this->gateway)->ToValue());

  }
  if (this->ip_address) {
    to_value_result.Set("IPAddress", (this->ip_address)->ToValue());

  }
  if (this->name_servers) {
    to_value_result.Set("NameServers", (this->name_servers)->ToValue());

  }
  if (this->routing_prefix) {
    to_value_result.Set("RoutingPrefix", (this->routing_prefix)->ToValue());

  }
  if (this->type) {
    to_value_result.Set("Type", (this->type)->ToValue());

  }
  if (this->web_proxy_auto_discovery_url) {
    to_value_result.Set("WebProxyAutoDiscoveryUrl", (this->web_proxy_auto_discovery_url)->ToValue());

  }

  return to_value_result;
}


XAUTHProperties::XAUTHProperties()
 {}

XAUTHProperties::~XAUTHProperties() = default;
XAUTHProperties::XAUTHProperties(XAUTHProperties&& rhs) = default;
XAUTHProperties& XAUTHProperties::operator=(XAUTHProperties&& rhs) = default;
// static
bool XAUTHProperties::Populate(
    const base::Value& value, XAUTHProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      auto* temp = (*password_value).GetIfString();
      if (!temp) {
        out->password = absl::nullopt;
        return false;
      }
      out->password = *temp;
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      auto temp = (*save_credentials_value).GetIfBool();
      if (!temp.has_value()) {
        out->save_credentials = absl::nullopt;
        return false;
      }
      out->save_credentials = *temp;
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      auto* temp = (*username_value).GetIfString();
      if (!temp) {
        out->username = absl::nullopt;
        return false;
      }
      out->username = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<XAUTHProperties> XAUTHProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<XAUTHProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict XAUTHProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->password) {
    to_value_result.Set("Password", *this->password);

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", *this->save_credentials);

  }
  if (this->username) {
    to_value_result.Set("Username", *this->username);

  }

  return to_value_result;
}


ManagedXAUTHProperties::ManagedXAUTHProperties()
 {}

ManagedXAUTHProperties::~ManagedXAUTHProperties() = default;
ManagedXAUTHProperties::ManagedXAUTHProperties(ManagedXAUTHProperties&& rhs) = default;
ManagedXAUTHProperties& ManagedXAUTHProperties::operator=(ManagedXAUTHProperties&& rhs) = default;
// static
bool ManagedXAUTHProperties::Populate(
    const base::Value& value, ManagedXAUTHProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      if (!(*password_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*password_value), &temp))
          return false;
        out->password = std::move(temp);
      }
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      if (!(*save_credentials_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*save_credentials_value), &temp))
          return false;
        out->save_credentials = std::move(temp);
      }
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      if (!(*username_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*username_value), &temp))
          return false;
        out->username = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedXAUTHProperties> ManagedXAUTHProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedXAUTHProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedXAUTHProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->password) {
    to_value_result.Set("Password", (this->password)->ToValue());

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", (this->save_credentials)->ToValue());

  }
  if (this->username) {
    to_value_result.Set("Username", (this->username)->ToValue());

  }

  return to_value_result;
}


IPSecProperties::IPSecProperties()
 {}

IPSecProperties::~IPSecProperties() = default;
IPSecProperties::IPSecProperties(IPSecProperties&& rhs) = default;
IPSecProperties& IPSecProperties::operator=(IPSecProperties&& rhs) = default;
// static
bool IPSecProperties::Populate(
    const base::Value& value, IPSecProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* authentication_type_value = dict.Find("AuthenticationType");
  if (!authentication_type_value) {
    return false;
  }
  {
    auto* temp = (*authentication_type_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->authentication_type = *temp;
  }

  const base::Value* client_cert_pattern_value = dict.Find("ClientCertPattern");
  if (client_cert_pattern_value) {
    {
      if (!(*client_cert_pattern_value).is_dict()) {
        return false;
      }
      else {
        CertificatePattern temp;
        if (!CertificatePattern::Populate((*client_cert_pattern_value), &temp))
          return false;
        out->client_cert_pattern = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_pkcs11_id_value = dict.Find("ClientCertPKCS11Id");
  if (client_cert_pkcs11_id_value) {
    {
      auto* temp = (*client_cert_pkcs11_id_value).GetIfString();
      if (!temp) {
        out->client_cert_pkcs11_id = absl::nullopt;
        return false;
      }
      out->client_cert_pkcs11_id = *temp;
    }
  }

  const base::Value* client_cert_provisioning_profile_id_value = dict.Find("ClientCertProvisioningProfileId");
  if (client_cert_provisioning_profile_id_value) {
    {
      auto* temp = (*client_cert_provisioning_profile_id_value).GetIfString();
      if (!temp) {
        out->client_cert_provisioning_profile_id = absl::nullopt;
        return false;
      }
      out->client_cert_provisioning_profile_id = *temp;
    }
  }

  const base::Value* client_cert_ref_value = dict.Find("ClientCertRef");
  if (client_cert_ref_value) {
    {
      auto* temp = (*client_cert_ref_value).GetIfString();
      if (!temp) {
        out->client_cert_ref = absl::nullopt;
        return false;
      }
      out->client_cert_ref = *temp;
    }
  }

  const base::Value* client_cert_type_value = dict.Find("ClientCertType");
  if (client_cert_type_value) {
    {
      auto* temp = (*client_cert_type_value).GetIfString();
      if (!temp) {
        out->client_cert_type = absl::nullopt;
        return false;
      }
      out->client_cert_type = *temp;
    }
  }

  const base::Value* eap_value = dict.Find("EAP");
  if (eap_value) {
    {
      if (!(*eap_value).is_dict()) {
        return false;
      }
      else {
        EAPProperties temp;
        if (!EAPProperties::Populate((*eap_value), &temp))
          return false;
        out->eap = std::move(temp);
      }
    }
  }

  const base::Value* group_value = dict.Find("Group");
  if (group_value) {
    {
      auto* temp = (*group_value).GetIfString();
      if (!temp) {
        out->group = absl::nullopt;
        return false;
      }
      out->group = *temp;
    }
  }

  const base::Value* ike_version_value = dict.Find("IKEVersion");
  if (ike_version_value) {
    {
      auto temp = (*ike_version_value).GetIfInt();
      if (!temp.has_value()) {
        out->ike_version = absl::nullopt;
        return false;
      }
      out->ike_version = *temp;
    }
  }

  const base::Value* psk_value = dict.Find("PSK");
  if (psk_value) {
    {
      auto* temp = (*psk_value).GetIfString();
      if (!temp) {
        out->psk = absl::nullopt;
        return false;
      }
      out->psk = *temp;
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      auto temp = (*save_credentials_value).GetIfBool();
      if (!temp.has_value()) {
        out->save_credentials = absl::nullopt;
        return false;
      }
      out->save_credentials = *temp;
    }
  }

  const base::Value* server_cape_ms_value = dict.Find("ServerCAPEMs");
  if (server_cape_ms_value) {
    {
      if (!(*server_cape_ms_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*server_cape_ms_value).GetList(), &out->server_cape_ms)) {
          return false;
        }
      }
    }
  }

  const base::Value* server_ca_refs_value = dict.Find("ServerCARefs");
  if (server_ca_refs_value) {
    {
      if (!(*server_ca_refs_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*server_ca_refs_value).GetList(), &out->server_ca_refs)) {
          return false;
        }
      }
    }
  }

  const base::Value* xauth_value = dict.Find("XAUTH");
  if (xauth_value) {
    {
      if (!(*xauth_value).is_dict()) {
        return false;
      }
      else {
        XAUTHProperties temp;
        if (!XAUTHProperties::Populate((*xauth_value), &temp))
          return false;
        out->xauth = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<IPSecProperties> IPSecProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<IPSecProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict IPSecProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("AuthenticationType", this->authentication_type);

  if (this->client_cert_pattern) {
    to_value_result.Set("ClientCertPattern", (this->client_cert_pattern)->ToValue());

  }
  if (this->client_cert_pkcs11_id) {
    to_value_result.Set("ClientCertPKCS11Id", *this->client_cert_pkcs11_id);

  }
  if (this->client_cert_provisioning_profile_id) {
    to_value_result.Set("ClientCertProvisioningProfileId", *this->client_cert_provisioning_profile_id);

  }
  if (this->client_cert_ref) {
    to_value_result.Set("ClientCertRef", *this->client_cert_ref);

  }
  if (this->client_cert_type) {
    to_value_result.Set("ClientCertType", *this->client_cert_type);

  }
  if (this->eap) {
    to_value_result.Set("EAP", (this->eap)->ToValue());

  }
  if (this->group) {
    to_value_result.Set("Group", *this->group);

  }
  if (this->ike_version) {
    to_value_result.Set("IKEVersion", *this->ike_version);

  }
  if (this->psk) {
    to_value_result.Set("PSK", *this->psk);

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", *this->save_credentials);

  }
  if (this->server_cape_ms) {
    to_value_result.Set("ServerCAPEMs", json_schema_compiler::util::CreateValueFromArray(*this->server_cape_ms));

  }
  if (this->server_ca_refs) {
    to_value_result.Set("ServerCARefs", json_schema_compiler::util::CreateValueFromArray(*this->server_ca_refs));

  }
  if (this->xauth) {
    to_value_result.Set("XAUTH", (this->xauth)->ToValue());

  }

  return to_value_result;
}


ManagedIPSecProperties::ManagedIPSecProperties()
 {}

ManagedIPSecProperties::~ManagedIPSecProperties() = default;
ManagedIPSecProperties::ManagedIPSecProperties(ManagedIPSecProperties&& rhs) = default;
ManagedIPSecProperties& ManagedIPSecProperties::operator=(ManagedIPSecProperties&& rhs) = default;
// static
bool ManagedIPSecProperties::Populate(
    const base::Value& value, ManagedIPSecProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* authentication_type_value = dict.Find("AuthenticationType");
  if (!authentication_type_value) {
    return false;
  }
  {
    if (!(*authentication_type_value).is_dict()) {
      return false;
    }
    if (!ManagedDOMString::Populate((*authentication_type_value), &out->authentication_type)) {
      return false;
    }
  }

  const base::Value* client_cert_pattern_value = dict.Find("ClientCertPattern");
  if (client_cert_pattern_value) {
    {
      if (!(*client_cert_pattern_value).is_dict()) {
        return false;
      }
      else {
        ManagedCertificatePattern temp;
        if (!ManagedCertificatePattern::Populate((*client_cert_pattern_value), &temp))
          return false;
        out->client_cert_pattern = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_pkcs11_id_value = dict.Find("ClientCertPKCS11Id");
  if (client_cert_pkcs11_id_value) {
    {
      if (!(*client_cert_pkcs11_id_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_pkcs11_id_value), &temp))
          return false;
        out->client_cert_pkcs11_id = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_provisioning_profile_id_value = dict.Find("ClientCertProvisioningProfileId");
  if (client_cert_provisioning_profile_id_value) {
    {
      if (!(*client_cert_provisioning_profile_id_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_provisioning_profile_id_value), &temp))
          return false;
        out->client_cert_provisioning_profile_id = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_ref_value = dict.Find("ClientCertRef");
  if (client_cert_ref_value) {
    {
      if (!(*client_cert_ref_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_ref_value), &temp))
          return false;
        out->client_cert_ref = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_type_value = dict.Find("ClientCertType");
  if (client_cert_type_value) {
    {
      if (!(*client_cert_type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_type_value), &temp))
          return false;
        out->client_cert_type = std::move(temp);
      }
    }
  }

  const base::Value* eap_value = dict.Find("EAP");
  if (eap_value) {
    {
      if (!(*eap_value).is_dict()) {
        return false;
      }
      else {
        ManagedEAPProperties temp;
        if (!ManagedEAPProperties::Populate((*eap_value), &temp))
          return false;
        out->eap = std::move(temp);
      }
    }
  }

  const base::Value* group_value = dict.Find("Group");
  if (group_value) {
    {
      if (!(*group_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*group_value), &temp))
          return false;
        out->group = std::move(temp);
      }
    }
  }

  const base::Value* ike_version_value = dict.Find("IKEVersion");
  if (ike_version_value) {
    {
      if (!(*ike_version_value).is_dict()) {
        return false;
      }
      else {
        ManagedLong temp;
        if (!ManagedLong::Populate((*ike_version_value), &temp))
          return false;
        out->ike_version = std::move(temp);
      }
    }
  }

  const base::Value* psk_value = dict.Find("PSK");
  if (psk_value) {
    {
      if (!(*psk_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*psk_value), &temp))
          return false;
        out->psk = std::move(temp);
      }
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      if (!(*save_credentials_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*save_credentials_value), &temp))
          return false;
        out->save_credentials = std::move(temp);
      }
    }
  }

  const base::Value* server_cape_ms_value = dict.Find("ServerCAPEMs");
  if (server_cape_ms_value) {
    {
      if (!(*server_cape_ms_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*server_cape_ms_value), &temp))
          return false;
        out->server_cape_ms = std::move(temp);
      }
    }
  }

  const base::Value* server_ca_refs_value = dict.Find("ServerCARefs");
  if (server_ca_refs_value) {
    {
      if (!(*server_ca_refs_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*server_ca_refs_value), &temp))
          return false;
        out->server_ca_refs = std::move(temp);
      }
    }
  }

  const base::Value* xauth_value = dict.Find("XAUTH");
  if (xauth_value) {
    {
      if (!(*xauth_value).is_dict()) {
        return false;
      }
      else {
        ManagedXAUTHProperties temp;
        if (!ManagedXAUTHProperties::Populate((*xauth_value), &temp))
          return false;
        out->xauth = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedIPSecProperties> ManagedIPSecProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedIPSecProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedIPSecProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("AuthenticationType", (this->authentication_type).ToValue());

  if (this->client_cert_pattern) {
    to_value_result.Set("ClientCertPattern", (this->client_cert_pattern)->ToValue());

  }
  if (this->client_cert_pkcs11_id) {
    to_value_result.Set("ClientCertPKCS11Id", (this->client_cert_pkcs11_id)->ToValue());

  }
  if (this->client_cert_provisioning_profile_id) {
    to_value_result.Set("ClientCertProvisioningProfileId", (this->client_cert_provisioning_profile_id)->ToValue());

  }
  if (this->client_cert_ref) {
    to_value_result.Set("ClientCertRef", (this->client_cert_ref)->ToValue());

  }
  if (this->client_cert_type) {
    to_value_result.Set("ClientCertType", (this->client_cert_type)->ToValue());

  }
  if (this->eap) {
    to_value_result.Set("EAP", (this->eap)->ToValue());

  }
  if (this->group) {
    to_value_result.Set("Group", (this->group)->ToValue());

  }
  if (this->ike_version) {
    to_value_result.Set("IKEVersion", (this->ike_version)->ToValue());

  }
  if (this->psk) {
    to_value_result.Set("PSK", (this->psk)->ToValue());

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", (this->save_credentials)->ToValue());

  }
  if (this->server_cape_ms) {
    to_value_result.Set("ServerCAPEMs", (this->server_cape_ms)->ToValue());

  }
  if (this->server_ca_refs) {
    to_value_result.Set("ServerCARefs", (this->server_ca_refs)->ToValue());

  }
  if (this->xauth) {
    to_value_result.Set("XAUTH", (this->xauth)->ToValue());

  }

  return to_value_result;
}


L2TPProperties::L2TPProperties()
 {}

L2TPProperties::~L2TPProperties() = default;
L2TPProperties::L2TPProperties(L2TPProperties&& rhs) = default;
L2TPProperties& L2TPProperties::operator=(L2TPProperties&& rhs) = default;
// static
bool L2TPProperties::Populate(
    const base::Value& value, L2TPProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* lcp_echo_disabled_value = dict.Find("LcpEchoDisabled");
  if (lcp_echo_disabled_value) {
    {
      auto temp = (*lcp_echo_disabled_value).GetIfBool();
      if (!temp.has_value()) {
        out->lcp_echo_disabled = absl::nullopt;
        return false;
      }
      out->lcp_echo_disabled = *temp;
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      auto* temp = (*password_value).GetIfString();
      if (!temp) {
        out->password = absl::nullopt;
        return false;
      }
      out->password = *temp;
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      auto temp = (*save_credentials_value).GetIfBool();
      if (!temp.has_value()) {
        out->save_credentials = absl::nullopt;
        return false;
      }
      out->save_credentials = *temp;
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      auto* temp = (*username_value).GetIfString();
      if (!temp) {
        out->username = absl::nullopt;
        return false;
      }
      out->username = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<L2TPProperties> L2TPProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<L2TPProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict L2TPProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->lcp_echo_disabled) {
    to_value_result.Set("LcpEchoDisabled", *this->lcp_echo_disabled);

  }
  if (this->password) {
    to_value_result.Set("Password", *this->password);

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", *this->save_credentials);

  }
  if (this->username) {
    to_value_result.Set("Username", *this->username);

  }

  return to_value_result;
}


ManagedL2TPProperties::ManagedL2TPProperties()
 {}

ManagedL2TPProperties::~ManagedL2TPProperties() = default;
ManagedL2TPProperties::ManagedL2TPProperties(ManagedL2TPProperties&& rhs) = default;
ManagedL2TPProperties& ManagedL2TPProperties::operator=(ManagedL2TPProperties&& rhs) = default;
// static
bool ManagedL2TPProperties::Populate(
    const base::Value& value, ManagedL2TPProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* lcp_echo_disabled_value = dict.Find("LcpEchoDisabled");
  if (lcp_echo_disabled_value) {
    {
      if (!(*lcp_echo_disabled_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*lcp_echo_disabled_value), &temp))
          return false;
        out->lcp_echo_disabled = std::move(temp);
      }
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      if (!(*password_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*password_value), &temp))
          return false;
        out->password = std::move(temp);
      }
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      if (!(*save_credentials_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*save_credentials_value), &temp))
          return false;
        out->save_credentials = std::move(temp);
      }
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      if (!(*username_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*username_value), &temp))
          return false;
        out->username = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedL2TPProperties> ManagedL2TPProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedL2TPProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedL2TPProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->lcp_echo_disabled) {
    to_value_result.Set("LcpEchoDisabled", (this->lcp_echo_disabled)->ToValue());

  }
  if (this->password) {
    to_value_result.Set("Password", (this->password)->ToValue());

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", (this->save_credentials)->ToValue());

  }
  if (this->username) {
    to_value_result.Set("Username", (this->username)->ToValue());

  }

  return to_value_result;
}


PaymentPortal::PaymentPortal()
 {}

PaymentPortal::~PaymentPortal() = default;
PaymentPortal::PaymentPortal(PaymentPortal&& rhs) = default;
PaymentPortal& PaymentPortal::operator=(PaymentPortal&& rhs) = default;
// static
bool PaymentPortal::Populate(
    const base::Value& value, PaymentPortal* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* method_value = dict.Find("Method");
  if (!method_value) {
    return false;
  }
  {
    auto* temp = (*method_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->method = *temp;
  }

  const base::Value* post_data_value = dict.Find("PostData");
  if (post_data_value) {
    {
      auto* temp = (*post_data_value).GetIfString();
      if (!temp) {
        out->post_data = absl::nullopt;
        return false;
      }
      out->post_data = *temp;
    }
  }

  const base::Value* url_value = dict.Find("Url");
  if (url_value) {
    {
      auto* temp = (*url_value).GetIfString();
      if (!temp) {
        out->url = absl::nullopt;
        return false;
      }
      out->url = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<PaymentPortal> PaymentPortal::FromValue(const base::Value& value) {
  auto out = std::make_unique<PaymentPortal>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict PaymentPortal::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Method", this->method);

  if (this->post_data) {
    to_value_result.Set("PostData", *this->post_data);

  }
  if (this->url) {
    to_value_result.Set("Url", *this->url);

  }

  return to_value_result;
}


ProxyLocation::ProxyLocation()
: port(0) {}

ProxyLocation::~ProxyLocation() = default;
ProxyLocation::ProxyLocation(ProxyLocation&& rhs) = default;
ProxyLocation& ProxyLocation::operator=(ProxyLocation&& rhs) = default;
// static
bool ProxyLocation::Populate(
    const base::Value& value, ProxyLocation* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* host_value = dict.Find("Host");
  if (!host_value) {
    return false;
  }
  {
    auto* temp = (*host_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->host = *temp;
  }

  const base::Value* port_value = dict.Find("Port");
  if (!port_value) {
    return false;
  }
  {
    auto temp = (*port_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->port = *temp;
  }

  return true;
}

// static
std::unique_ptr<ProxyLocation> ProxyLocation::FromValue(const base::Value& value) {
  auto out = std::make_unique<ProxyLocation>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ProxyLocation::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Host", this->host);

  to_value_result.Set("Port", this->port);


  return to_value_result;
}


ManagedProxyLocation::ManagedProxyLocation()
 {}

ManagedProxyLocation::~ManagedProxyLocation() = default;
ManagedProxyLocation::ManagedProxyLocation(ManagedProxyLocation&& rhs) = default;
ManagedProxyLocation& ManagedProxyLocation::operator=(ManagedProxyLocation&& rhs) = default;
// static
bool ManagedProxyLocation::Populate(
    const base::Value& value, ManagedProxyLocation* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* host_value = dict.Find("Host");
  if (!host_value) {
    return false;
  }
  {
    if (!(*host_value).is_dict()) {
      return false;
    }
    if (!ManagedDOMString::Populate((*host_value), &out->host)) {
      return false;
    }
  }

  const base::Value* port_value = dict.Find("Port");
  if (!port_value) {
    return false;
  }
  {
    if (!(*port_value).is_dict()) {
      return false;
    }
    if (!ManagedLong::Populate((*port_value), &out->port)) {
      return false;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedProxyLocation> ManagedProxyLocation::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedProxyLocation>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedProxyLocation::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Host", (this->host).ToValue());

  to_value_result.Set("Port", (this->port).ToValue());


  return to_value_result;
}


ManualProxySettings::ManualProxySettings()
 {}

ManualProxySettings::~ManualProxySettings() = default;
ManualProxySettings::ManualProxySettings(ManualProxySettings&& rhs) = default;
ManualProxySettings& ManualProxySettings::operator=(ManualProxySettings&& rhs) = default;
// static
bool ManualProxySettings::Populate(
    const base::Value& value, ManualProxySettings* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* http_proxy_value = dict.Find("HTTPProxy");
  if (http_proxy_value) {
    {
      if (!(*http_proxy_value).is_dict()) {
        return false;
      }
      else {
        ProxyLocation temp;
        if (!ProxyLocation::Populate((*http_proxy_value), &temp))
          return false;
        out->http_proxy = std::move(temp);
      }
    }
  }

  const base::Value* secure_http_proxy_value = dict.Find("SecureHTTPProxy");
  if (secure_http_proxy_value) {
    {
      if (!(*secure_http_proxy_value).is_dict()) {
        return false;
      }
      else {
        ProxyLocation temp;
        if (!ProxyLocation::Populate((*secure_http_proxy_value), &temp))
          return false;
        out->secure_http_proxy = std::move(temp);
      }
    }
  }

  const base::Value* ftp_proxy_value = dict.Find("FTPProxy");
  if (ftp_proxy_value) {
    {
      if (!(*ftp_proxy_value).is_dict()) {
        return false;
      }
      else {
        ProxyLocation temp;
        if (!ProxyLocation::Populate((*ftp_proxy_value), &temp))
          return false;
        out->ftp_proxy = std::move(temp);
      }
    }
  }

  const base::Value* socks_value = dict.Find("SOCKS");
  if (socks_value) {
    {
      if (!(*socks_value).is_dict()) {
        return false;
      }
      else {
        ProxyLocation temp;
        if (!ProxyLocation::Populate((*socks_value), &temp))
          return false;
        out->socks = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManualProxySettings> ManualProxySettings::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManualProxySettings>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManualProxySettings::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->http_proxy) {
    to_value_result.Set("HTTPProxy", (this->http_proxy)->ToValue());

  }
  if (this->secure_http_proxy) {
    to_value_result.Set("SecureHTTPProxy", (this->secure_http_proxy)->ToValue());

  }
  if (this->ftp_proxy) {
    to_value_result.Set("FTPProxy", (this->ftp_proxy)->ToValue());

  }
  if (this->socks) {
    to_value_result.Set("SOCKS", (this->socks)->ToValue());

  }

  return to_value_result;
}


ManagedManualProxySettings::ManagedManualProxySettings()
 {}

ManagedManualProxySettings::~ManagedManualProxySettings() = default;
ManagedManualProxySettings::ManagedManualProxySettings(ManagedManualProxySettings&& rhs) = default;
ManagedManualProxySettings& ManagedManualProxySettings::operator=(ManagedManualProxySettings&& rhs) = default;
// static
bool ManagedManualProxySettings::Populate(
    const base::Value& value, ManagedManualProxySettings* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* http_proxy_value = dict.Find("HTTPProxy");
  if (http_proxy_value) {
    {
      if (!(*http_proxy_value).is_dict()) {
        return false;
      }
      else {
        ManagedProxyLocation temp;
        if (!ManagedProxyLocation::Populate((*http_proxy_value), &temp))
          return false;
        out->http_proxy = std::move(temp);
      }
    }
  }

  const base::Value* secure_http_proxy_value = dict.Find("SecureHTTPProxy");
  if (secure_http_proxy_value) {
    {
      if (!(*secure_http_proxy_value).is_dict()) {
        return false;
      }
      else {
        ManagedProxyLocation temp;
        if (!ManagedProxyLocation::Populate((*secure_http_proxy_value), &temp))
          return false;
        out->secure_http_proxy = std::move(temp);
      }
    }
  }

  const base::Value* ftp_proxy_value = dict.Find("FTPProxy");
  if (ftp_proxy_value) {
    {
      if (!(*ftp_proxy_value).is_dict()) {
        return false;
      }
      else {
        ManagedProxyLocation temp;
        if (!ManagedProxyLocation::Populate((*ftp_proxy_value), &temp))
          return false;
        out->ftp_proxy = std::move(temp);
      }
    }
  }

  const base::Value* socks_value = dict.Find("SOCKS");
  if (socks_value) {
    {
      if (!(*socks_value).is_dict()) {
        return false;
      }
      else {
        ManagedProxyLocation temp;
        if (!ManagedProxyLocation::Populate((*socks_value), &temp))
          return false;
        out->socks = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedManualProxySettings> ManagedManualProxySettings::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedManualProxySettings>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedManualProxySettings::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->http_proxy) {
    to_value_result.Set("HTTPProxy", (this->http_proxy)->ToValue());

  }
  if (this->secure_http_proxy) {
    to_value_result.Set("SecureHTTPProxy", (this->secure_http_proxy)->ToValue());

  }
  if (this->ftp_proxy) {
    to_value_result.Set("FTPProxy", (this->ftp_proxy)->ToValue());

  }
  if (this->socks) {
    to_value_result.Set("SOCKS", (this->socks)->ToValue());

  }

  return to_value_result;
}


ProxySettings::ProxySettings()
: type(PROXY_SETTINGS_TYPE_NONE) {}

ProxySettings::~ProxySettings() = default;
ProxySettings::ProxySettings(ProxySettings&& rhs) = default;
ProxySettings& ProxySettings::operator=(ProxySettings&& rhs) = default;
// static
bool ProxySettings::Populate(
    const base::Value& value, ProxySettings* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* type_value = dict.Find("Type");
  if (!type_value) {
    return false;
  }
  {
    const std::string* proxy_settings_type_as_string = (*type_value).GetIfString();
    if (!proxy_settings_type_as_string) {
      return false;
    }
    out->type = ParseProxySettingsType(*proxy_settings_type_as_string);
    if (out->type == PROXY_SETTINGS_TYPE_NONE) {
      return false;
    }
  }

  const base::Value* manual_value = dict.Find("Manual");
  if (manual_value) {
    {
      if (!(*manual_value).is_dict()) {
        return false;
      }
      else {
        ManualProxySettings temp;
        if (!ManualProxySettings::Populate((*manual_value), &temp))
          return false;
        out->manual = std::move(temp);
      }
    }
  }

  const base::Value* exclude_domains_value = dict.Find("ExcludeDomains");
  if (exclude_domains_value) {
    {
      if (!(*exclude_domains_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*exclude_domains_value).GetList(), &out->exclude_domains)) {
          return false;
        }
      }
    }
  }

  const base::Value* pac_value = dict.Find("PAC");
  if (pac_value) {
    {
      auto* temp = (*pac_value).GetIfString();
      if (!temp) {
        out->pac = absl::nullopt;
        return false;
      }
      out->pac = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ProxySettings> ProxySettings::FromValue(const base::Value& value) {
  auto out = std::make_unique<ProxySettings>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ProxySettings::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Type", networking_private::ToString(this->type));

  if (this->manual) {
    to_value_result.Set("Manual", (this->manual)->ToValue());

  }
  if (this->exclude_domains) {
    to_value_result.Set("ExcludeDomains", json_schema_compiler::util::CreateValueFromArray(*this->exclude_domains));

  }
  if (this->pac) {
    to_value_result.Set("PAC", *this->pac);

  }

  return to_value_result;
}


ManagedProxySettings::ManagedProxySettings()
 {}

ManagedProxySettings::~ManagedProxySettings() = default;
ManagedProxySettings::ManagedProxySettings(ManagedProxySettings&& rhs) = default;
ManagedProxySettings& ManagedProxySettings::operator=(ManagedProxySettings&& rhs) = default;
// static
bool ManagedProxySettings::Populate(
    const base::Value& value, ManagedProxySettings* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* type_value = dict.Find("Type");
  if (!type_value) {
    return false;
  }
  {
    if (!(*type_value).is_dict()) {
      return false;
    }
    if (!ManagedProxySettingsType::Populate((*type_value), &out->type)) {
      return false;
    }
  }

  const base::Value* manual_value = dict.Find("Manual");
  if (manual_value) {
    {
      if (!(*manual_value).is_dict()) {
        return false;
      }
      else {
        ManagedManualProxySettings temp;
        if (!ManagedManualProxySettings::Populate((*manual_value), &temp))
          return false;
        out->manual = std::move(temp);
      }
    }
  }

  const base::Value* exclude_domains_value = dict.Find("ExcludeDomains");
  if (exclude_domains_value) {
    {
      if (!(*exclude_domains_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*exclude_domains_value), &temp))
          return false;
        out->exclude_domains = std::move(temp);
      }
    }
  }

  const base::Value* pac_value = dict.Find("PAC");
  if (pac_value) {
    {
      if (!(*pac_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*pac_value), &temp))
          return false;
        out->pac = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedProxySettings> ManagedProxySettings::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedProxySettings>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedProxySettings::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Type", (this->type).ToValue());

  if (this->manual) {
    to_value_result.Set("Manual", (this->manual)->ToValue());

  }
  if (this->exclude_domains) {
    to_value_result.Set("ExcludeDomains", (this->exclude_domains)->ToValue());

  }
  if (this->pac) {
    to_value_result.Set("PAC", (this->pac)->ToValue());

  }

  return to_value_result;
}


VerifyX509::VerifyX509()
 {}

VerifyX509::~VerifyX509() = default;
VerifyX509::VerifyX509(VerifyX509&& rhs) = default;
VerifyX509& VerifyX509::operator=(VerifyX509&& rhs) = default;
// static
bool VerifyX509::Populate(
    const base::Value& value, VerifyX509* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      auto* temp = (*name_value).GetIfString();
      if (!temp) {
        out->name = absl::nullopt;
        return false;
      }
      out->name = *temp;
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (type_value) {
    {
      auto* temp = (*type_value).GetIfString();
      if (!temp) {
        out->type = absl::nullopt;
        return false;
      }
      out->type = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<VerifyX509> VerifyX509::FromValue(const base::Value& value) {
  auto out = std::make_unique<VerifyX509>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict VerifyX509::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->name) {
    to_value_result.Set("Name", *this->name);

  }
  if (this->type) {
    to_value_result.Set("Type", *this->type);

  }

  return to_value_result;
}


ManagedVerifyX509::ManagedVerifyX509()
 {}

ManagedVerifyX509::~ManagedVerifyX509() = default;
ManagedVerifyX509::ManagedVerifyX509(ManagedVerifyX509&& rhs) = default;
ManagedVerifyX509& ManagedVerifyX509::operator=(ManagedVerifyX509&& rhs) = default;
// static
bool ManagedVerifyX509::Populate(
    const base::Value& value, ManagedVerifyX509* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      if (!(*name_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*name_value), &temp))
          return false;
        out->name = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (type_value) {
    {
      if (!(*type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*type_value), &temp))
          return false;
        out->type = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedVerifyX509> ManagedVerifyX509::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedVerifyX509>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedVerifyX509::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->name) {
    to_value_result.Set("Name", (this->name)->ToValue());

  }
  if (this->type) {
    to_value_result.Set("Type", (this->type)->ToValue());

  }

  return to_value_result;
}


OpenVPNProperties::OpenVPNProperties()
 {}

OpenVPNProperties::~OpenVPNProperties() = default;
OpenVPNProperties::OpenVPNProperties(OpenVPNProperties&& rhs) = default;
OpenVPNProperties& OpenVPNProperties::operator=(OpenVPNProperties&& rhs) = default;
// static
bool OpenVPNProperties::Populate(
    const base::Value& value, OpenVPNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* auth_value = dict.Find("Auth");
  if (auth_value) {
    {
      auto* temp = (*auth_value).GetIfString();
      if (!temp) {
        out->auth = absl::nullopt;
        return false;
      }
      out->auth = *temp;
    }
  }

  const base::Value* auth_retry_value = dict.Find("AuthRetry");
  if (auth_retry_value) {
    {
      auto* temp = (*auth_retry_value).GetIfString();
      if (!temp) {
        out->auth_retry = absl::nullopt;
        return false;
      }
      out->auth_retry = *temp;
    }
  }

  const base::Value* auth_no_cache_value = dict.Find("AuthNoCache");
  if (auth_no_cache_value) {
    {
      auto temp = (*auth_no_cache_value).GetIfBool();
      if (!temp.has_value()) {
        out->auth_no_cache = absl::nullopt;
        return false;
      }
      out->auth_no_cache = *temp;
    }
  }

  const base::Value* cipher_value = dict.Find("Cipher");
  if (cipher_value) {
    {
      auto* temp = (*cipher_value).GetIfString();
      if (!temp) {
        out->cipher = absl::nullopt;
        return false;
      }
      out->cipher = *temp;
    }
  }

  const base::Value* client_cert_pkcs11_id_value = dict.Find("ClientCertPKCS11Id");
  if (client_cert_pkcs11_id_value) {
    {
      auto* temp = (*client_cert_pkcs11_id_value).GetIfString();
      if (!temp) {
        out->client_cert_pkcs11_id = absl::nullopt;
        return false;
      }
      out->client_cert_pkcs11_id = *temp;
    }
  }

  const base::Value* client_cert_pattern_value = dict.Find("ClientCertPattern");
  if (client_cert_pattern_value) {
    {
      if (!(*client_cert_pattern_value).is_dict()) {
        return false;
      }
      else {
        CertificatePattern temp;
        if (!CertificatePattern::Populate((*client_cert_pattern_value), &temp))
          return false;
        out->client_cert_pattern = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_provisioning_profile_id_value = dict.Find("ClientCertProvisioningProfileId");
  if (client_cert_provisioning_profile_id_value) {
    {
      auto* temp = (*client_cert_provisioning_profile_id_value).GetIfString();
      if (!temp) {
        out->client_cert_provisioning_profile_id = absl::nullopt;
        return false;
      }
      out->client_cert_provisioning_profile_id = *temp;
    }
  }

  const base::Value* client_cert_ref_value = dict.Find("ClientCertRef");
  if (client_cert_ref_value) {
    {
      auto* temp = (*client_cert_ref_value).GetIfString();
      if (!temp) {
        out->client_cert_ref = absl::nullopt;
        return false;
      }
      out->client_cert_ref = *temp;
    }
  }

  const base::Value* client_cert_type_value = dict.Find("ClientCertType");
  if (client_cert_type_value) {
    {
      auto* temp = (*client_cert_type_value).GetIfString();
      if (!temp) {
        out->client_cert_type = absl::nullopt;
        return false;
      }
      out->client_cert_type = *temp;
    }
  }

  const base::Value* comp_lzo_value = dict.Find("CompLZO");
  if (comp_lzo_value) {
    {
      auto* temp = (*comp_lzo_value).GetIfString();
      if (!temp) {
        out->comp_lzo = absl::nullopt;
        return false;
      }
      out->comp_lzo = *temp;
    }
  }

  const base::Value* comp_no_adapt_value = dict.Find("CompNoAdapt");
  if (comp_no_adapt_value) {
    {
      auto temp = (*comp_no_adapt_value).GetIfBool();
      if (!temp.has_value()) {
        out->comp_no_adapt = absl::nullopt;
        return false;
      }
      out->comp_no_adapt = *temp;
    }
  }

  const base::Value* extra_hosts_value = dict.Find("ExtraHosts");
  if (extra_hosts_value) {
    {
      if (!(*extra_hosts_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*extra_hosts_value).GetList(), &out->extra_hosts)) {
          return false;
        }
      }
    }
  }

  const base::Value* ignore_default_route_value = dict.Find("IgnoreDefaultRoute");
  if (ignore_default_route_value) {
    {
      auto temp = (*ignore_default_route_value).GetIfBool();
      if (!temp.has_value()) {
        out->ignore_default_route = absl::nullopt;
        return false;
      }
      out->ignore_default_route = *temp;
    }
  }

  const base::Value* key_direction_value = dict.Find("KeyDirection");
  if (key_direction_value) {
    {
      auto* temp = (*key_direction_value).GetIfString();
      if (!temp) {
        out->key_direction = absl::nullopt;
        return false;
      }
      out->key_direction = *temp;
    }
  }

  const base::Value* ns_cert_type_value = dict.Find("NsCertType");
  if (ns_cert_type_value) {
    {
      auto* temp = (*ns_cert_type_value).GetIfString();
      if (!temp) {
        out->ns_cert_type = absl::nullopt;
        return false;
      }
      out->ns_cert_type = *temp;
    }
  }

  const base::Value* otp_value = dict.Find("OTP");
  if (otp_value) {
    {
      auto* temp = (*otp_value).GetIfString();
      if (!temp) {
        out->otp = absl::nullopt;
        return false;
      }
      out->otp = *temp;
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      auto* temp = (*password_value).GetIfString();
      if (!temp) {
        out->password = absl::nullopt;
        return false;
      }
      out->password = *temp;
    }
  }

  const base::Value* port_value = dict.Find("Port");
  if (port_value) {
    {
      auto temp = (*port_value).GetIfInt();
      if (!temp.has_value()) {
        out->port = absl::nullopt;
        return false;
      }
      out->port = *temp;
    }
  }

  const base::Value* proto_value = dict.Find("Proto");
  if (proto_value) {
    {
      auto* temp = (*proto_value).GetIfString();
      if (!temp) {
        out->proto = absl::nullopt;
        return false;
      }
      out->proto = *temp;
    }
  }

  const base::Value* push_peer_info_value = dict.Find("PushPeerInfo");
  if (push_peer_info_value) {
    {
      auto temp = (*push_peer_info_value).GetIfBool();
      if (!temp.has_value()) {
        out->push_peer_info = absl::nullopt;
        return false;
      }
      out->push_peer_info = *temp;
    }
  }

  const base::Value* remote_cert_eku_value = dict.Find("RemoteCertEKU");
  if (remote_cert_eku_value) {
    {
      auto* temp = (*remote_cert_eku_value).GetIfString();
      if (!temp) {
        out->remote_cert_eku = absl::nullopt;
        return false;
      }
      out->remote_cert_eku = *temp;
    }
  }

  const base::Value* remote_cert_ku_value = dict.Find("RemoteCertKU");
  if (remote_cert_ku_value) {
    {
      if (!(*remote_cert_ku_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*remote_cert_ku_value).GetList(), &out->remote_cert_ku)) {
          return false;
        }
      }
    }
  }

  const base::Value* remote_cert_tls_value = dict.Find("RemoteCertTLS");
  if (remote_cert_tls_value) {
    {
      auto* temp = (*remote_cert_tls_value).GetIfString();
      if (!temp) {
        out->remote_cert_tls = absl::nullopt;
        return false;
      }
      out->remote_cert_tls = *temp;
    }
  }

  const base::Value* reneg_sec_value = dict.Find("RenegSec");
  if (reneg_sec_value) {
    {
      auto temp = (*reneg_sec_value).GetIfInt();
      if (!temp.has_value()) {
        out->reneg_sec = absl::nullopt;
        return false;
      }
      out->reneg_sec = *temp;
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      auto temp = (*save_credentials_value).GetIfBool();
      if (!temp.has_value()) {
        out->save_credentials = absl::nullopt;
        return false;
      }
      out->save_credentials = *temp;
    }
  }

  const base::Value* server_cape_ms_value = dict.Find("ServerCAPEMs");
  if (server_cape_ms_value) {
    {
      if (!(*server_cape_ms_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*server_cape_ms_value).GetList(), &out->server_cape_ms)) {
          return false;
        }
      }
    }
  }

  const base::Value* server_ca_refs_value = dict.Find("ServerCARefs");
  if (server_ca_refs_value) {
    {
      if (!(*server_ca_refs_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*server_ca_refs_value).GetList(), &out->server_ca_refs)) {
          return false;
        }
      }
    }
  }

  const base::Value* server_cert_ref_value = dict.Find("ServerCertRef");
  if (server_cert_ref_value) {
    {
      auto* temp = (*server_cert_ref_value).GetIfString();
      if (!temp) {
        out->server_cert_ref = absl::nullopt;
        return false;
      }
      out->server_cert_ref = *temp;
    }
  }

  const base::Value* server_poll_timeout_value = dict.Find("ServerPollTimeout");
  if (server_poll_timeout_value) {
    {
      auto temp = (*server_poll_timeout_value).GetIfInt();
      if (!temp.has_value()) {
        out->server_poll_timeout = absl::nullopt;
        return false;
      }
      out->server_poll_timeout = *temp;
    }
  }

  const base::Value* shaper_value = dict.Find("Shaper");
  if (shaper_value) {
    {
      auto temp = (*shaper_value).GetIfInt();
      if (!temp.has_value()) {
        out->shaper = absl::nullopt;
        return false;
      }
      out->shaper = *temp;
    }
  }

  const base::Value* static_challenge_value = dict.Find("StaticChallenge");
  if (static_challenge_value) {
    {
      auto* temp = (*static_challenge_value).GetIfString();
      if (!temp) {
        out->static_challenge = absl::nullopt;
        return false;
      }
      out->static_challenge = *temp;
    }
  }

  const base::Value* tls_auth_contents_value = dict.Find("TLSAuthContents");
  if (tls_auth_contents_value) {
    {
      auto* temp = (*tls_auth_contents_value).GetIfString();
      if (!temp) {
        out->tls_auth_contents = absl::nullopt;
        return false;
      }
      out->tls_auth_contents = *temp;
    }
  }

  const base::Value* tls_remote_value = dict.Find("TLSRemote");
  if (tls_remote_value) {
    {
      auto* temp = (*tls_remote_value).GetIfString();
      if (!temp) {
        out->tls_remote = absl::nullopt;
        return false;
      }
      out->tls_remote = *temp;
    }
  }

  const base::Value* tls_version_min_value = dict.Find("TLSVersionMin");
  if (tls_version_min_value) {
    {
      auto* temp = (*tls_version_min_value).GetIfString();
      if (!temp) {
        out->tls_version_min = absl::nullopt;
        return false;
      }
      out->tls_version_min = *temp;
    }
  }

  const base::Value* user_authentication_type_value = dict.Find("UserAuthenticationType");
  if (user_authentication_type_value) {
    {
      auto* temp = (*user_authentication_type_value).GetIfString();
      if (!temp) {
        out->user_authentication_type = absl::nullopt;
        return false;
      }
      out->user_authentication_type = *temp;
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      auto* temp = (*username_value).GetIfString();
      if (!temp) {
        out->username = absl::nullopt;
        return false;
      }
      out->username = *temp;
    }
  }

  const base::Value* verb_value = dict.Find("Verb");
  if (verb_value) {
    {
      auto* temp = (*verb_value).GetIfString();
      if (!temp) {
        out->verb = absl::nullopt;
        return false;
      }
      out->verb = *temp;
    }
  }

  const base::Value* verify_hash_value = dict.Find("VerifyHash");
  if (verify_hash_value) {
    {
      auto* temp = (*verify_hash_value).GetIfString();
      if (!temp) {
        out->verify_hash = absl::nullopt;
        return false;
      }
      out->verify_hash = *temp;
    }
  }

  const base::Value* verify_x509_value = dict.Find("VerifyX509");
  if (verify_x509_value) {
    {
      if (!(*verify_x509_value).is_dict()) {
        return false;
      }
      else {
        VerifyX509 temp;
        if (!VerifyX509::Populate((*verify_x509_value), &temp))
          return false;
        out->verify_x509 = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<OpenVPNProperties> OpenVPNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<OpenVPNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict OpenVPNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auth) {
    to_value_result.Set("Auth", *this->auth);

  }
  if (this->auth_retry) {
    to_value_result.Set("AuthRetry", *this->auth_retry);

  }
  if (this->auth_no_cache) {
    to_value_result.Set("AuthNoCache", *this->auth_no_cache);

  }
  if (this->cipher) {
    to_value_result.Set("Cipher", *this->cipher);

  }
  if (this->client_cert_pkcs11_id) {
    to_value_result.Set("ClientCertPKCS11Id", *this->client_cert_pkcs11_id);

  }
  if (this->client_cert_pattern) {
    to_value_result.Set("ClientCertPattern", (this->client_cert_pattern)->ToValue());

  }
  if (this->client_cert_provisioning_profile_id) {
    to_value_result.Set("ClientCertProvisioningProfileId", *this->client_cert_provisioning_profile_id);

  }
  if (this->client_cert_ref) {
    to_value_result.Set("ClientCertRef", *this->client_cert_ref);

  }
  if (this->client_cert_type) {
    to_value_result.Set("ClientCertType", *this->client_cert_type);

  }
  if (this->comp_lzo) {
    to_value_result.Set("CompLZO", *this->comp_lzo);

  }
  if (this->comp_no_adapt) {
    to_value_result.Set("CompNoAdapt", *this->comp_no_adapt);

  }
  if (this->extra_hosts) {
    to_value_result.Set("ExtraHosts", json_schema_compiler::util::CreateValueFromArray(*this->extra_hosts));

  }
  if (this->ignore_default_route) {
    to_value_result.Set("IgnoreDefaultRoute", *this->ignore_default_route);

  }
  if (this->key_direction) {
    to_value_result.Set("KeyDirection", *this->key_direction);

  }
  if (this->ns_cert_type) {
    to_value_result.Set("NsCertType", *this->ns_cert_type);

  }
  if (this->otp) {
    to_value_result.Set("OTP", *this->otp);

  }
  if (this->password) {
    to_value_result.Set("Password", *this->password);

  }
  if (this->port) {
    to_value_result.Set("Port", *this->port);

  }
  if (this->proto) {
    to_value_result.Set("Proto", *this->proto);

  }
  if (this->push_peer_info) {
    to_value_result.Set("PushPeerInfo", *this->push_peer_info);

  }
  if (this->remote_cert_eku) {
    to_value_result.Set("RemoteCertEKU", *this->remote_cert_eku);

  }
  if (this->remote_cert_ku) {
    to_value_result.Set("RemoteCertKU", json_schema_compiler::util::CreateValueFromArray(*this->remote_cert_ku));

  }
  if (this->remote_cert_tls) {
    to_value_result.Set("RemoteCertTLS", *this->remote_cert_tls);

  }
  if (this->reneg_sec) {
    to_value_result.Set("RenegSec", *this->reneg_sec);

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", *this->save_credentials);

  }
  if (this->server_cape_ms) {
    to_value_result.Set("ServerCAPEMs", json_schema_compiler::util::CreateValueFromArray(*this->server_cape_ms));

  }
  if (this->server_ca_refs) {
    to_value_result.Set("ServerCARefs", json_schema_compiler::util::CreateValueFromArray(*this->server_ca_refs));

  }
  if (this->server_cert_ref) {
    to_value_result.Set("ServerCertRef", *this->server_cert_ref);

  }
  if (this->server_poll_timeout) {
    to_value_result.Set("ServerPollTimeout", *this->server_poll_timeout);

  }
  if (this->shaper) {
    to_value_result.Set("Shaper", *this->shaper);

  }
  if (this->static_challenge) {
    to_value_result.Set("StaticChallenge", *this->static_challenge);

  }
  if (this->tls_auth_contents) {
    to_value_result.Set("TLSAuthContents", *this->tls_auth_contents);

  }
  if (this->tls_remote) {
    to_value_result.Set("TLSRemote", *this->tls_remote);

  }
  if (this->tls_version_min) {
    to_value_result.Set("TLSVersionMin", *this->tls_version_min);

  }
  if (this->user_authentication_type) {
    to_value_result.Set("UserAuthenticationType", *this->user_authentication_type);

  }
  if (this->username) {
    to_value_result.Set("Username", *this->username);

  }
  if (this->verb) {
    to_value_result.Set("Verb", *this->verb);

  }
  if (this->verify_hash) {
    to_value_result.Set("VerifyHash", *this->verify_hash);

  }
  if (this->verify_x509) {
    to_value_result.Set("VerifyX509", (this->verify_x509)->ToValue());

  }

  return to_value_result;
}


ManagedOpenVPNProperties::ManagedOpenVPNProperties()
 {}

ManagedOpenVPNProperties::~ManagedOpenVPNProperties() = default;
ManagedOpenVPNProperties::ManagedOpenVPNProperties(ManagedOpenVPNProperties&& rhs) = default;
ManagedOpenVPNProperties& ManagedOpenVPNProperties::operator=(ManagedOpenVPNProperties&& rhs) = default;
// static
bool ManagedOpenVPNProperties::Populate(
    const base::Value& value, ManagedOpenVPNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* auth_value = dict.Find("Auth");
  if (auth_value) {
    {
      if (!(*auth_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*auth_value), &temp))
          return false;
        out->auth = std::move(temp);
      }
    }
  }

  const base::Value* auth_retry_value = dict.Find("AuthRetry");
  if (auth_retry_value) {
    {
      if (!(*auth_retry_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*auth_retry_value), &temp))
          return false;
        out->auth_retry = std::move(temp);
      }
    }
  }

  const base::Value* auth_no_cache_value = dict.Find("AuthNoCache");
  if (auth_no_cache_value) {
    {
      if (!(*auth_no_cache_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*auth_no_cache_value), &temp))
          return false;
        out->auth_no_cache = std::move(temp);
      }
    }
  }

  const base::Value* cipher_value = dict.Find("Cipher");
  if (cipher_value) {
    {
      if (!(*cipher_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*cipher_value), &temp))
          return false;
        out->cipher = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_pkcs11_id_value = dict.Find("ClientCertPKCS11Id");
  if (client_cert_pkcs11_id_value) {
    {
      if (!(*client_cert_pkcs11_id_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_pkcs11_id_value), &temp))
          return false;
        out->client_cert_pkcs11_id = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_pattern_value = dict.Find("ClientCertPattern");
  if (client_cert_pattern_value) {
    {
      if (!(*client_cert_pattern_value).is_dict()) {
        return false;
      }
      else {
        ManagedCertificatePattern temp;
        if (!ManagedCertificatePattern::Populate((*client_cert_pattern_value), &temp))
          return false;
        out->client_cert_pattern = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_provisioning_profile_id_value = dict.Find("ClientCertProvisioningProfileId");
  if (client_cert_provisioning_profile_id_value) {
    {
      if (!(*client_cert_provisioning_profile_id_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_provisioning_profile_id_value), &temp))
          return false;
        out->client_cert_provisioning_profile_id = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_ref_value = dict.Find("ClientCertRef");
  if (client_cert_ref_value) {
    {
      if (!(*client_cert_ref_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_ref_value), &temp))
          return false;
        out->client_cert_ref = std::move(temp);
      }
    }
  }

  const base::Value* client_cert_type_value = dict.Find("ClientCertType");
  if (client_cert_type_value) {
    {
      if (!(*client_cert_type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*client_cert_type_value), &temp))
          return false;
        out->client_cert_type = std::move(temp);
      }
    }
  }

  const base::Value* comp_lzo_value = dict.Find("CompLZO");
  if (comp_lzo_value) {
    {
      if (!(*comp_lzo_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*comp_lzo_value), &temp))
          return false;
        out->comp_lzo = std::move(temp);
      }
    }
  }

  const base::Value* comp_no_adapt_value = dict.Find("CompNoAdapt");
  if (comp_no_adapt_value) {
    {
      if (!(*comp_no_adapt_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*comp_no_adapt_value), &temp))
          return false;
        out->comp_no_adapt = std::move(temp);
      }
    }
  }

  const base::Value* extra_hosts_value = dict.Find("ExtraHosts");
  if (extra_hosts_value) {
    {
      if (!(*extra_hosts_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*extra_hosts_value), &temp))
          return false;
        out->extra_hosts = std::move(temp);
      }
    }
  }

  const base::Value* ignore_default_route_value = dict.Find("IgnoreDefaultRoute");
  if (ignore_default_route_value) {
    {
      if (!(*ignore_default_route_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*ignore_default_route_value), &temp))
          return false;
        out->ignore_default_route = std::move(temp);
      }
    }
  }

  const base::Value* key_direction_value = dict.Find("KeyDirection");
  if (key_direction_value) {
    {
      if (!(*key_direction_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*key_direction_value), &temp))
          return false;
        out->key_direction = std::move(temp);
      }
    }
  }

  const base::Value* ns_cert_type_value = dict.Find("NsCertType");
  if (ns_cert_type_value) {
    {
      if (!(*ns_cert_type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*ns_cert_type_value), &temp))
          return false;
        out->ns_cert_type = std::move(temp);
      }
    }
  }

  const base::Value* otp_value = dict.Find("OTP");
  if (otp_value) {
    {
      if (!(*otp_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*otp_value), &temp))
          return false;
        out->otp = std::move(temp);
      }
    }
  }

  const base::Value* password_value = dict.Find("Password");
  if (password_value) {
    {
      if (!(*password_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*password_value), &temp))
          return false;
        out->password = std::move(temp);
      }
    }
  }

  const base::Value* port_value = dict.Find("Port");
  if (port_value) {
    {
      if (!(*port_value).is_dict()) {
        return false;
      }
      else {
        ManagedLong temp;
        if (!ManagedLong::Populate((*port_value), &temp))
          return false;
        out->port = std::move(temp);
      }
    }
  }

  const base::Value* proto_value = dict.Find("Proto");
  if (proto_value) {
    {
      if (!(*proto_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*proto_value), &temp))
          return false;
        out->proto = std::move(temp);
      }
    }
  }

  const base::Value* push_peer_info_value = dict.Find("PushPeerInfo");
  if (push_peer_info_value) {
    {
      if (!(*push_peer_info_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*push_peer_info_value), &temp))
          return false;
        out->push_peer_info = std::move(temp);
      }
    }
  }

  const base::Value* remote_cert_eku_value = dict.Find("RemoteCertEKU");
  if (remote_cert_eku_value) {
    {
      if (!(*remote_cert_eku_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*remote_cert_eku_value), &temp))
          return false;
        out->remote_cert_eku = std::move(temp);
      }
    }
  }

  const base::Value* remote_cert_ku_value = dict.Find("RemoteCertKU");
  if (remote_cert_ku_value) {
    {
      if (!(*remote_cert_ku_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*remote_cert_ku_value), &temp))
          return false;
        out->remote_cert_ku = std::move(temp);
      }
    }
  }

  const base::Value* remote_cert_tls_value = dict.Find("RemoteCertTLS");
  if (remote_cert_tls_value) {
    {
      if (!(*remote_cert_tls_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*remote_cert_tls_value), &temp))
          return false;
        out->remote_cert_tls = std::move(temp);
      }
    }
  }

  const base::Value* reneg_sec_value = dict.Find("RenegSec");
  if (reneg_sec_value) {
    {
      if (!(*reneg_sec_value).is_dict()) {
        return false;
      }
      else {
        ManagedLong temp;
        if (!ManagedLong::Populate((*reneg_sec_value), &temp))
          return false;
        out->reneg_sec = std::move(temp);
      }
    }
  }

  const base::Value* save_credentials_value = dict.Find("SaveCredentials");
  if (save_credentials_value) {
    {
      if (!(*save_credentials_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*save_credentials_value), &temp))
          return false;
        out->save_credentials = std::move(temp);
      }
    }
  }

  const base::Value* server_cape_ms_value = dict.Find("ServerCAPEMs");
  if (server_cape_ms_value) {
    {
      if (!(*server_cape_ms_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*server_cape_ms_value), &temp))
          return false;
        out->server_cape_ms = std::move(temp);
      }
    }
  }

  const base::Value* server_ca_refs_value = dict.Find("ServerCARefs");
  if (server_ca_refs_value) {
    {
      if (!(*server_ca_refs_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMStringList temp;
        if (!ManagedDOMStringList::Populate((*server_ca_refs_value), &temp))
          return false;
        out->server_ca_refs = std::move(temp);
      }
    }
  }

  const base::Value* server_cert_ref_value = dict.Find("ServerCertRef");
  if (server_cert_ref_value) {
    {
      if (!(*server_cert_ref_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*server_cert_ref_value), &temp))
          return false;
        out->server_cert_ref = std::move(temp);
      }
    }
  }

  const base::Value* server_poll_timeout_value = dict.Find("ServerPollTimeout");
  if (server_poll_timeout_value) {
    {
      if (!(*server_poll_timeout_value).is_dict()) {
        return false;
      }
      else {
        ManagedLong temp;
        if (!ManagedLong::Populate((*server_poll_timeout_value), &temp))
          return false;
        out->server_poll_timeout = std::move(temp);
      }
    }
  }

  const base::Value* shaper_value = dict.Find("Shaper");
  if (shaper_value) {
    {
      if (!(*shaper_value).is_dict()) {
        return false;
      }
      else {
        ManagedLong temp;
        if (!ManagedLong::Populate((*shaper_value), &temp))
          return false;
        out->shaper = std::move(temp);
      }
    }
  }

  const base::Value* static_challenge_value = dict.Find("StaticChallenge");
  if (static_challenge_value) {
    {
      if (!(*static_challenge_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*static_challenge_value), &temp))
          return false;
        out->static_challenge = std::move(temp);
      }
    }
  }

  const base::Value* tls_auth_contents_value = dict.Find("TLSAuthContents");
  if (tls_auth_contents_value) {
    {
      if (!(*tls_auth_contents_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*tls_auth_contents_value), &temp))
          return false;
        out->tls_auth_contents = std::move(temp);
      }
    }
  }

  const base::Value* tls_remote_value = dict.Find("TLSRemote");
  if (tls_remote_value) {
    {
      if (!(*tls_remote_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*tls_remote_value), &temp))
          return false;
        out->tls_remote = std::move(temp);
      }
    }
  }

  const base::Value* tls_version_min_value = dict.Find("TLSVersionMin");
  if (tls_version_min_value) {
    {
      if (!(*tls_version_min_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*tls_version_min_value), &temp))
          return false;
        out->tls_version_min = std::move(temp);
      }
    }
  }

  const base::Value* user_authentication_type_value = dict.Find("UserAuthenticationType");
  if (user_authentication_type_value) {
    {
      if (!(*user_authentication_type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*user_authentication_type_value), &temp))
          return false;
        out->user_authentication_type = std::move(temp);
      }
    }
  }

  const base::Value* username_value = dict.Find("Username");
  if (username_value) {
    {
      if (!(*username_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*username_value), &temp))
          return false;
        out->username = std::move(temp);
      }
    }
  }

  const base::Value* verb_value = dict.Find("Verb");
  if (verb_value) {
    {
      if (!(*verb_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*verb_value), &temp))
          return false;
        out->verb = std::move(temp);
      }
    }
  }

  const base::Value* verify_hash_value = dict.Find("VerifyHash");
  if (verify_hash_value) {
    {
      if (!(*verify_hash_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*verify_hash_value), &temp))
          return false;
        out->verify_hash = std::move(temp);
      }
    }
  }

  const base::Value* verify_x509_value = dict.Find("VerifyX509");
  if (verify_x509_value) {
    {
      if (!(*verify_x509_value).is_dict()) {
        return false;
      }
      else {
        ManagedVerifyX509 temp;
        if (!ManagedVerifyX509::Populate((*verify_x509_value), &temp))
          return false;
        out->verify_x509 = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedOpenVPNProperties> ManagedOpenVPNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedOpenVPNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedOpenVPNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auth) {
    to_value_result.Set("Auth", (this->auth)->ToValue());

  }
  if (this->auth_retry) {
    to_value_result.Set("AuthRetry", (this->auth_retry)->ToValue());

  }
  if (this->auth_no_cache) {
    to_value_result.Set("AuthNoCache", (this->auth_no_cache)->ToValue());

  }
  if (this->cipher) {
    to_value_result.Set("Cipher", (this->cipher)->ToValue());

  }
  if (this->client_cert_pkcs11_id) {
    to_value_result.Set("ClientCertPKCS11Id", (this->client_cert_pkcs11_id)->ToValue());

  }
  if (this->client_cert_pattern) {
    to_value_result.Set("ClientCertPattern", (this->client_cert_pattern)->ToValue());

  }
  if (this->client_cert_provisioning_profile_id) {
    to_value_result.Set("ClientCertProvisioningProfileId", (this->client_cert_provisioning_profile_id)->ToValue());

  }
  if (this->client_cert_ref) {
    to_value_result.Set("ClientCertRef", (this->client_cert_ref)->ToValue());

  }
  if (this->client_cert_type) {
    to_value_result.Set("ClientCertType", (this->client_cert_type)->ToValue());

  }
  if (this->comp_lzo) {
    to_value_result.Set("CompLZO", (this->comp_lzo)->ToValue());

  }
  if (this->comp_no_adapt) {
    to_value_result.Set("CompNoAdapt", (this->comp_no_adapt)->ToValue());

  }
  if (this->extra_hosts) {
    to_value_result.Set("ExtraHosts", (this->extra_hosts)->ToValue());

  }
  if (this->ignore_default_route) {
    to_value_result.Set("IgnoreDefaultRoute", (this->ignore_default_route)->ToValue());

  }
  if (this->key_direction) {
    to_value_result.Set("KeyDirection", (this->key_direction)->ToValue());

  }
  if (this->ns_cert_type) {
    to_value_result.Set("NsCertType", (this->ns_cert_type)->ToValue());

  }
  if (this->otp) {
    to_value_result.Set("OTP", (this->otp)->ToValue());

  }
  if (this->password) {
    to_value_result.Set("Password", (this->password)->ToValue());

  }
  if (this->port) {
    to_value_result.Set("Port", (this->port)->ToValue());

  }
  if (this->proto) {
    to_value_result.Set("Proto", (this->proto)->ToValue());

  }
  if (this->push_peer_info) {
    to_value_result.Set("PushPeerInfo", (this->push_peer_info)->ToValue());

  }
  if (this->remote_cert_eku) {
    to_value_result.Set("RemoteCertEKU", (this->remote_cert_eku)->ToValue());

  }
  if (this->remote_cert_ku) {
    to_value_result.Set("RemoteCertKU", (this->remote_cert_ku)->ToValue());

  }
  if (this->remote_cert_tls) {
    to_value_result.Set("RemoteCertTLS", (this->remote_cert_tls)->ToValue());

  }
  if (this->reneg_sec) {
    to_value_result.Set("RenegSec", (this->reneg_sec)->ToValue());

  }
  if (this->save_credentials) {
    to_value_result.Set("SaveCredentials", (this->save_credentials)->ToValue());

  }
  if (this->server_cape_ms) {
    to_value_result.Set("ServerCAPEMs", (this->server_cape_ms)->ToValue());

  }
  if (this->server_ca_refs) {
    to_value_result.Set("ServerCARefs", (this->server_ca_refs)->ToValue());

  }
  if (this->server_cert_ref) {
    to_value_result.Set("ServerCertRef", (this->server_cert_ref)->ToValue());

  }
  if (this->server_poll_timeout) {
    to_value_result.Set("ServerPollTimeout", (this->server_poll_timeout)->ToValue());

  }
  if (this->shaper) {
    to_value_result.Set("Shaper", (this->shaper)->ToValue());

  }
  if (this->static_challenge) {
    to_value_result.Set("StaticChallenge", (this->static_challenge)->ToValue());

  }
  if (this->tls_auth_contents) {
    to_value_result.Set("TLSAuthContents", (this->tls_auth_contents)->ToValue());

  }
  if (this->tls_remote) {
    to_value_result.Set("TLSRemote", (this->tls_remote)->ToValue());

  }
  if (this->tls_version_min) {
    to_value_result.Set("TLSVersionMin", (this->tls_version_min)->ToValue());

  }
  if (this->user_authentication_type) {
    to_value_result.Set("UserAuthenticationType", (this->user_authentication_type)->ToValue());

  }
  if (this->username) {
    to_value_result.Set("Username", (this->username)->ToValue());

  }
  if (this->verb) {
    to_value_result.Set("Verb", (this->verb)->ToValue());

  }
  if (this->verify_hash) {
    to_value_result.Set("VerifyHash", (this->verify_hash)->ToValue());

  }
  if (this->verify_x509) {
    to_value_result.Set("VerifyX509", (this->verify_x509)->ToValue());

  }

  return to_value_result;
}


SIMLockStatus::SIMLockStatus()
: lock_enabled(false) {}

SIMLockStatus::~SIMLockStatus() = default;
SIMLockStatus::SIMLockStatus(SIMLockStatus&& rhs) = default;
SIMLockStatus& SIMLockStatus::operator=(SIMLockStatus&& rhs) = default;
// static
bool SIMLockStatus::Populate(
    const base::Value& value, SIMLockStatus* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* lock_type_value = dict.Find("LockType");
  if (!lock_type_value) {
    return false;
  }
  {
    auto* temp = (*lock_type_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->lock_type = *temp;
  }

  const base::Value* lock_enabled_value = dict.Find("LockEnabled");
  if (!lock_enabled_value) {
    return false;
  }
  {
    auto temp = (*lock_enabled_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->lock_enabled = *temp;
  }

  const base::Value* retries_left_value = dict.Find("RetriesLeft");
  if (retries_left_value) {
    {
      auto temp = (*retries_left_value).GetIfInt();
      if (!temp.has_value()) {
        out->retries_left = absl::nullopt;
        return false;
      }
      out->retries_left = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<SIMLockStatus> SIMLockStatus::FromValue(const base::Value& value) {
  auto out = std::make_unique<SIMLockStatus>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict SIMLockStatus::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("LockType", this->lock_type);

  to_value_result.Set("LockEnabled", this->lock_enabled);

  if (this->retries_left) {
    to_value_result.Set("RetriesLeft", *this->retries_left);

  }

  return to_value_result;
}


ThirdPartyVPNProperties::ThirdPartyVPNProperties()
 {}

ThirdPartyVPNProperties::~ThirdPartyVPNProperties() = default;
ThirdPartyVPNProperties::ThirdPartyVPNProperties(ThirdPartyVPNProperties&& rhs) = default;
ThirdPartyVPNProperties& ThirdPartyVPNProperties::operator=(ThirdPartyVPNProperties&& rhs) = default;
// static
bool ThirdPartyVPNProperties::Populate(
    const base::Value& value, ThirdPartyVPNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* extension_id_value = dict.Find("ExtensionID");
  if (!extension_id_value) {
    return false;
  }
  {
    auto* temp = (*extension_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->extension_id = *temp;
  }

  const base::Value* provider_name_value = dict.Find("ProviderName");
  if (provider_name_value) {
    {
      auto* temp = (*provider_name_value).GetIfString();
      if (!temp) {
        out->provider_name = absl::nullopt;
        return false;
      }
      out->provider_name = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ThirdPartyVPNProperties> ThirdPartyVPNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ThirdPartyVPNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ThirdPartyVPNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("ExtensionID", this->extension_id);

  if (this->provider_name) {
    to_value_result.Set("ProviderName", *this->provider_name);

  }

  return to_value_result;
}


ManagedThirdPartyVPNProperties::ManagedThirdPartyVPNProperties()
 {}

ManagedThirdPartyVPNProperties::~ManagedThirdPartyVPNProperties() = default;
ManagedThirdPartyVPNProperties::ManagedThirdPartyVPNProperties(ManagedThirdPartyVPNProperties&& rhs) = default;
ManagedThirdPartyVPNProperties& ManagedThirdPartyVPNProperties::operator=(ManagedThirdPartyVPNProperties&& rhs) = default;
// static
bool ManagedThirdPartyVPNProperties::Populate(
    const base::Value& value, ManagedThirdPartyVPNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* extension_id_value = dict.Find("ExtensionID");
  if (!extension_id_value) {
    return false;
  }
  {
    if (!(*extension_id_value).is_dict()) {
      return false;
    }
    if (!ManagedDOMString::Populate((*extension_id_value), &out->extension_id)) {
      return false;
    }
  }

  const base::Value* provider_name_value = dict.Find("ProviderName");
  if (provider_name_value) {
    {
      auto* temp = (*provider_name_value).GetIfString();
      if (!temp) {
        out->provider_name = absl::nullopt;
        return false;
      }
      out->provider_name = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedThirdPartyVPNProperties> ManagedThirdPartyVPNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedThirdPartyVPNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedThirdPartyVPNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("ExtensionID", (this->extension_id).ToValue());

  if (this->provider_name) {
    to_value_result.Set("ProviderName", *this->provider_name);

  }

  return to_value_result;
}


CellularProperties::CellularProperties()
: activation_state(ACTIVATION_STATE_TYPE_NONE) {}

CellularProperties::~CellularProperties() = default;
CellularProperties::CellularProperties(CellularProperties&& rhs) = default;
CellularProperties& CellularProperties::operator=(CellularProperties&& rhs) = default;
// static
bool CellularProperties::Populate(
    const base::Value& value, CellularProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->activation_state = ACTIVATION_STATE_TYPE_NONE;
  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      auto temp = (*auto_connect_value).GetIfBool();
      if (!temp.has_value()) {
        out->auto_connect = absl::nullopt;
        return false;
      }
      out->auto_connect = *temp;
    }
  }

  const base::Value* apn_value = dict.Find("APN");
  if (apn_value) {
    {
      if (!(*apn_value).is_dict()) {
        return false;
      }
      else {
        APNProperties temp;
        if (!APNProperties::Populate((*apn_value), &temp))
          return false;
        out->apn = std::move(temp);
      }
    }
  }

  const base::Value* apn_list_value = dict.Find("APNList");
  if (apn_list_value) {
    {
      if (!(*apn_list_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*apn_list_value).GetList(), &out->apn_list)) {
          return false;
        }
      }
    }
  }

  const base::Value* activation_type_value = dict.Find("ActivationType");
  if (activation_type_value) {
    {
      auto* temp = (*activation_type_value).GetIfString();
      if (!temp) {
        out->activation_type = absl::nullopt;
        return false;
      }
      out->activation_type = *temp;
    }
  }

  const base::Value* activation_state_value = dict.Find("ActivationState");
  if (activation_state_value) {
    {
      const std::string* activation_state_type_as_string = (*activation_state_value).GetIfString();
      if (!activation_state_type_as_string) {
        return false;
      }
      out->activation_state = ParseActivationStateType(*activation_state_type_as_string);
      if (out->activation_state == ACTIVATION_STATE_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->activation_state = ACTIVATION_STATE_TYPE_NONE;
  }

  const base::Value* allow_roaming_value = dict.Find("AllowRoaming");
  if (allow_roaming_value) {
    {
      auto temp = (*allow_roaming_value).GetIfBool();
      if (!temp.has_value()) {
        out->allow_roaming = absl::nullopt;
        return false;
      }
      out->allow_roaming = *temp;
    }
  }

  const base::Value* esn_value = dict.Find("ESN");
  if (esn_value) {
    {
      auto* temp = (*esn_value).GetIfString();
      if (!temp) {
        out->esn = absl::nullopt;
        return false;
      }
      out->esn = *temp;
    }
  }

  const base::Value* family_value = dict.Find("Family");
  if (family_value) {
    {
      auto* temp = (*family_value).GetIfString();
      if (!temp) {
        out->family = absl::nullopt;
        return false;
      }
      out->family = *temp;
    }
  }

  const base::Value* firmware_revision_value = dict.Find("FirmwareRevision");
  if (firmware_revision_value) {
    {
      auto* temp = (*firmware_revision_value).GetIfString();
      if (!temp) {
        out->firmware_revision = absl::nullopt;
        return false;
      }
      out->firmware_revision = *temp;
    }
  }

  const base::Value* found_networks_value = dict.Find("FoundNetworks");
  if (found_networks_value) {
    {
      if (!(*found_networks_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*found_networks_value).GetList(), &out->found_networks)) {
          return false;
        }
      }
    }
  }

  const base::Value* hardware_revision_value = dict.Find("HardwareRevision");
  if (hardware_revision_value) {
    {
      auto* temp = (*hardware_revision_value).GetIfString();
      if (!temp) {
        out->hardware_revision = absl::nullopt;
        return false;
      }
      out->hardware_revision = *temp;
    }
  }

  const base::Value* home_provider_value = dict.Find("HomeProvider");
  if (home_provider_value) {
    {
      if (!(*home_provider_value).is_dict()) {
        return false;
      }
      else {
        CellularProviderProperties temp;
        if (!CellularProviderProperties::Populate((*home_provider_value), &temp))
          return false;
        out->home_provider = std::move(temp);
      }
    }
  }

  const base::Value* iccid_value = dict.Find("ICCID");
  if (iccid_value) {
    {
      auto* temp = (*iccid_value).GetIfString();
      if (!temp) {
        out->iccid = absl::nullopt;
        return false;
      }
      out->iccid = *temp;
    }
  }

  const base::Value* imei_value = dict.Find("IMEI");
  if (imei_value) {
    {
      auto* temp = (*imei_value).GetIfString();
      if (!temp) {
        out->imei = absl::nullopt;
        return false;
      }
      out->imei = *temp;
    }
  }

  const base::Value* last_good_apn_value = dict.Find("LastGoodAPN");
  if (last_good_apn_value) {
    {
      if (!(*last_good_apn_value).is_dict()) {
        return false;
      }
      else {
        APNProperties temp;
        if (!APNProperties::Populate((*last_good_apn_value), &temp))
          return false;
        out->last_good_apn = std::move(temp);
      }
    }
  }

  const base::Value* manufacturer_value = dict.Find("Manufacturer");
  if (manufacturer_value) {
    {
      auto* temp = (*manufacturer_value).GetIfString();
      if (!temp) {
        out->manufacturer = absl::nullopt;
        return false;
      }
      out->manufacturer = *temp;
    }
  }

  const base::Value* mdn_value = dict.Find("MDN");
  if (mdn_value) {
    {
      auto* temp = (*mdn_value).GetIfString();
      if (!temp) {
        out->mdn = absl::nullopt;
        return false;
      }
      out->mdn = *temp;
    }
  }

  const base::Value* meid_value = dict.Find("MEID");
  if (meid_value) {
    {
      auto* temp = (*meid_value).GetIfString();
      if (!temp) {
        out->meid = absl::nullopt;
        return false;
      }
      out->meid = *temp;
    }
  }

  const base::Value* min_value = dict.Find("MIN");
  if (min_value) {
    {
      auto* temp = (*min_value).GetIfString();
      if (!temp) {
        out->min = absl::nullopt;
        return false;
      }
      out->min = *temp;
    }
  }

  const base::Value* model_id_value = dict.Find("ModelID");
  if (model_id_value) {
    {
      auto* temp = (*model_id_value).GetIfString();
      if (!temp) {
        out->model_id = absl::nullopt;
        return false;
      }
      out->model_id = *temp;
    }
  }

  const base::Value* network_technology_value = dict.Find("NetworkTechnology");
  if (network_technology_value) {
    {
      auto* temp = (*network_technology_value).GetIfString();
      if (!temp) {
        out->network_technology = absl::nullopt;
        return false;
      }
      out->network_technology = *temp;
    }
  }

  const base::Value* payment_portal_value = dict.Find("PaymentPortal");
  if (payment_portal_value) {
    {
      if (!(*payment_portal_value).is_dict()) {
        return false;
      }
      else {
        PaymentPortal temp;
        if (!PaymentPortal::Populate((*payment_portal_value), &temp))
          return false;
        out->payment_portal = std::move(temp);
      }
    }
  }

  const base::Value* roaming_state_value = dict.Find("RoamingState");
  if (roaming_state_value) {
    {
      auto* temp = (*roaming_state_value).GetIfString();
      if (!temp) {
        out->roaming_state = absl::nullopt;
        return false;
      }
      out->roaming_state = *temp;
    }
  }

  const base::Value* scanning_value = dict.Find("Scanning");
  if (scanning_value) {
    {
      auto temp = (*scanning_value).GetIfBool();
      if (!temp.has_value()) {
        out->scanning = absl::nullopt;
        return false;
      }
      out->scanning = *temp;
    }
  }

  const base::Value* serving_operator_value = dict.Find("ServingOperator");
  if (serving_operator_value) {
    {
      if (!(*serving_operator_value).is_dict()) {
        return false;
      }
      else {
        CellularProviderProperties temp;
        if (!CellularProviderProperties::Populate((*serving_operator_value), &temp))
          return false;
        out->serving_operator = std::move(temp);
      }
    }
  }

  const base::Value* sim_lock_status_value = dict.Find("SIMLockStatus");
  if (sim_lock_status_value) {
    {
      if (!(*sim_lock_status_value).is_dict()) {
        return false;
      }
      else {
        SIMLockStatus temp;
        if (!SIMLockStatus::Populate((*sim_lock_status_value), &temp))
          return false;
        out->sim_lock_status = std::move(temp);
      }
    }
  }

  const base::Value* sim_present_value = dict.Find("SIMPresent");
  if (sim_present_value) {
    {
      auto temp = (*sim_present_value).GetIfBool();
      if (!temp.has_value()) {
        out->sim_present = absl::nullopt;
        return false;
      }
      out->sim_present = *temp;
    }
  }

  const base::Value* signal_strength_value = dict.Find("SignalStrength");
  if (signal_strength_value) {
    {
      auto temp = (*signal_strength_value).GetIfInt();
      if (!temp.has_value()) {
        out->signal_strength = absl::nullopt;
        return false;
      }
      out->signal_strength = *temp;
    }
  }

  const base::Value* support_network_scan_value = dict.Find("SupportNetworkScan");
  if (support_network_scan_value) {
    {
      auto temp = (*support_network_scan_value).GetIfBool();
      if (!temp.has_value()) {
        out->support_network_scan = absl::nullopt;
        return false;
      }
      out->support_network_scan = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<CellularProperties> CellularProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<CellularProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict CellularProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", *this->auto_connect);

  }
  if (this->apn) {
    to_value_result.Set("APN", (this->apn)->ToValue());

  }
  if (this->apn_list) {
    to_value_result.Set("APNList", json_schema_compiler::util::CreateValueFromArray(*this->apn_list));

  }
  if (this->activation_type) {
    to_value_result.Set("ActivationType", *this->activation_type);

  }
  if (this->activation_state != ACTIVATION_STATE_TYPE_NONE) {
    to_value_result.Set("ActivationState", networking_private::ToString(this->activation_state));

  }
  if (this->allow_roaming) {
    to_value_result.Set("AllowRoaming", *this->allow_roaming);

  }
  if (this->esn) {
    to_value_result.Set("ESN", *this->esn);

  }
  if (this->family) {
    to_value_result.Set("Family", *this->family);

  }
  if (this->firmware_revision) {
    to_value_result.Set("FirmwareRevision", *this->firmware_revision);

  }
  if (this->found_networks) {
    to_value_result.Set("FoundNetworks", json_schema_compiler::util::CreateValueFromArray(*this->found_networks));

  }
  if (this->hardware_revision) {
    to_value_result.Set("HardwareRevision", *this->hardware_revision);

  }
  if (this->home_provider) {
    to_value_result.Set("HomeProvider", (this->home_provider)->ToValue());

  }
  if (this->iccid) {
    to_value_result.Set("ICCID", *this->iccid);

  }
  if (this->imei) {
    to_value_result.Set("IMEI", *this->imei);

  }
  if (this->last_good_apn) {
    to_value_result.Set("LastGoodAPN", (this->last_good_apn)->ToValue());

  }
  if (this->manufacturer) {
    to_value_result.Set("Manufacturer", *this->manufacturer);

  }
  if (this->mdn) {
    to_value_result.Set("MDN", *this->mdn);

  }
  if (this->meid) {
    to_value_result.Set("MEID", *this->meid);

  }
  if (this->min) {
    to_value_result.Set("MIN", *this->min);

  }
  if (this->model_id) {
    to_value_result.Set("ModelID", *this->model_id);

  }
  if (this->network_technology) {
    to_value_result.Set("NetworkTechnology", *this->network_technology);

  }
  if (this->payment_portal) {
    to_value_result.Set("PaymentPortal", (this->payment_portal)->ToValue());

  }
  if (this->roaming_state) {
    to_value_result.Set("RoamingState", *this->roaming_state);

  }
  if (this->scanning) {
    to_value_result.Set("Scanning", *this->scanning);

  }
  if (this->serving_operator) {
    to_value_result.Set("ServingOperator", (this->serving_operator)->ToValue());

  }
  if (this->sim_lock_status) {
    to_value_result.Set("SIMLockStatus", (this->sim_lock_status)->ToValue());

  }
  if (this->sim_present) {
    to_value_result.Set("SIMPresent", *this->sim_present);

  }
  if (this->signal_strength) {
    to_value_result.Set("SignalStrength", *this->signal_strength);

  }
  if (this->support_network_scan) {
    to_value_result.Set("SupportNetworkScan", *this->support_network_scan);

  }

  return to_value_result;
}


ManagedCellularProperties::ManagedCellularProperties()
: activation_state(ACTIVATION_STATE_TYPE_NONE) {}

ManagedCellularProperties::~ManagedCellularProperties() = default;
ManagedCellularProperties::ManagedCellularProperties(ManagedCellularProperties&& rhs) = default;
ManagedCellularProperties& ManagedCellularProperties::operator=(ManagedCellularProperties&& rhs) = default;
// static
bool ManagedCellularProperties::Populate(
    const base::Value& value, ManagedCellularProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->activation_state = ACTIVATION_STATE_TYPE_NONE;
  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      if (!(*auto_connect_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*auto_connect_value), &temp))
          return false;
        out->auto_connect = std::move(temp);
      }
    }
  }

  const base::Value* apn_value = dict.Find("APN");
  if (apn_value) {
    {
      if (!(*apn_value).is_dict()) {
        return false;
      }
      else {
        ManagedAPNProperties temp;
        if (!ManagedAPNProperties::Populate((*apn_value), &temp))
          return false;
        out->apn = std::move(temp);
      }
    }
  }

  const base::Value* apn_list_value = dict.Find("APNList");
  if (apn_list_value) {
    {
      if (!(*apn_list_value).is_dict()) {
        return false;
      }
      else {
        ManagedAPNList temp;
        if (!ManagedAPNList::Populate((*apn_list_value), &temp))
          return false;
        out->apn_list = std::move(temp);
      }
    }
  }

  const base::Value* activation_type_value = dict.Find("ActivationType");
  if (activation_type_value) {
    {
      auto* temp = (*activation_type_value).GetIfString();
      if (!temp) {
        out->activation_type = absl::nullopt;
        return false;
      }
      out->activation_type = *temp;
    }
  }

  const base::Value* activation_state_value = dict.Find("ActivationState");
  if (activation_state_value) {
    {
      const std::string* activation_state_type_as_string = (*activation_state_value).GetIfString();
      if (!activation_state_type_as_string) {
        return false;
      }
      out->activation_state = ParseActivationStateType(*activation_state_type_as_string);
      if (out->activation_state == ACTIVATION_STATE_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->activation_state = ACTIVATION_STATE_TYPE_NONE;
  }

  const base::Value* allow_roaming_value = dict.Find("AllowRoaming");
  if (allow_roaming_value) {
    {
      auto temp = (*allow_roaming_value).GetIfBool();
      if (!temp.has_value()) {
        out->allow_roaming = absl::nullopt;
        return false;
      }
      out->allow_roaming = *temp;
    }
  }

  const base::Value* esn_value = dict.Find("ESN");
  if (esn_value) {
    {
      auto* temp = (*esn_value).GetIfString();
      if (!temp) {
        out->esn = absl::nullopt;
        return false;
      }
      out->esn = *temp;
    }
  }

  const base::Value* family_value = dict.Find("Family");
  if (family_value) {
    {
      auto* temp = (*family_value).GetIfString();
      if (!temp) {
        out->family = absl::nullopt;
        return false;
      }
      out->family = *temp;
    }
  }

  const base::Value* firmware_revision_value = dict.Find("FirmwareRevision");
  if (firmware_revision_value) {
    {
      auto* temp = (*firmware_revision_value).GetIfString();
      if (!temp) {
        out->firmware_revision = absl::nullopt;
        return false;
      }
      out->firmware_revision = *temp;
    }
  }

  const base::Value* found_networks_value = dict.Find("FoundNetworks");
  if (found_networks_value) {
    {
      if (!(*found_networks_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*found_networks_value).GetList(), &out->found_networks)) {
          return false;
        }
      }
    }
  }

  const base::Value* hardware_revision_value = dict.Find("HardwareRevision");
  if (hardware_revision_value) {
    {
      auto* temp = (*hardware_revision_value).GetIfString();
      if (!temp) {
        out->hardware_revision = absl::nullopt;
        return false;
      }
      out->hardware_revision = *temp;
    }
  }

  const base::Value* home_provider_value = dict.Find("HomeProvider");
  if (home_provider_value) {
    {
      if (!(*home_provider_value).is_dict()) {
        return false;
      }
      else {
        CellularProviderProperties temp;
        if (!CellularProviderProperties::Populate((*home_provider_value), &temp))
          return false;
        out->home_provider = std::move(temp);
      }
    }
  }

  const base::Value* iccid_value = dict.Find("ICCID");
  if (iccid_value) {
    {
      auto* temp = (*iccid_value).GetIfString();
      if (!temp) {
        out->iccid = absl::nullopt;
        return false;
      }
      out->iccid = *temp;
    }
  }

  const base::Value* imei_value = dict.Find("IMEI");
  if (imei_value) {
    {
      auto* temp = (*imei_value).GetIfString();
      if (!temp) {
        out->imei = absl::nullopt;
        return false;
      }
      out->imei = *temp;
    }
  }

  const base::Value* last_good_apn_value = dict.Find("LastGoodAPN");
  if (last_good_apn_value) {
    {
      if (!(*last_good_apn_value).is_dict()) {
        return false;
      }
      else {
        APNProperties temp;
        if (!APNProperties::Populate((*last_good_apn_value), &temp))
          return false;
        out->last_good_apn = std::move(temp);
      }
    }
  }

  const base::Value* manufacturer_value = dict.Find("Manufacturer");
  if (manufacturer_value) {
    {
      auto* temp = (*manufacturer_value).GetIfString();
      if (!temp) {
        out->manufacturer = absl::nullopt;
        return false;
      }
      out->manufacturer = *temp;
    }
  }

  const base::Value* mdn_value = dict.Find("MDN");
  if (mdn_value) {
    {
      auto* temp = (*mdn_value).GetIfString();
      if (!temp) {
        out->mdn = absl::nullopt;
        return false;
      }
      out->mdn = *temp;
    }
  }

  const base::Value* meid_value = dict.Find("MEID");
  if (meid_value) {
    {
      auto* temp = (*meid_value).GetIfString();
      if (!temp) {
        out->meid = absl::nullopt;
        return false;
      }
      out->meid = *temp;
    }
  }

  const base::Value* min_value = dict.Find("MIN");
  if (min_value) {
    {
      auto* temp = (*min_value).GetIfString();
      if (!temp) {
        out->min = absl::nullopt;
        return false;
      }
      out->min = *temp;
    }
  }

  const base::Value* model_id_value = dict.Find("ModelID");
  if (model_id_value) {
    {
      auto* temp = (*model_id_value).GetIfString();
      if (!temp) {
        out->model_id = absl::nullopt;
        return false;
      }
      out->model_id = *temp;
    }
  }

  const base::Value* network_technology_value = dict.Find("NetworkTechnology");
  if (network_technology_value) {
    {
      auto* temp = (*network_technology_value).GetIfString();
      if (!temp) {
        out->network_technology = absl::nullopt;
        return false;
      }
      out->network_technology = *temp;
    }
  }

  const base::Value* payment_portal_value = dict.Find("PaymentPortal");
  if (payment_portal_value) {
    {
      if (!(*payment_portal_value).is_dict()) {
        return false;
      }
      else {
        PaymentPortal temp;
        if (!PaymentPortal::Populate((*payment_portal_value), &temp))
          return false;
        out->payment_portal = std::move(temp);
      }
    }
  }

  const base::Value* roaming_state_value = dict.Find("RoamingState");
  if (roaming_state_value) {
    {
      auto* temp = (*roaming_state_value).GetIfString();
      if (!temp) {
        out->roaming_state = absl::nullopt;
        return false;
      }
      out->roaming_state = *temp;
    }
  }

  const base::Value* scanning_value = dict.Find("Scanning");
  if (scanning_value) {
    {
      auto temp = (*scanning_value).GetIfBool();
      if (!temp.has_value()) {
        out->scanning = absl::nullopt;
        return false;
      }
      out->scanning = *temp;
    }
  }

  const base::Value* serving_operator_value = dict.Find("ServingOperator");
  if (serving_operator_value) {
    {
      if (!(*serving_operator_value).is_dict()) {
        return false;
      }
      else {
        CellularProviderProperties temp;
        if (!CellularProviderProperties::Populate((*serving_operator_value), &temp))
          return false;
        out->serving_operator = std::move(temp);
      }
    }
  }

  const base::Value* sim_lock_status_value = dict.Find("SIMLockStatus");
  if (sim_lock_status_value) {
    {
      if (!(*sim_lock_status_value).is_dict()) {
        return false;
      }
      else {
        SIMLockStatus temp;
        if (!SIMLockStatus::Populate((*sim_lock_status_value), &temp))
          return false;
        out->sim_lock_status = std::move(temp);
      }
    }
  }

  const base::Value* sim_present_value = dict.Find("SIMPresent");
  if (sim_present_value) {
    {
      auto temp = (*sim_present_value).GetIfBool();
      if (!temp.has_value()) {
        out->sim_present = absl::nullopt;
        return false;
      }
      out->sim_present = *temp;
    }
  }

  const base::Value* signal_strength_value = dict.Find("SignalStrength");
  if (signal_strength_value) {
    {
      auto temp = (*signal_strength_value).GetIfInt();
      if (!temp.has_value()) {
        out->signal_strength = absl::nullopt;
        return false;
      }
      out->signal_strength = *temp;
    }
  }

  const base::Value* support_network_scan_value = dict.Find("SupportNetworkScan");
  if (support_network_scan_value) {
    {
      auto temp = (*support_network_scan_value).GetIfBool();
      if (!temp.has_value()) {
        out->support_network_scan = absl::nullopt;
        return false;
      }
      out->support_network_scan = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedCellularProperties> ManagedCellularProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedCellularProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedCellularProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", (this->auto_connect)->ToValue());

  }
  if (this->apn) {
    to_value_result.Set("APN", (this->apn)->ToValue());

  }
  if (this->apn_list) {
    to_value_result.Set("APNList", (this->apn_list)->ToValue());

  }
  if (this->activation_type) {
    to_value_result.Set("ActivationType", *this->activation_type);

  }
  if (this->activation_state != ACTIVATION_STATE_TYPE_NONE) {
    to_value_result.Set("ActivationState", networking_private::ToString(this->activation_state));

  }
  if (this->allow_roaming) {
    to_value_result.Set("AllowRoaming", *this->allow_roaming);

  }
  if (this->esn) {
    to_value_result.Set("ESN", *this->esn);

  }
  if (this->family) {
    to_value_result.Set("Family", *this->family);

  }
  if (this->firmware_revision) {
    to_value_result.Set("FirmwareRevision", *this->firmware_revision);

  }
  if (this->found_networks) {
    to_value_result.Set("FoundNetworks", json_schema_compiler::util::CreateValueFromArray(*this->found_networks));

  }
  if (this->hardware_revision) {
    to_value_result.Set("HardwareRevision", *this->hardware_revision);

  }
  if (this->home_provider) {
    to_value_result.Set("HomeProvider", (this->home_provider)->ToValue());

  }
  if (this->iccid) {
    to_value_result.Set("ICCID", *this->iccid);

  }
  if (this->imei) {
    to_value_result.Set("IMEI", *this->imei);

  }
  if (this->last_good_apn) {
    to_value_result.Set("LastGoodAPN", (this->last_good_apn)->ToValue());

  }
  if (this->manufacturer) {
    to_value_result.Set("Manufacturer", *this->manufacturer);

  }
  if (this->mdn) {
    to_value_result.Set("MDN", *this->mdn);

  }
  if (this->meid) {
    to_value_result.Set("MEID", *this->meid);

  }
  if (this->min) {
    to_value_result.Set("MIN", *this->min);

  }
  if (this->model_id) {
    to_value_result.Set("ModelID", *this->model_id);

  }
  if (this->network_technology) {
    to_value_result.Set("NetworkTechnology", *this->network_technology);

  }
  if (this->payment_portal) {
    to_value_result.Set("PaymentPortal", (this->payment_portal)->ToValue());

  }
  if (this->roaming_state) {
    to_value_result.Set("RoamingState", *this->roaming_state);

  }
  if (this->scanning) {
    to_value_result.Set("Scanning", *this->scanning);

  }
  if (this->serving_operator) {
    to_value_result.Set("ServingOperator", (this->serving_operator)->ToValue());

  }
  if (this->sim_lock_status) {
    to_value_result.Set("SIMLockStatus", (this->sim_lock_status)->ToValue());

  }
  if (this->sim_present) {
    to_value_result.Set("SIMPresent", *this->sim_present);

  }
  if (this->signal_strength) {
    to_value_result.Set("SignalStrength", *this->signal_strength);

  }
  if (this->support_network_scan) {
    to_value_result.Set("SupportNetworkScan", *this->support_network_scan);

  }

  return to_value_result;
}


CellularStateProperties::CellularStateProperties()
: activation_state(ACTIVATION_STATE_TYPE_NONE) {}

CellularStateProperties::~CellularStateProperties() = default;
CellularStateProperties::CellularStateProperties(CellularStateProperties&& rhs) = default;
CellularStateProperties& CellularStateProperties::operator=(CellularStateProperties&& rhs) = default;
// static
bool CellularStateProperties::Populate(
    const base::Value& value, CellularStateProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->activation_state = ACTIVATION_STATE_TYPE_NONE;
  const base::Value* activation_state_value = dict.Find("ActivationState");
  if (activation_state_value) {
    {
      const std::string* activation_state_type_as_string = (*activation_state_value).GetIfString();
      if (!activation_state_type_as_string) {
        return false;
      }
      out->activation_state = ParseActivationStateType(*activation_state_type_as_string);
      if (out->activation_state == ACTIVATION_STATE_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->activation_state = ACTIVATION_STATE_TYPE_NONE;
  }

  const base::Value* eid_value = dict.Find("EID");
  if (eid_value) {
    {
      auto* temp = (*eid_value).GetIfString();
      if (!temp) {
        out->eid = absl::nullopt;
        return false;
      }
      out->eid = *temp;
    }
  }

  const base::Value* iccid_value = dict.Find("ICCID");
  if (iccid_value) {
    {
      auto* temp = (*iccid_value).GetIfString();
      if (!temp) {
        out->iccid = absl::nullopt;
        return false;
      }
      out->iccid = *temp;
    }
  }

  const base::Value* network_technology_value = dict.Find("NetworkTechnology");
  if (network_technology_value) {
    {
      auto* temp = (*network_technology_value).GetIfString();
      if (!temp) {
        out->network_technology = absl::nullopt;
        return false;
      }
      out->network_technology = *temp;
    }
  }

  const base::Value* roaming_state_value = dict.Find("RoamingState");
  if (roaming_state_value) {
    {
      auto* temp = (*roaming_state_value).GetIfString();
      if (!temp) {
        out->roaming_state = absl::nullopt;
        return false;
      }
      out->roaming_state = *temp;
    }
  }

  const base::Value* scanning_value = dict.Find("Scanning");
  if (scanning_value) {
    {
      auto temp = (*scanning_value).GetIfBool();
      if (!temp.has_value()) {
        out->scanning = absl::nullopt;
        return false;
      }
      out->scanning = *temp;
    }
  }

  const base::Value* sim_present_value = dict.Find("SIMPresent");
  if (sim_present_value) {
    {
      auto temp = (*sim_present_value).GetIfBool();
      if (!temp.has_value()) {
        out->sim_present = absl::nullopt;
        return false;
      }
      out->sim_present = *temp;
    }
  }

  const base::Value* signal_strength_value = dict.Find("SignalStrength");
  if (signal_strength_value) {
    {
      auto temp = (*signal_strength_value).GetIfInt();
      if (!temp.has_value()) {
        out->signal_strength = absl::nullopt;
        return false;
      }
      out->signal_strength = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<CellularStateProperties> CellularStateProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<CellularStateProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict CellularStateProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->activation_state != ACTIVATION_STATE_TYPE_NONE) {
    to_value_result.Set("ActivationState", networking_private::ToString(this->activation_state));

  }
  if (this->eid) {
    to_value_result.Set("EID", *this->eid);

  }
  if (this->iccid) {
    to_value_result.Set("ICCID", *this->iccid);

  }
  if (this->network_technology) {
    to_value_result.Set("NetworkTechnology", *this->network_technology);

  }
  if (this->roaming_state) {
    to_value_result.Set("RoamingState", *this->roaming_state);

  }
  if (this->scanning) {
    to_value_result.Set("Scanning", *this->scanning);

  }
  if (this->sim_present) {
    to_value_result.Set("SIMPresent", *this->sim_present);

  }
  if (this->signal_strength) {
    to_value_result.Set("SignalStrength", *this->signal_strength);

  }

  return to_value_result;
}


EAPStateProperties::EAPStateProperties()
 {}

EAPStateProperties::~EAPStateProperties() = default;
EAPStateProperties::EAPStateProperties(EAPStateProperties&& rhs) = default;
EAPStateProperties& EAPStateProperties::operator=(EAPStateProperties&& rhs) = default;
// static
bool EAPStateProperties::Populate(
    const base::Value& value, EAPStateProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* outer_value = dict.Find("Outer");
  if (outer_value) {
    {
      auto* temp = (*outer_value).GetIfString();
      if (!temp) {
        out->outer = absl::nullopt;
        return false;
      }
      out->outer = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<EAPStateProperties> EAPStateProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<EAPStateProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict EAPStateProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->outer) {
    to_value_result.Set("Outer", *this->outer);

  }

  return to_value_result;
}


EthernetProperties::EthernetProperties()
 {}

EthernetProperties::~EthernetProperties() = default;
EthernetProperties::EthernetProperties(EthernetProperties&& rhs) = default;
EthernetProperties& EthernetProperties::operator=(EthernetProperties&& rhs) = default;
// static
bool EthernetProperties::Populate(
    const base::Value& value, EthernetProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      auto temp = (*auto_connect_value).GetIfBool();
      if (!temp.has_value()) {
        out->auto_connect = absl::nullopt;
        return false;
      }
      out->auto_connect = *temp;
    }
  }

  const base::Value* authentication_value = dict.Find("Authentication");
  if (authentication_value) {
    {
      auto* temp = (*authentication_value).GetIfString();
      if (!temp) {
        out->authentication = absl::nullopt;
        return false;
      }
      out->authentication = *temp;
    }
  }

  const base::Value* eap_value = dict.Find("EAP");
  if (eap_value) {
    {
      if (!(*eap_value).is_dict()) {
        return false;
      }
      else {
        EAPProperties temp;
        if (!EAPProperties::Populate((*eap_value), &temp))
          return false;
        out->eap = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<EthernetProperties> EthernetProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<EthernetProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict EthernetProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", *this->auto_connect);

  }
  if (this->authentication) {
    to_value_result.Set("Authentication", *this->authentication);

  }
  if (this->eap) {
    to_value_result.Set("EAP", (this->eap)->ToValue());

  }

  return to_value_result;
}


ManagedEthernetProperties::ManagedEthernetProperties()
 {}

ManagedEthernetProperties::~ManagedEthernetProperties() = default;
ManagedEthernetProperties::ManagedEthernetProperties(ManagedEthernetProperties&& rhs) = default;
ManagedEthernetProperties& ManagedEthernetProperties::operator=(ManagedEthernetProperties&& rhs) = default;
// static
bool ManagedEthernetProperties::Populate(
    const base::Value& value, ManagedEthernetProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      if (!(*auto_connect_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*auto_connect_value), &temp))
          return false;
        out->auto_connect = std::move(temp);
      }
    }
  }

  const base::Value* authentication_value = dict.Find("Authentication");
  if (authentication_value) {
    {
      if (!(*authentication_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*authentication_value), &temp))
          return false;
        out->authentication = std::move(temp);
      }
    }
  }

  const base::Value* eap_value = dict.Find("EAP");
  if (eap_value) {
    {
      if (!(*eap_value).is_dict()) {
        return false;
      }
      else {
        ManagedEAPProperties temp;
        if (!ManagedEAPProperties::Populate((*eap_value), &temp))
          return false;
        out->eap = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedEthernetProperties> ManagedEthernetProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedEthernetProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedEthernetProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", (this->auto_connect)->ToValue());

  }
  if (this->authentication) {
    to_value_result.Set("Authentication", (this->authentication)->ToValue());

  }
  if (this->eap) {
    to_value_result.Set("EAP", (this->eap)->ToValue());

  }

  return to_value_result;
}


EthernetStateProperties::EthernetStateProperties()
 {}

EthernetStateProperties::~EthernetStateProperties() = default;
EthernetStateProperties::EthernetStateProperties(EthernetStateProperties&& rhs) = default;
EthernetStateProperties& EthernetStateProperties::operator=(EthernetStateProperties&& rhs) = default;
// static
bool EthernetStateProperties::Populate(
    const base::Value& value, EthernetStateProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* authentication_value = dict.Find("Authentication");
  if (!authentication_value) {
    return false;
  }
  {
    auto* temp = (*authentication_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->authentication = *temp;
  }

  return true;
}

// static
std::unique_ptr<EthernetStateProperties> EthernetStateProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<EthernetStateProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict EthernetStateProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Authentication", this->authentication);


  return to_value_result;
}


TetherProperties::TetherProperties()
: has_connected_to_host(false) {}

TetherProperties::~TetherProperties() = default;
TetherProperties::TetherProperties(TetherProperties&& rhs) = default;
TetherProperties& TetherProperties::operator=(TetherProperties&& rhs) = default;
// static
bool TetherProperties::Populate(
    const base::Value& value, TetherProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* battery_percentage_value = dict.Find("BatteryPercentage");
  if (battery_percentage_value) {
    {
      auto temp = (*battery_percentage_value).GetIfInt();
      if (!temp.has_value()) {
        out->battery_percentage = absl::nullopt;
        return false;
      }
      out->battery_percentage = *temp;
    }
  }

  const base::Value* carrier_value = dict.Find("Carrier");
  if (carrier_value) {
    {
      auto* temp = (*carrier_value).GetIfString();
      if (!temp) {
        out->carrier = absl::nullopt;
        return false;
      }
      out->carrier = *temp;
    }
  }

  const base::Value* has_connected_to_host_value = dict.Find("HasConnectedToHost");
  if (!has_connected_to_host_value) {
    return false;
  }
  {
    auto temp = (*has_connected_to_host_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->has_connected_to_host = *temp;
  }

  const base::Value* signal_strength_value = dict.Find("SignalStrength");
  if (signal_strength_value) {
    {
      auto temp = (*signal_strength_value).GetIfInt();
      if (!temp.has_value()) {
        out->signal_strength = absl::nullopt;
        return false;
      }
      out->signal_strength = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<TetherProperties> TetherProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<TetherProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict TetherProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->battery_percentage) {
    to_value_result.Set("BatteryPercentage", *this->battery_percentage);

  }
  if (this->carrier) {
    to_value_result.Set("Carrier", *this->carrier);

  }
  to_value_result.Set("HasConnectedToHost", this->has_connected_to_host);

  if (this->signal_strength) {
    to_value_result.Set("SignalStrength", *this->signal_strength);

  }

  return to_value_result;
}


VPNProperties::VPNProperties()
 {}

VPNProperties::~VPNProperties() = default;
VPNProperties::VPNProperties(VPNProperties&& rhs) = default;
VPNProperties& VPNProperties::operator=(VPNProperties&& rhs) = default;
// static
bool VPNProperties::Populate(
    const base::Value& value, VPNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      auto temp = (*auto_connect_value).GetIfBool();
      if (!temp.has_value()) {
        out->auto_connect = absl::nullopt;
        return false;
      }
      out->auto_connect = *temp;
    }
  }

  const base::Value* host_value = dict.Find("Host");
  if (host_value) {
    {
      auto* temp = (*host_value).GetIfString();
      if (!temp) {
        out->host = absl::nullopt;
        return false;
      }
      out->host = *temp;
    }
  }

  const base::Value* i_psec_value = dict.Find("IPsec");
  if (i_psec_value) {
    {
      if (!(*i_psec_value).is_dict()) {
        return false;
      }
      else {
        IPSecProperties temp;
        if (!IPSecProperties::Populate((*i_psec_value), &temp))
          return false;
        out->i_psec = std::move(temp);
      }
    }
  }

  const base::Value* l2tp_value = dict.Find("L2TP");
  if (l2tp_value) {
    {
      if (!(*l2tp_value).is_dict()) {
        return false;
      }
      else {
        L2TPProperties temp;
        if (!L2TPProperties::Populate((*l2tp_value), &temp))
          return false;
        out->l2tp = std::move(temp);
      }
    }
  }

  const base::Value* open_vpn_value = dict.Find("OpenVPN");
  if (open_vpn_value) {
    {
      if (!(*open_vpn_value).is_dict()) {
        return false;
      }
      else {
        OpenVPNProperties temp;
        if (!OpenVPNProperties::Populate((*open_vpn_value), &temp))
          return false;
        out->open_vpn = std::move(temp);
      }
    }
  }

  const base::Value* third_party_vpn_value = dict.Find("ThirdPartyVPN");
  if (third_party_vpn_value) {
    {
      if (!(*third_party_vpn_value).is_dict()) {
        return false;
      }
      else {
        ThirdPartyVPNProperties temp;
        if (!ThirdPartyVPNProperties::Populate((*third_party_vpn_value), &temp))
          return false;
        out->third_party_vpn = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (type_value) {
    {
      auto* temp = (*type_value).GetIfString();
      if (!temp) {
        out->type = absl::nullopt;
        return false;
      }
      out->type = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<VPNProperties> VPNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<VPNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict VPNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", *this->auto_connect);

  }
  if (this->host) {
    to_value_result.Set("Host", *this->host);

  }
  if (this->i_psec) {
    to_value_result.Set("IPsec", (this->i_psec)->ToValue());

  }
  if (this->l2tp) {
    to_value_result.Set("L2TP", (this->l2tp)->ToValue());

  }
  if (this->open_vpn) {
    to_value_result.Set("OpenVPN", (this->open_vpn)->ToValue());

  }
  if (this->third_party_vpn) {
    to_value_result.Set("ThirdPartyVPN", (this->third_party_vpn)->ToValue());

  }
  if (this->type) {
    to_value_result.Set("Type", *this->type);

  }

  return to_value_result;
}


ManagedVPNProperties::ManagedVPNProperties()
 {}

ManagedVPNProperties::~ManagedVPNProperties() = default;
ManagedVPNProperties::ManagedVPNProperties(ManagedVPNProperties&& rhs) = default;
ManagedVPNProperties& ManagedVPNProperties::operator=(ManagedVPNProperties&& rhs) = default;
// static
bool ManagedVPNProperties::Populate(
    const base::Value& value, ManagedVPNProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      if (!(*auto_connect_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*auto_connect_value), &temp))
          return false;
        out->auto_connect = std::move(temp);
      }
    }
  }

  const base::Value* host_value = dict.Find("Host");
  if (host_value) {
    {
      if (!(*host_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*host_value), &temp))
          return false;
        out->host = std::move(temp);
      }
    }
  }

  const base::Value* i_psec_value = dict.Find("IPsec");
  if (i_psec_value) {
    {
      if (!(*i_psec_value).is_dict()) {
        return false;
      }
      else {
        ManagedIPSecProperties temp;
        if (!ManagedIPSecProperties::Populate((*i_psec_value), &temp))
          return false;
        out->i_psec = std::move(temp);
      }
    }
  }

  const base::Value* l2tp_value = dict.Find("L2TP");
  if (l2tp_value) {
    {
      if (!(*l2tp_value).is_dict()) {
        return false;
      }
      else {
        ManagedL2TPProperties temp;
        if (!ManagedL2TPProperties::Populate((*l2tp_value), &temp))
          return false;
        out->l2tp = std::move(temp);
      }
    }
  }

  const base::Value* open_vpn_value = dict.Find("OpenVPN");
  if (open_vpn_value) {
    {
      if (!(*open_vpn_value).is_dict()) {
        return false;
      }
      else {
        ManagedOpenVPNProperties temp;
        if (!ManagedOpenVPNProperties::Populate((*open_vpn_value), &temp))
          return false;
        out->open_vpn = std::move(temp);
      }
    }
  }

  const base::Value* third_party_vpn_value = dict.Find("ThirdPartyVPN");
  if (third_party_vpn_value) {
    {
      if (!(*third_party_vpn_value).is_dict()) {
        return false;
      }
      else {
        ManagedThirdPartyVPNProperties temp;
        if (!ManagedThirdPartyVPNProperties::Populate((*third_party_vpn_value), &temp))
          return false;
        out->third_party_vpn = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (type_value) {
    {
      if (!(*type_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*type_value), &temp))
          return false;
        out->type = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedVPNProperties> ManagedVPNProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedVPNProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedVPNProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", (this->auto_connect)->ToValue());

  }
  if (this->host) {
    to_value_result.Set("Host", (this->host)->ToValue());

  }
  if (this->i_psec) {
    to_value_result.Set("IPsec", (this->i_psec)->ToValue());

  }
  if (this->l2tp) {
    to_value_result.Set("L2TP", (this->l2tp)->ToValue());

  }
  if (this->open_vpn) {
    to_value_result.Set("OpenVPN", (this->open_vpn)->ToValue());

  }
  if (this->third_party_vpn) {
    to_value_result.Set("ThirdPartyVPN", (this->third_party_vpn)->ToValue());

  }
  if (this->type) {
    to_value_result.Set("Type", (this->type)->ToValue());

  }

  return to_value_result;
}


VPNStateProperties::VPNStateProperties()
 {}

VPNStateProperties::~VPNStateProperties() = default;
VPNStateProperties::VPNStateProperties(VPNStateProperties&& rhs) = default;
VPNStateProperties& VPNStateProperties::operator=(VPNStateProperties&& rhs) = default;
// static
bool VPNStateProperties::Populate(
    const base::Value& value, VPNStateProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* type_value = dict.Find("Type");
  if (!type_value) {
    return false;
  }
  {
    auto* temp = (*type_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->type = *temp;
  }

  const base::Value* i_psec_value = dict.Find("IPsec");
  if (i_psec_value) {
    {
      if (!(*i_psec_value).is_dict()) {
        return false;
      }
      else {
        IPSecProperties temp;
        if (!IPSecProperties::Populate((*i_psec_value), &temp))
          return false;
        out->i_psec = std::move(temp);
      }
    }
  }

  const base::Value* third_party_vpn_value = dict.Find("ThirdPartyVPN");
  if (third_party_vpn_value) {
    {
      if (!(*third_party_vpn_value).is_dict()) {
        return false;
      }
      else {
        ThirdPartyVPNProperties temp;
        if (!ThirdPartyVPNProperties::Populate((*third_party_vpn_value), &temp))
          return false;
        out->third_party_vpn = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<VPNStateProperties> VPNStateProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<VPNStateProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict VPNStateProperties::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("Type", this->type);

  if (this->i_psec) {
    to_value_result.Set("IPsec", (this->i_psec)->ToValue());

  }
  if (this->third_party_vpn) {
    to_value_result.Set("ThirdPartyVPN", (this->third_party_vpn)->ToValue());

  }

  return to_value_result;
}


WiFiProperties::WiFiProperties()
 {}

WiFiProperties::~WiFiProperties() = default;
WiFiProperties::WiFiProperties(WiFiProperties&& rhs) = default;
WiFiProperties& WiFiProperties::operator=(WiFiProperties&& rhs) = default;
// static
bool WiFiProperties::Populate(
    const base::Value& value, WiFiProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* allow_gateway_arp_polling_value = dict.Find("AllowGatewayARPPolling");
  if (allow_gateway_arp_polling_value) {
    {
      auto temp = (*allow_gateway_arp_polling_value).GetIfBool();
      if (!temp.has_value()) {
        out->allow_gateway_arp_polling = absl::nullopt;
        return false;
      }
      out->allow_gateway_arp_polling = *temp;
    }
  }

  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      auto temp = (*auto_connect_value).GetIfBool();
      if (!temp.has_value()) {
        out->auto_connect = absl::nullopt;
        return false;
      }
      out->auto_connect = *temp;
    }
  }

  const base::Value* bssid_value = dict.Find("BSSID");
  if (bssid_value) {
    {
      auto* temp = (*bssid_value).GetIfString();
      if (!temp) {
        out->bssid = absl::nullopt;
        return false;
      }
      out->bssid = *temp;
    }
  }

  const base::Value* eap_value = dict.Find("EAP");
  if (eap_value) {
    {
      if (!(*eap_value).is_dict()) {
        return false;
      }
      else {
        EAPProperties temp;
        if (!EAPProperties::Populate((*eap_value), &temp))
          return false;
        out->eap = std::move(temp);
      }
    }
  }

  const base::Value* frequency_value = dict.Find("Frequency");
  if (frequency_value) {
    {
      auto temp = (*frequency_value).GetIfInt();
      if (!temp.has_value()) {
        out->frequency = absl::nullopt;
        return false;
      }
      out->frequency = *temp;
    }
  }

  const base::Value* frequency_list_value = dict.Find("FrequencyList");
  if (frequency_list_value) {
    {
      if (!(*frequency_list_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*frequency_list_value).GetList(), &out->frequency_list)) {
          return false;
        }
      }
    }
  }

  const base::Value* hex_ssid_value = dict.Find("HexSSID");
  if (hex_ssid_value) {
    {
      auto* temp = (*hex_ssid_value).GetIfString();
      if (!temp) {
        out->hex_ssid = absl::nullopt;
        return false;
      }
      out->hex_ssid = *temp;
    }
  }

  const base::Value* hidden_ssid_value = dict.Find("HiddenSSID");
  if (hidden_ssid_value) {
    {
      auto temp = (*hidden_ssid_value).GetIfBool();
      if (!temp.has_value()) {
        out->hidden_ssid = absl::nullopt;
        return false;
      }
      out->hidden_ssid = *temp;
    }
  }

  const base::Value* passphrase_value = dict.Find("Passphrase");
  if (passphrase_value) {
    {
      auto* temp = (*passphrase_value).GetIfString();
      if (!temp) {
        out->passphrase = absl::nullopt;
        return false;
      }
      out->passphrase = *temp;
    }
  }

  const base::Value* ssid_value = dict.Find("SSID");
  if (ssid_value) {
    {
      auto* temp = (*ssid_value).GetIfString();
      if (!temp) {
        out->ssid = absl::nullopt;
        return false;
      }
      out->ssid = *temp;
    }
  }

  const base::Value* security_value = dict.Find("Security");
  if (security_value) {
    {
      auto* temp = (*security_value).GetIfString();
      if (!temp) {
        out->security = absl::nullopt;
        return false;
      }
      out->security = *temp;
    }
  }

  const base::Value* signal_strength_value = dict.Find("SignalStrength");
  if (signal_strength_value) {
    {
      auto temp = (*signal_strength_value).GetIfInt();
      if (!temp.has_value()) {
        out->signal_strength = absl::nullopt;
        return false;
      }
      out->signal_strength = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<WiFiProperties> WiFiProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<WiFiProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict WiFiProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->allow_gateway_arp_polling) {
    to_value_result.Set("AllowGatewayARPPolling", *this->allow_gateway_arp_polling);

  }
  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", *this->auto_connect);

  }
  if (this->bssid) {
    to_value_result.Set("BSSID", *this->bssid);

  }
  if (this->eap) {
    to_value_result.Set("EAP", (this->eap)->ToValue());

  }
  if (this->frequency) {
    to_value_result.Set("Frequency", *this->frequency);

  }
  if (this->frequency_list) {
    to_value_result.Set("FrequencyList", json_schema_compiler::util::CreateValueFromArray(*this->frequency_list));

  }
  if (this->hex_ssid) {
    to_value_result.Set("HexSSID", *this->hex_ssid);

  }
  if (this->hidden_ssid) {
    to_value_result.Set("HiddenSSID", *this->hidden_ssid);

  }
  if (this->passphrase) {
    to_value_result.Set("Passphrase", *this->passphrase);

  }
  if (this->ssid) {
    to_value_result.Set("SSID", *this->ssid);

  }
  if (this->security) {
    to_value_result.Set("Security", *this->security);

  }
  if (this->signal_strength) {
    to_value_result.Set("SignalStrength", *this->signal_strength);

  }

  return to_value_result;
}


ManagedWiFiProperties::ManagedWiFiProperties()
 {}

ManagedWiFiProperties::~ManagedWiFiProperties() = default;
ManagedWiFiProperties::ManagedWiFiProperties(ManagedWiFiProperties&& rhs) = default;
ManagedWiFiProperties& ManagedWiFiProperties::operator=(ManagedWiFiProperties&& rhs) = default;
// static
bool ManagedWiFiProperties::Populate(
    const base::Value& value, ManagedWiFiProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* allow_gateway_arp_polling_value = dict.Find("AllowGatewayARPPolling");
  if (allow_gateway_arp_polling_value) {
    {
      if (!(*allow_gateway_arp_polling_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*allow_gateway_arp_polling_value), &temp))
          return false;
        out->allow_gateway_arp_polling = std::move(temp);
      }
    }
  }

  const base::Value* auto_connect_value = dict.Find("AutoConnect");
  if (auto_connect_value) {
    {
      if (!(*auto_connect_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*auto_connect_value), &temp))
          return false;
        out->auto_connect = std::move(temp);
      }
    }
  }

  const base::Value* bssid_value = dict.Find("BSSID");
  if (bssid_value) {
    {
      auto* temp = (*bssid_value).GetIfString();
      if (!temp) {
        out->bssid = absl::nullopt;
        return false;
      }
      out->bssid = *temp;
    }
  }

  const base::Value* eap_value = dict.Find("EAP");
  if (eap_value) {
    {
      if (!(*eap_value).is_dict()) {
        return false;
      }
      else {
        ManagedEAPProperties temp;
        if (!ManagedEAPProperties::Populate((*eap_value), &temp))
          return false;
        out->eap = std::move(temp);
      }
    }
  }

  const base::Value* frequency_value = dict.Find("Frequency");
  if (frequency_value) {
    {
      auto temp = (*frequency_value).GetIfInt();
      if (!temp.has_value()) {
        out->frequency = absl::nullopt;
        return false;
      }
      out->frequency = *temp;
    }
  }

  const base::Value* frequency_list_value = dict.Find("FrequencyList");
  if (frequency_list_value) {
    {
      if (!(*frequency_list_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*frequency_list_value).GetList(), &out->frequency_list)) {
          return false;
        }
      }
    }
  }

  const base::Value* hex_ssid_value = dict.Find("HexSSID");
  if (hex_ssid_value) {
    {
      if (!(*hex_ssid_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*hex_ssid_value), &temp))
          return false;
        out->hex_ssid = std::move(temp);
      }
    }
  }

  const base::Value* hidden_ssid_value = dict.Find("HiddenSSID");
  if (hidden_ssid_value) {
    {
      if (!(*hidden_ssid_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*hidden_ssid_value), &temp))
          return false;
        out->hidden_ssid = std::move(temp);
      }
    }
  }

  const base::Value* passphrase_value = dict.Find("Passphrase");
  if (passphrase_value) {
    {
      if (!(*passphrase_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*passphrase_value), &temp))
          return false;
        out->passphrase = std::move(temp);
      }
    }
  }

  const base::Value* ssid_value = dict.Find("SSID");
  if (ssid_value) {
    {
      if (!(*ssid_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*ssid_value), &temp))
          return false;
        out->ssid = std::move(temp);
      }
    }
  }

  const base::Value* security_value = dict.Find("Security");
  if (!security_value) {
    return false;
  }
  {
    if (!(*security_value).is_dict()) {
      return false;
    }
    if (!ManagedDOMString::Populate((*security_value), &out->security)) {
      return false;
    }
  }

  const base::Value* signal_strength_value = dict.Find("SignalStrength");
  if (signal_strength_value) {
    {
      auto temp = (*signal_strength_value).GetIfInt();
      if (!temp.has_value()) {
        out->signal_strength = absl::nullopt;
        return false;
      }
      out->signal_strength = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedWiFiProperties> ManagedWiFiProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedWiFiProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedWiFiProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->allow_gateway_arp_polling) {
    to_value_result.Set("AllowGatewayARPPolling", (this->allow_gateway_arp_polling)->ToValue());

  }
  if (this->auto_connect) {
    to_value_result.Set("AutoConnect", (this->auto_connect)->ToValue());

  }
  if (this->bssid) {
    to_value_result.Set("BSSID", *this->bssid);

  }
  if (this->eap) {
    to_value_result.Set("EAP", (this->eap)->ToValue());

  }
  if (this->frequency) {
    to_value_result.Set("Frequency", *this->frequency);

  }
  if (this->frequency_list) {
    to_value_result.Set("FrequencyList", json_schema_compiler::util::CreateValueFromArray(*this->frequency_list));

  }
  if (this->hex_ssid) {
    to_value_result.Set("HexSSID", (this->hex_ssid)->ToValue());

  }
  if (this->hidden_ssid) {
    to_value_result.Set("HiddenSSID", (this->hidden_ssid)->ToValue());

  }
  if (this->passphrase) {
    to_value_result.Set("Passphrase", (this->passphrase)->ToValue());

  }
  if (this->ssid) {
    to_value_result.Set("SSID", (this->ssid)->ToValue());

  }
  to_value_result.Set("Security", (this->security).ToValue());

  if (this->signal_strength) {
    to_value_result.Set("SignalStrength", *this->signal_strength);

  }

  return to_value_result;
}


WiFiStateProperties::WiFiStateProperties()
 {}

WiFiStateProperties::~WiFiStateProperties() = default;
WiFiStateProperties::WiFiStateProperties(WiFiStateProperties&& rhs) = default;
WiFiStateProperties& WiFiStateProperties::operator=(WiFiStateProperties&& rhs) = default;
// static
bool WiFiStateProperties::Populate(
    const base::Value& value, WiFiStateProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* bssid_value = dict.Find("BSSID");
  if (bssid_value) {
    {
      auto* temp = (*bssid_value).GetIfString();
      if (!temp) {
        out->bssid = absl::nullopt;
        return false;
      }
      out->bssid = *temp;
    }
  }

  const base::Value* eap_value = dict.Find("EAP");
  if (eap_value) {
    {
      if (!(*eap_value).is_dict()) {
        return false;
      }
      else {
        EAPStateProperties temp;
        if (!EAPStateProperties::Populate((*eap_value), &temp))
          return false;
        out->eap = std::move(temp);
      }
    }
  }

  const base::Value* frequency_value = dict.Find("Frequency");
  if (frequency_value) {
    {
      auto temp = (*frequency_value).GetIfInt();
      if (!temp.has_value()) {
        out->frequency = absl::nullopt;
        return false;
      }
      out->frequency = *temp;
    }
  }

  const base::Value* hex_ssid_value = dict.Find("HexSSID");
  if (hex_ssid_value) {
    {
      auto* temp = (*hex_ssid_value).GetIfString();
      if (!temp) {
        out->hex_ssid = absl::nullopt;
        return false;
      }
      out->hex_ssid = *temp;
    }
  }

  const base::Value* security_value = dict.Find("Security");
  if (!security_value) {
    return false;
  }
  {
    auto* temp = (*security_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->security = *temp;
  }

  const base::Value* signal_strength_value = dict.Find("SignalStrength");
  if (signal_strength_value) {
    {
      auto temp = (*signal_strength_value).GetIfInt();
      if (!temp.has_value()) {
        out->signal_strength = absl::nullopt;
        return false;
      }
      out->signal_strength = *temp;
    }
  }

  const base::Value* ssid_value = dict.Find("SSID");
  if (ssid_value) {
    {
      auto* temp = (*ssid_value).GetIfString();
      if (!temp) {
        out->ssid = absl::nullopt;
        return false;
      }
      out->ssid = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<WiFiStateProperties> WiFiStateProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<WiFiStateProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict WiFiStateProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->bssid) {
    to_value_result.Set("BSSID", *this->bssid);

  }
  if (this->eap) {
    to_value_result.Set("EAP", (this->eap)->ToValue());

  }
  if (this->frequency) {
    to_value_result.Set("Frequency", *this->frequency);

  }
  if (this->hex_ssid) {
    to_value_result.Set("HexSSID", *this->hex_ssid);

  }
  to_value_result.Set("Security", this->security);

  if (this->signal_strength) {
    to_value_result.Set("SignalStrength", *this->signal_strength);

  }
  if (this->ssid) {
    to_value_result.Set("SSID", *this->ssid);

  }

  return to_value_result;
}


NetworkConfigProperties::NetworkConfigProperties()
: ip_address_config_type(IP_CONFIG_TYPE_NONE),
name_servers_config_type(IP_CONFIG_TYPE_NONE),
type(NETWORK_TYPE_NONE) {}

NetworkConfigProperties::~NetworkConfigProperties() = default;
NetworkConfigProperties::NetworkConfigProperties(NetworkConfigProperties&& rhs) = default;
NetworkConfigProperties& NetworkConfigProperties::operator=(NetworkConfigProperties&& rhs) = default;
// static
bool NetworkConfigProperties::Populate(
    const base::Value& value, NetworkConfigProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->ip_address_config_type = IP_CONFIG_TYPE_NONE;
  out->name_servers_config_type = IP_CONFIG_TYPE_NONE;
  out->type = NETWORK_TYPE_NONE;
  const base::Value* cellular_value = dict.Find("Cellular");
  if (cellular_value) {
    {
      if (!(*cellular_value).is_dict()) {
        return false;
      }
      else {
        CellularProperties temp;
        if (!CellularProperties::Populate((*cellular_value), &temp))
          return false;
        out->cellular = std::move(temp);
      }
    }
  }

  const base::Value* ethernet_value = dict.Find("Ethernet");
  if (ethernet_value) {
    {
      if (!(*ethernet_value).is_dict()) {
        return false;
      }
      else {
        EthernetProperties temp;
        if (!EthernetProperties::Populate((*ethernet_value), &temp))
          return false;
        out->ethernet = std::move(temp);
      }
    }
  }

  const base::Value* guid_value = dict.Find("GUID");
  if (guid_value) {
    {
      auto* temp = (*guid_value).GetIfString();
      if (!temp) {
        out->guid = absl::nullopt;
        return false;
      }
      out->guid = *temp;
    }
  }

  const base::Value* ip_address_config_type_value = dict.Find("IPAddressConfigType");
  if (ip_address_config_type_value) {
    {
      const std::string* ip_config_type_as_string = (*ip_address_config_type_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->ip_address_config_type = ParseIPConfigType(*ip_config_type_as_string);
      if (out->ip_address_config_type == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->ip_address_config_type = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      auto* temp = (*name_value).GetIfString();
      if (!temp) {
        out->name = absl::nullopt;
        return false;
      }
      out->name = *temp;
    }
  }

  const base::Value* name_servers_config_type_value = dict.Find("NameServersConfigType");
  if (name_servers_config_type_value) {
    {
      const std::string* ip_config_type_as_string = (*name_servers_config_type_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->name_servers_config_type = ParseIPConfigType(*ip_config_type_as_string);
      if (out->name_servers_config_type == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->name_servers_config_type = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* priority_value = dict.Find("Priority");
  if (priority_value) {
    {
      auto temp = (*priority_value).GetIfInt();
      if (!temp.has_value()) {
        out->priority = absl::nullopt;
        return false;
      }
      out->priority = *temp;
    }
  }

  const base::Value* proxy_settings_value = dict.Find("ProxySettings");
  if (proxy_settings_value) {
    {
      if (!(*proxy_settings_value).is_dict()) {
        return false;
      }
      else {
        ProxySettings temp;
        if (!ProxySettings::Populate((*proxy_settings_value), &temp))
          return false;
        out->proxy_settings = std::move(temp);
      }
    }
  }

  const base::Value* static_ip_config_value = dict.Find("StaticIPConfig");
  if (static_ip_config_value) {
    {
      if (!(*static_ip_config_value).is_dict()) {
        return false;
      }
      else {
        IPConfigProperties temp;
        if (!IPConfigProperties::Populate((*static_ip_config_value), &temp))
          return false;
        out->static_ip_config = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (type_value) {
    {
      const std::string* network_type_as_string = (*type_value).GetIfString();
      if (!network_type_as_string) {
        return false;
      }
      out->type = ParseNetworkType(*network_type_as_string);
      if (out->type == NETWORK_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->type = NETWORK_TYPE_NONE;
  }

  const base::Value* vpn_value = dict.Find("VPN");
  if (vpn_value) {
    {
      if (!(*vpn_value).is_dict()) {
        return false;
      }
      else {
        VPNProperties temp;
        if (!VPNProperties::Populate((*vpn_value), &temp))
          return false;
        out->vpn = std::move(temp);
      }
    }
  }

  const base::Value* wi_fi_value = dict.Find("WiFi");
  if (wi_fi_value) {
    {
      if (!(*wi_fi_value).is_dict()) {
        return false;
      }
      else {
        WiFiProperties temp;
        if (!WiFiProperties::Populate((*wi_fi_value), &temp))
          return false;
        out->wi_fi = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<NetworkConfigProperties> NetworkConfigProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<NetworkConfigProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict NetworkConfigProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->cellular) {
    to_value_result.Set("Cellular", (this->cellular)->ToValue());

  }
  if (this->ethernet) {
    to_value_result.Set("Ethernet", (this->ethernet)->ToValue());

  }
  if (this->guid) {
    to_value_result.Set("GUID", *this->guid);

  }
  if (this->ip_address_config_type != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("IPAddressConfigType", networking_private::ToString(this->ip_address_config_type));

  }
  if (this->name) {
    to_value_result.Set("Name", *this->name);

  }
  if (this->name_servers_config_type != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("NameServersConfigType", networking_private::ToString(this->name_servers_config_type));

  }
  if (this->priority) {
    to_value_result.Set("Priority", *this->priority);

  }
  if (this->proxy_settings) {
    to_value_result.Set("ProxySettings", (this->proxy_settings)->ToValue());

  }
  if (this->static_ip_config) {
    to_value_result.Set("StaticIPConfig", (this->static_ip_config)->ToValue());

  }
  if (this->type != NETWORK_TYPE_NONE) {
    to_value_result.Set("Type", networking_private::ToString(this->type));

  }
  if (this->vpn) {
    to_value_result.Set("VPN", (this->vpn)->ToValue());

  }
  if (this->wi_fi) {
    to_value_result.Set("WiFi", (this->wi_fi)->ToValue());

  }

  return to_value_result;
}


NetworkProperties::NetworkProperties()
: connection_state(CONNECTION_STATE_TYPE_NONE),
ip_address_config_type(IP_CONFIG_TYPE_NONE),
name_servers_config_type(IP_CONFIG_TYPE_NONE),
type(NETWORK_TYPE_NONE) {}

NetworkProperties::~NetworkProperties() = default;
NetworkProperties::NetworkProperties(NetworkProperties&& rhs) = default;
NetworkProperties& NetworkProperties::operator=(NetworkProperties&& rhs) = default;
// static
bool NetworkProperties::Populate(
    const base::Value& value, NetworkProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->connection_state = CONNECTION_STATE_TYPE_NONE;
  out->ip_address_config_type = IP_CONFIG_TYPE_NONE;
  out->name_servers_config_type = IP_CONFIG_TYPE_NONE;
  const base::Value* cellular_value = dict.Find("Cellular");
  if (cellular_value) {
    {
      if (!(*cellular_value).is_dict()) {
        return false;
      }
      else {
        CellularProperties temp;
        if (!CellularProperties::Populate((*cellular_value), &temp))
          return false;
        out->cellular = std::move(temp);
      }
    }
  }

  const base::Value* connectable_value = dict.Find("Connectable");
  if (connectable_value) {
    {
      auto temp = (*connectable_value).GetIfBool();
      if (!temp.has_value()) {
        out->connectable = absl::nullopt;
        return false;
      }
      out->connectable = *temp;
    }
  }

  const base::Value* connection_state_value = dict.Find("ConnectionState");
  if (connection_state_value) {
    {
      const std::string* connection_state_type_as_string = (*connection_state_value).GetIfString();
      if (!connection_state_type_as_string) {
        return false;
      }
      out->connection_state = ParseConnectionStateType(*connection_state_type_as_string);
      if (out->connection_state == CONNECTION_STATE_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->connection_state = CONNECTION_STATE_TYPE_NONE;
  }

  const base::Value* error_state_value = dict.Find("ErrorState");
  if (error_state_value) {
    {
      auto* temp = (*error_state_value).GetIfString();
      if (!temp) {
        out->error_state = absl::nullopt;
        return false;
      }
      out->error_state = *temp;
    }
  }

  const base::Value* ethernet_value = dict.Find("Ethernet");
  if (ethernet_value) {
    {
      if (!(*ethernet_value).is_dict()) {
        return false;
      }
      else {
        EthernetProperties temp;
        if (!EthernetProperties::Populate((*ethernet_value), &temp))
          return false;
        out->ethernet = std::move(temp);
      }
    }
  }

  const base::Value* guid_value = dict.Find("GUID");
  if (!guid_value) {
    return false;
  }
  {
    auto* temp = (*guid_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->guid = *temp;
  }

  const base::Value* ip_address_config_type_value = dict.Find("IPAddressConfigType");
  if (ip_address_config_type_value) {
    {
      const std::string* ip_config_type_as_string = (*ip_address_config_type_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->ip_address_config_type = ParseIPConfigType(*ip_config_type_as_string);
      if (out->ip_address_config_type == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->ip_address_config_type = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* ip_configs_value = dict.Find("IPConfigs");
  if (ip_configs_value) {
    {
      if (!(*ip_configs_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*ip_configs_value).GetList(), &out->ip_configs)) {
          return false;
        }
      }
    }
  }

  const base::Value* mac_address_value = dict.Find("MacAddress");
  if (mac_address_value) {
    {
      auto* temp = (*mac_address_value).GetIfString();
      if (!temp) {
        out->mac_address = absl::nullopt;
        return false;
      }
      out->mac_address = *temp;
    }
  }

  const base::Value* metered_value = dict.Find("Metered");
  if (metered_value) {
    {
      auto temp = (*metered_value).GetIfBool();
      if (!temp.has_value()) {
        out->metered = absl::nullopt;
        return false;
      }
      out->metered = *temp;
    }
  }

  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      auto* temp = (*name_value).GetIfString();
      if (!temp) {
        out->name = absl::nullopt;
        return false;
      }
      out->name = *temp;
    }
  }

  const base::Value* name_servers_config_type_value = dict.Find("NameServersConfigType");
  if (name_servers_config_type_value) {
    {
      const std::string* ip_config_type_as_string = (*name_servers_config_type_value).GetIfString();
      if (!ip_config_type_as_string) {
        return false;
      }
      out->name_servers_config_type = ParseIPConfigType(*ip_config_type_as_string);
      if (out->name_servers_config_type == IP_CONFIG_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->name_servers_config_type = IP_CONFIG_TYPE_NONE;
  }

  const base::Value* priority_value = dict.Find("Priority");
  if (priority_value) {
    {
      auto temp = (*priority_value).GetIfInt();
      if (!temp.has_value()) {
        out->priority = absl::nullopt;
        return false;
      }
      out->priority = *temp;
    }
  }

  const base::Value* proxy_settings_value = dict.Find("ProxySettings");
  if (proxy_settings_value) {
    {
      if (!(*proxy_settings_value).is_dict()) {
        return false;
      }
      else {
        ProxySettings temp;
        if (!ProxySettings::Populate((*proxy_settings_value), &temp))
          return false;
        out->proxy_settings = std::move(temp);
      }
    }
  }

  const base::Value* restricted_connectivity_value = dict.Find("RestrictedConnectivity");
  if (restricted_connectivity_value) {
    {
      auto temp = (*restricted_connectivity_value).GetIfBool();
      if (!temp.has_value()) {
        out->restricted_connectivity = absl::nullopt;
        return false;
      }
      out->restricted_connectivity = *temp;
    }
  }

  const base::Value* static_ip_config_value = dict.Find("StaticIPConfig");
  if (static_ip_config_value) {
    {
      if (!(*static_ip_config_value).is_dict()) {
        return false;
      }
      else {
        IPConfigProperties temp;
        if (!IPConfigProperties::Populate((*static_ip_config_value), &temp))
          return false;
        out->static_ip_config = std::move(temp);
      }
    }
  }

  const base::Value* saved_ip_config_value = dict.Find("SavedIPConfig");
  if (saved_ip_config_value) {
    {
      if (!(*saved_ip_config_value).is_dict()) {
        return false;
      }
      else {
        IPConfigProperties temp;
        if (!IPConfigProperties::Populate((*saved_ip_config_value), &temp))
          return false;
        out->saved_ip_config = std::move(temp);
      }
    }
  }

  const base::Value* source_value = dict.Find("Source");
  if (source_value) {
    {
      auto* temp = (*source_value).GetIfString();
      if (!temp) {
        out->source = absl::nullopt;
        return false;
      }
      out->source = *temp;
    }
  }

  const base::Value* tether_value = dict.Find("Tether");
  if (tether_value) {
    {
      if (!(*tether_value).is_dict()) {
        return false;
      }
      else {
        TetherProperties temp;
        if (!TetherProperties::Populate((*tether_value), &temp))
          return false;
        out->tether = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (!type_value) {
    return false;
  }
  {
    const std::string* network_type_as_string = (*type_value).GetIfString();
    if (!network_type_as_string) {
      return false;
    }
    out->type = ParseNetworkType(*network_type_as_string);
    if (out->type == NETWORK_TYPE_NONE) {
      return false;
    }
  }

  const base::Value* vpn_value = dict.Find("VPN");
  if (vpn_value) {
    {
      if (!(*vpn_value).is_dict()) {
        return false;
      }
      else {
        VPNProperties temp;
        if (!VPNProperties::Populate((*vpn_value), &temp))
          return false;
        out->vpn = std::move(temp);
      }
    }
  }

  const base::Value* wi_fi_value = dict.Find("WiFi");
  if (wi_fi_value) {
    {
      if (!(*wi_fi_value).is_dict()) {
        return false;
      }
      else {
        WiFiProperties temp;
        if (!WiFiProperties::Populate((*wi_fi_value), &temp))
          return false;
        out->wi_fi = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<NetworkProperties> NetworkProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<NetworkProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict NetworkProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->cellular) {
    to_value_result.Set("Cellular", (this->cellular)->ToValue());

  }
  if (this->connectable) {
    to_value_result.Set("Connectable", *this->connectable);

  }
  if (this->connection_state != CONNECTION_STATE_TYPE_NONE) {
    to_value_result.Set("ConnectionState", networking_private::ToString(this->connection_state));

  }
  if (this->error_state) {
    to_value_result.Set("ErrorState", *this->error_state);

  }
  if (this->ethernet) {
    to_value_result.Set("Ethernet", (this->ethernet)->ToValue());

  }
  to_value_result.Set("GUID", this->guid);

  if (this->ip_address_config_type != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("IPAddressConfigType", networking_private::ToString(this->ip_address_config_type));

  }
  if (this->ip_configs) {
    to_value_result.Set("IPConfigs", json_schema_compiler::util::CreateValueFromArray(*this->ip_configs));

  }
  if (this->mac_address) {
    to_value_result.Set("MacAddress", *this->mac_address);

  }
  if (this->metered) {
    to_value_result.Set("Metered", *this->metered);

  }
  if (this->name) {
    to_value_result.Set("Name", *this->name);

  }
  if (this->name_servers_config_type != IP_CONFIG_TYPE_NONE) {
    to_value_result.Set("NameServersConfigType", networking_private::ToString(this->name_servers_config_type));

  }
  if (this->priority) {
    to_value_result.Set("Priority", *this->priority);

  }
  if (this->proxy_settings) {
    to_value_result.Set("ProxySettings", (this->proxy_settings)->ToValue());

  }
  if (this->restricted_connectivity) {
    to_value_result.Set("RestrictedConnectivity", *this->restricted_connectivity);

  }
  if (this->static_ip_config) {
    to_value_result.Set("StaticIPConfig", (this->static_ip_config)->ToValue());

  }
  if (this->saved_ip_config) {
    to_value_result.Set("SavedIPConfig", (this->saved_ip_config)->ToValue());

  }
  if (this->source) {
    to_value_result.Set("Source", *this->source);

  }
  if (this->tether) {
    to_value_result.Set("Tether", (this->tether)->ToValue());

  }
  to_value_result.Set("Type", networking_private::ToString(this->type));

  if (this->vpn) {
    to_value_result.Set("VPN", (this->vpn)->ToValue());

  }
  if (this->wi_fi) {
    to_value_result.Set("WiFi", (this->wi_fi)->ToValue());

  }

  return to_value_result;
}


ManagedProperties::ManagedProperties()
: connection_state(CONNECTION_STATE_TYPE_NONE),
type(NETWORK_TYPE_NONE) {}

ManagedProperties::~ManagedProperties() = default;
ManagedProperties::ManagedProperties(ManagedProperties&& rhs) = default;
ManagedProperties& ManagedProperties::operator=(ManagedProperties&& rhs) = default;
// static
bool ManagedProperties::Populate(
    const base::Value& value, ManagedProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->connection_state = CONNECTION_STATE_TYPE_NONE;
  const base::Value* cellular_value = dict.Find("Cellular");
  if (cellular_value) {
    {
      if (!(*cellular_value).is_dict()) {
        return false;
      }
      else {
        ManagedCellularProperties temp;
        if (!ManagedCellularProperties::Populate((*cellular_value), &temp))
          return false;
        out->cellular = std::move(temp);
      }
    }
  }

  const base::Value* connectable_value = dict.Find("Connectable");
  if (connectable_value) {
    {
      auto temp = (*connectable_value).GetIfBool();
      if (!temp.has_value()) {
        out->connectable = absl::nullopt;
        return false;
      }
      out->connectable = *temp;
    }
  }

  const base::Value* connection_state_value = dict.Find("ConnectionState");
  if (connection_state_value) {
    {
      const std::string* connection_state_type_as_string = (*connection_state_value).GetIfString();
      if (!connection_state_type_as_string) {
        return false;
      }
      out->connection_state = ParseConnectionStateType(*connection_state_type_as_string);
      if (out->connection_state == CONNECTION_STATE_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->connection_state = CONNECTION_STATE_TYPE_NONE;
  }

  const base::Value* error_state_value = dict.Find("ErrorState");
  if (error_state_value) {
    {
      auto* temp = (*error_state_value).GetIfString();
      if (!temp) {
        out->error_state = absl::nullopt;
        return false;
      }
      out->error_state = *temp;
    }
  }

  const base::Value* ethernet_value = dict.Find("Ethernet");
  if (ethernet_value) {
    {
      if (!(*ethernet_value).is_dict()) {
        return false;
      }
      else {
        ManagedEthernetProperties temp;
        if (!ManagedEthernetProperties::Populate((*ethernet_value), &temp))
          return false;
        out->ethernet = std::move(temp);
      }
    }
  }

  const base::Value* guid_value = dict.Find("GUID");
  if (!guid_value) {
    return false;
  }
  {
    auto* temp = (*guid_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->guid = *temp;
  }

  const base::Value* ip_address_config_type_value = dict.Find("IPAddressConfigType");
  if (ip_address_config_type_value) {
    {
      if (!(*ip_address_config_type_value).is_dict()) {
        return false;
      }
      else {
        ManagedIPConfigType temp;
        if (!ManagedIPConfigType::Populate((*ip_address_config_type_value), &temp))
          return false;
        out->ip_address_config_type = std::move(temp);
      }
    }
  }

  const base::Value* ip_configs_value = dict.Find("IPConfigs");
  if (ip_configs_value) {
    {
      if (!(*ip_configs_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*ip_configs_value).GetList(), &out->ip_configs)) {
          return false;
        }
      }
    }
  }

  const base::Value* mac_address_value = dict.Find("MacAddress");
  if (mac_address_value) {
    {
      auto* temp = (*mac_address_value).GetIfString();
      if (!temp) {
        out->mac_address = absl::nullopt;
        return false;
      }
      out->mac_address = *temp;
    }
  }

  const base::Value* metered_value = dict.Find("Metered");
  if (metered_value) {
    {
      if (!(*metered_value).is_dict()) {
        return false;
      }
      else {
        ManagedBoolean temp;
        if (!ManagedBoolean::Populate((*metered_value), &temp))
          return false;
        out->metered = std::move(temp);
      }
    }
  }

  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      if (!(*name_value).is_dict()) {
        return false;
      }
      else {
        ManagedDOMString temp;
        if (!ManagedDOMString::Populate((*name_value), &temp))
          return false;
        out->name = std::move(temp);
      }
    }
  }

  const base::Value* name_servers_config_type_value = dict.Find("NameServersConfigType");
  if (name_servers_config_type_value) {
    {
      if (!(*name_servers_config_type_value).is_dict()) {
        return false;
      }
      else {
        ManagedIPConfigType temp;
        if (!ManagedIPConfigType::Populate((*name_servers_config_type_value), &temp))
          return false;
        out->name_servers_config_type = std::move(temp);
      }
    }
  }

  const base::Value* priority_value = dict.Find("Priority");
  if (priority_value) {
    {
      if (!(*priority_value).is_dict()) {
        return false;
      }
      else {
        ManagedLong temp;
        if (!ManagedLong::Populate((*priority_value), &temp))
          return false;
        out->priority = std::move(temp);
      }
    }
  }

  const base::Value* proxy_settings_value = dict.Find("ProxySettings");
  if (proxy_settings_value) {
    {
      if (!(*proxy_settings_value).is_dict()) {
        return false;
      }
      else {
        ManagedProxySettings temp;
        if (!ManagedProxySettings::Populate((*proxy_settings_value), &temp))
          return false;
        out->proxy_settings = std::move(temp);
      }
    }
  }

  const base::Value* restricted_connectivity_value = dict.Find("RestrictedConnectivity");
  if (restricted_connectivity_value) {
    {
      auto temp = (*restricted_connectivity_value).GetIfBool();
      if (!temp.has_value()) {
        out->restricted_connectivity = absl::nullopt;
        return false;
      }
      out->restricted_connectivity = *temp;
    }
  }

  const base::Value* static_ip_config_value = dict.Find("StaticIPConfig");
  if (static_ip_config_value) {
    {
      if (!(*static_ip_config_value).is_dict()) {
        return false;
      }
      else {
        ManagedIPConfigProperties temp;
        if (!ManagedIPConfigProperties::Populate((*static_ip_config_value), &temp))
          return false;
        out->static_ip_config = std::move(temp);
      }
    }
  }

  const base::Value* saved_ip_config_value = dict.Find("SavedIPConfig");
  if (saved_ip_config_value) {
    {
      if (!(*saved_ip_config_value).is_dict()) {
        return false;
      }
      else {
        IPConfigProperties temp;
        if (!IPConfigProperties::Populate((*saved_ip_config_value), &temp))
          return false;
        out->saved_ip_config = std::move(temp);
      }
    }
  }

  const base::Value* source_value = dict.Find("Source");
  if (source_value) {
    {
      auto* temp = (*source_value).GetIfString();
      if (!temp) {
        out->source = absl::nullopt;
        return false;
      }
      out->source = *temp;
    }
  }

  const base::Value* tether_value = dict.Find("Tether");
  if (tether_value) {
    {
      if (!(*tether_value).is_dict()) {
        return false;
      }
      else {
        TetherProperties temp;
        if (!TetherProperties::Populate((*tether_value), &temp))
          return false;
        out->tether = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (!type_value) {
    return false;
  }
  {
    const std::string* network_type_as_string = (*type_value).GetIfString();
    if (!network_type_as_string) {
      return false;
    }
    out->type = ParseNetworkType(*network_type_as_string);
    if (out->type == NETWORK_TYPE_NONE) {
      return false;
    }
  }

  const base::Value* vpn_value = dict.Find("VPN");
  if (vpn_value) {
    {
      if (!(*vpn_value).is_dict()) {
        return false;
      }
      else {
        ManagedVPNProperties temp;
        if (!ManagedVPNProperties::Populate((*vpn_value), &temp))
          return false;
        out->vpn = std::move(temp);
      }
    }
  }

  const base::Value* wi_fi_value = dict.Find("WiFi");
  if (wi_fi_value) {
    {
      if (!(*wi_fi_value).is_dict()) {
        return false;
      }
      else {
        ManagedWiFiProperties temp;
        if (!ManagedWiFiProperties::Populate((*wi_fi_value), &temp))
          return false;
        out->wi_fi = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<ManagedProperties> ManagedProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<ManagedProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict ManagedProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->cellular) {
    to_value_result.Set("Cellular", (this->cellular)->ToValue());

  }
  if (this->connectable) {
    to_value_result.Set("Connectable", *this->connectable);

  }
  if (this->connection_state != CONNECTION_STATE_TYPE_NONE) {
    to_value_result.Set("ConnectionState", networking_private::ToString(this->connection_state));

  }
  if (this->error_state) {
    to_value_result.Set("ErrorState", *this->error_state);

  }
  if (this->ethernet) {
    to_value_result.Set("Ethernet", (this->ethernet)->ToValue());

  }
  to_value_result.Set("GUID", this->guid);

  if (this->ip_address_config_type) {
    to_value_result.Set("IPAddressConfigType", (this->ip_address_config_type)->ToValue());

  }
  if (this->ip_configs) {
    to_value_result.Set("IPConfigs", json_schema_compiler::util::CreateValueFromArray(*this->ip_configs));

  }
  if (this->mac_address) {
    to_value_result.Set("MacAddress", *this->mac_address);

  }
  if (this->metered) {
    to_value_result.Set("Metered", (this->metered)->ToValue());

  }
  if (this->name) {
    to_value_result.Set("Name", (this->name)->ToValue());

  }
  if (this->name_servers_config_type) {
    to_value_result.Set("NameServersConfigType", (this->name_servers_config_type)->ToValue());

  }
  if (this->priority) {
    to_value_result.Set("Priority", (this->priority)->ToValue());

  }
  if (this->proxy_settings) {
    to_value_result.Set("ProxySettings", (this->proxy_settings)->ToValue());

  }
  if (this->restricted_connectivity) {
    to_value_result.Set("RestrictedConnectivity", *this->restricted_connectivity);

  }
  if (this->static_ip_config) {
    to_value_result.Set("StaticIPConfig", (this->static_ip_config)->ToValue());

  }
  if (this->saved_ip_config) {
    to_value_result.Set("SavedIPConfig", (this->saved_ip_config)->ToValue());

  }
  if (this->source) {
    to_value_result.Set("Source", *this->source);

  }
  if (this->tether) {
    to_value_result.Set("Tether", (this->tether)->ToValue());

  }
  to_value_result.Set("Type", networking_private::ToString(this->type));

  if (this->vpn) {
    to_value_result.Set("VPN", (this->vpn)->ToValue());

  }
  if (this->wi_fi) {
    to_value_result.Set("WiFi", (this->wi_fi)->ToValue());

  }

  return to_value_result;
}


NetworkStateProperties::NetworkStateProperties()
: connection_state(CONNECTION_STATE_TYPE_NONE),
type(NETWORK_TYPE_NONE) {}

NetworkStateProperties::~NetworkStateProperties() = default;
NetworkStateProperties::NetworkStateProperties(NetworkStateProperties&& rhs) = default;
NetworkStateProperties& NetworkStateProperties::operator=(NetworkStateProperties&& rhs) = default;
// static
bool NetworkStateProperties::Populate(
    const base::Value& value, NetworkStateProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  out->connection_state = CONNECTION_STATE_TYPE_NONE;
  const base::Value* cellular_value = dict.Find("Cellular");
  if (cellular_value) {
    {
      if (!(*cellular_value).is_dict()) {
        return false;
      }
      else {
        CellularStateProperties temp;
        if (!CellularStateProperties::Populate((*cellular_value), &temp))
          return false;
        out->cellular = std::move(temp);
      }
    }
  }

  const base::Value* connectable_value = dict.Find("Connectable");
  if (connectable_value) {
    {
      auto temp = (*connectable_value).GetIfBool();
      if (!temp.has_value()) {
        out->connectable = absl::nullopt;
        return false;
      }
      out->connectable = *temp;
    }
  }

  const base::Value* connection_state_value = dict.Find("ConnectionState");
  if (connection_state_value) {
    {
      const std::string* connection_state_type_as_string = (*connection_state_value).GetIfString();
      if (!connection_state_type_as_string) {
        return false;
      }
      out->connection_state = ParseConnectionStateType(*connection_state_type_as_string);
      if (out->connection_state == CONNECTION_STATE_TYPE_NONE) {
        return false;
      }
    }
    } else {
    out->connection_state = CONNECTION_STATE_TYPE_NONE;
  }

  const base::Value* ethernet_value = dict.Find("Ethernet");
  if (ethernet_value) {
    {
      if (!(*ethernet_value).is_dict()) {
        return false;
      }
      else {
        EthernetStateProperties temp;
        if (!EthernetStateProperties::Populate((*ethernet_value), &temp))
          return false;
        out->ethernet = std::move(temp);
      }
    }
  }

  const base::Value* error_state_value = dict.Find("ErrorState");
  if (error_state_value) {
    {
      auto* temp = (*error_state_value).GetIfString();
      if (!temp) {
        out->error_state = absl::nullopt;
        return false;
      }
      out->error_state = *temp;
    }
  }

  const base::Value* guid_value = dict.Find("GUID");
  if (!guid_value) {
    return false;
  }
  {
    auto* temp = (*guid_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->guid = *temp;
  }

  const base::Value* name_value = dict.Find("Name");
  if (name_value) {
    {
      auto* temp = (*name_value).GetIfString();
      if (!temp) {
        out->name = absl::nullopt;
        return false;
      }
      out->name = *temp;
    }
  }

  const base::Value* priority_value = dict.Find("Priority");
  if (priority_value) {
    {
      auto temp = (*priority_value).GetIfInt();
      if (!temp.has_value()) {
        out->priority = absl::nullopt;
        return false;
      }
      out->priority = *temp;
    }
  }

  const base::Value* source_value = dict.Find("Source");
  if (source_value) {
    {
      auto* temp = (*source_value).GetIfString();
      if (!temp) {
        out->source = absl::nullopt;
        return false;
      }
      out->source = *temp;
    }
  }

  const base::Value* tether_value = dict.Find("Tether");
  if (tether_value) {
    {
      if (!(*tether_value).is_dict()) {
        return false;
      }
      else {
        TetherProperties temp;
        if (!TetherProperties::Populate((*tether_value), &temp))
          return false;
        out->tether = std::move(temp);
      }
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (!type_value) {
    return false;
  }
  {
    const std::string* network_type_as_string = (*type_value).GetIfString();
    if (!network_type_as_string) {
      return false;
    }
    out->type = ParseNetworkType(*network_type_as_string);
    if (out->type == NETWORK_TYPE_NONE) {
      return false;
    }
  }

  const base::Value* vpn_value = dict.Find("VPN");
  if (vpn_value) {
    {
      if (!(*vpn_value).is_dict()) {
        return false;
      }
      else {
        VPNStateProperties temp;
        if (!VPNStateProperties::Populate((*vpn_value), &temp))
          return false;
        out->vpn = std::move(temp);
      }
    }
  }

  const base::Value* wi_fi_value = dict.Find("WiFi");
  if (wi_fi_value) {
    {
      if (!(*wi_fi_value).is_dict()) {
        return false;
      }
      else {
        WiFiStateProperties temp;
        if (!WiFiStateProperties::Populate((*wi_fi_value), &temp))
          return false;
        out->wi_fi = std::move(temp);
      }
    }
  }

  return true;
}

// static
std::unique_ptr<NetworkStateProperties> NetworkStateProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<NetworkStateProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict NetworkStateProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->cellular) {
    to_value_result.Set("Cellular", (this->cellular)->ToValue());

  }
  if (this->connectable) {
    to_value_result.Set("Connectable", *this->connectable);

  }
  if (this->connection_state != CONNECTION_STATE_TYPE_NONE) {
    to_value_result.Set("ConnectionState", networking_private::ToString(this->connection_state));

  }
  if (this->ethernet) {
    to_value_result.Set("Ethernet", (this->ethernet)->ToValue());

  }
  if (this->error_state) {
    to_value_result.Set("ErrorState", *this->error_state);

  }
  to_value_result.Set("GUID", this->guid);

  if (this->name) {
    to_value_result.Set("Name", *this->name);

  }
  if (this->priority) {
    to_value_result.Set("Priority", *this->priority);

  }
  if (this->source) {
    to_value_result.Set("Source", *this->source);

  }
  if (this->tether) {
    to_value_result.Set("Tether", (this->tether)->ToValue());

  }
  to_value_result.Set("Type", networking_private::ToString(this->type));

  if (this->vpn) {
    to_value_result.Set("VPN", (this->vpn)->ToValue());

  }
  if (this->wi_fi) {
    to_value_result.Set("WiFi", (this->wi_fi)->ToValue());

  }

  return to_value_result;
}


DeviceStateProperties::DeviceStateProperties()
: state(DEVICE_STATE_TYPE_NONE),
type(NETWORK_TYPE_NONE) {}

DeviceStateProperties::~DeviceStateProperties() = default;
DeviceStateProperties::DeviceStateProperties(DeviceStateProperties&& rhs) = default;
DeviceStateProperties& DeviceStateProperties::operator=(DeviceStateProperties&& rhs) = default;
// static
bool DeviceStateProperties::Populate(
    const base::Value& value, DeviceStateProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* scanning_value = dict.Find("Scanning");
  if (scanning_value) {
    {
      auto temp = (*scanning_value).GetIfBool();
      if (!temp.has_value()) {
        out->scanning = absl::nullopt;
        return false;
      }
      out->scanning = *temp;
    }
  }

  const base::Value* sim_lock_status_value = dict.Find("SIMLockStatus");
  if (sim_lock_status_value) {
    {
      if (!(*sim_lock_status_value).is_dict()) {
        return false;
      }
      else {
        SIMLockStatus temp;
        if (!SIMLockStatus::Populate((*sim_lock_status_value), &temp))
          return false;
        out->sim_lock_status = std::move(temp);
      }
    }
  }

  const base::Value* sim_present_value = dict.Find("SIMPresent");
  if (sim_present_value) {
    {
      auto temp = (*sim_present_value).GetIfBool();
      if (!temp.has_value()) {
        out->sim_present = absl::nullopt;
        return false;
      }
      out->sim_present = *temp;
    }
  }

  const base::Value* state_value = dict.Find("State");
  if (!state_value) {
    return false;
  }
  {
    const std::string* device_state_type_as_string = (*state_value).GetIfString();
    if (!device_state_type_as_string) {
      return false;
    }
    out->state = ParseDeviceStateType(*device_state_type_as_string);
    if (out->state == DEVICE_STATE_TYPE_NONE) {
      return false;
    }
  }

  const base::Value* type_value = dict.Find("Type");
  if (!type_value) {
    return false;
  }
  {
    const std::string* network_type_as_string = (*type_value).GetIfString();
    if (!network_type_as_string) {
      return false;
    }
    out->type = ParseNetworkType(*network_type_as_string);
    if (out->type == NETWORK_TYPE_NONE) {
      return false;
    }
  }

  const base::Value* managed_network_available_value = dict.Find("ManagedNetworkAvailable");
  if (managed_network_available_value) {
    {
      auto temp = (*managed_network_available_value).GetIfBool();
      if (!temp.has_value()) {
        out->managed_network_available = absl::nullopt;
        return false;
      }
      out->managed_network_available = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<DeviceStateProperties> DeviceStateProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<DeviceStateProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict DeviceStateProperties::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->scanning) {
    to_value_result.Set("Scanning", *this->scanning);

  }
  if (this->sim_lock_status) {
    to_value_result.Set("SIMLockStatus", (this->sim_lock_status)->ToValue());

  }
  if (this->sim_present) {
    to_value_result.Set("SIMPresent", *this->sim_present);

  }
  to_value_result.Set("State", networking_private::ToString(this->state));

  to_value_result.Set("Type", networking_private::ToString(this->type));

  if (this->managed_network_available) {
    to_value_result.Set("ManagedNetworkAvailable", *this->managed_network_available);

  }

  return to_value_result;
}


NetworkFilter::NetworkFilter()
: network_type(NETWORK_TYPE_NONE) {}

NetworkFilter::~NetworkFilter() = default;
NetworkFilter::NetworkFilter(NetworkFilter&& rhs) = default;
NetworkFilter& NetworkFilter::operator=(NetworkFilter&& rhs) = default;
// static
bool NetworkFilter::Populate(
    const base::Value& value, NetworkFilter* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* network_type_value = dict.Find("networkType");
  if (!network_type_value) {
    return false;
  }
  {
    const std::string* network_type_as_string = (*network_type_value).GetIfString();
    if (!network_type_as_string) {
      return false;
    }
    out->network_type = ParseNetworkType(*network_type_as_string);
    if (out->network_type == NETWORK_TYPE_NONE) {
      return false;
    }
  }

  const base::Value* visible_value = dict.Find("visible");
  if (visible_value) {
    {
      auto temp = (*visible_value).GetIfBool();
      if (!temp.has_value()) {
        out->visible = absl::nullopt;
        return false;
      }
      out->visible = *temp;
    }
  }

  const base::Value* configured_value = dict.Find("configured");
  if (configured_value) {
    {
      auto temp = (*configured_value).GetIfBool();
      if (!temp.has_value()) {
        out->configured = absl::nullopt;
        return false;
      }
      out->configured = *temp;
    }
  }

  const base::Value* limit_value = dict.Find("limit");
  if (limit_value) {
    {
      auto temp = (*limit_value).GetIfInt();
      if (!temp.has_value()) {
        out->limit = absl::nullopt;
        return false;
      }
      out->limit = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<NetworkFilter> NetworkFilter::FromValue(const base::Value& value) {
  auto out = std::make_unique<NetworkFilter>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict NetworkFilter::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("networkType", networking_private::ToString(this->network_type));

  if (this->visible) {
    to_value_result.Set("visible", *this->visible);

  }
  if (this->configured) {
    to_value_result.Set("configured", *this->configured);

  }
  if (this->limit) {
    to_value_result.Set("limit", *this->limit);

  }

  return to_value_result;
}


GlobalPolicy::GlobalPolicy()
 {}

GlobalPolicy::~GlobalPolicy() = default;
GlobalPolicy::GlobalPolicy(GlobalPolicy&& rhs) = default;
GlobalPolicy& GlobalPolicy::operator=(GlobalPolicy&& rhs) = default;
// static
bool GlobalPolicy::Populate(
    const base::Value& value, GlobalPolicy* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* allow_only_policy_networks_to_autoconnect_value = dict.Find("AllowOnlyPolicyNetworksToAutoconnect");
  if (allow_only_policy_networks_to_autoconnect_value) {
    {
      auto temp = (*allow_only_policy_networks_to_autoconnect_value).GetIfBool();
      if (!temp.has_value()) {
        out->allow_only_policy_networks_to_autoconnect = absl::nullopt;
        return false;
      }
      out->allow_only_policy_networks_to_autoconnect = *temp;
    }
  }

  const base::Value* allow_only_policy_networks_to_connect_value = dict.Find("AllowOnlyPolicyNetworksToConnect");
  if (allow_only_policy_networks_to_connect_value) {
    {
      auto temp = (*allow_only_policy_networks_to_connect_value).GetIfBool();
      if (!temp.has_value()) {
        out->allow_only_policy_networks_to_connect = absl::nullopt;
        return false;
      }
      out->allow_only_policy_networks_to_connect = *temp;
    }
  }

  const base::Value* allow_only_policy_networks_to_connect_if_available_value = dict.Find("AllowOnlyPolicyNetworksToConnectIfAvailable");
  if (allow_only_policy_networks_to_connect_if_available_value) {
    {
      auto temp = (*allow_only_policy_networks_to_connect_if_available_value).GetIfBool();
      if (!temp.has_value()) {
        out->allow_only_policy_networks_to_connect_if_available = absl::nullopt;
        return false;
      }
      out->allow_only_policy_networks_to_connect_if_available = *temp;
    }
  }

  const base::Value* blocked_hex_ssi_ds_value = dict.Find("BlockedHexSSIDs");
  if (blocked_hex_ssi_ds_value) {
    {
      if (!(*blocked_hex_ssi_ds_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*blocked_hex_ssi_ds_value).GetList(), &out->blocked_hex_ssi_ds)) {
          return false;
        }
      }
    }
  }

  return true;
}

// static
std::unique_ptr<GlobalPolicy> GlobalPolicy::FromValue(const base::Value& value) {
  auto out = std::make_unique<GlobalPolicy>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict GlobalPolicy::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->allow_only_policy_networks_to_autoconnect) {
    to_value_result.Set("AllowOnlyPolicyNetworksToAutoconnect", *this->allow_only_policy_networks_to_autoconnect);

  }
  if (this->allow_only_policy_networks_to_connect) {
    to_value_result.Set("AllowOnlyPolicyNetworksToConnect", *this->allow_only_policy_networks_to_connect);

  }
  if (this->allow_only_policy_networks_to_connect_if_available) {
    to_value_result.Set("AllowOnlyPolicyNetworksToConnectIfAvailable", *this->allow_only_policy_networks_to_connect_if_available);

  }
  if (this->blocked_hex_ssi_ds) {
    to_value_result.Set("BlockedHexSSIDs", json_schema_compiler::util::CreateValueFromArray(*this->blocked_hex_ssi_ds));

  }

  return to_value_result;
}


Certificate::Certificate()
: hardware_backed(false),
device_wide(false) {}

Certificate::~Certificate() = default;
Certificate::Certificate(Certificate&& rhs) = default;
Certificate& Certificate::operator=(Certificate&& rhs) = default;
// static
bool Certificate::Populate(
    const base::Value& value, Certificate* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* hash_value = dict.Find("hash");
  if (!hash_value) {
    return false;
  }
  {
    auto* temp = (*hash_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->hash = *temp;
  }

  const base::Value* issued_by_value = dict.Find("issuedBy");
  if (!issued_by_value) {
    return false;
  }
  {
    auto* temp = (*issued_by_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->issued_by = *temp;
  }

  const base::Value* issued_to_value = dict.Find("issuedTo");
  if (!issued_to_value) {
    return false;
  }
  {
    auto* temp = (*issued_to_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->issued_to = *temp;
  }

  const base::Value* pem_value = dict.Find("pem");
  if (pem_value) {
    {
      auto* temp = (*pem_value).GetIfString();
      if (!temp) {
        out->pem = absl::nullopt;
        return false;
      }
      out->pem = *temp;
    }
  }

  const base::Value* pkcs11_id_value = dict.Find("PKCS11Id");
  if (pkcs11_id_value) {
    {
      auto* temp = (*pkcs11_id_value).GetIfString();
      if (!temp) {
        out->pkcs11_id = absl::nullopt;
        return false;
      }
      out->pkcs11_id = *temp;
    }
  }

  const base::Value* hardware_backed_value = dict.Find("hardwareBacked");
  if (!hardware_backed_value) {
    return false;
  }
  {
    auto temp = (*hardware_backed_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->hardware_backed = *temp;
  }

  const base::Value* device_wide_value = dict.Find("deviceWide");
  if (!device_wide_value) {
    return false;
  }
  {
    auto temp = (*device_wide_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->device_wide = *temp;
  }

  return true;
}

// static
std::unique_ptr<Certificate> Certificate::FromValue(const base::Value& value) {
  auto out = std::make_unique<Certificate>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict Certificate::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("hash", this->hash);

  to_value_result.Set("issuedBy", this->issued_by);

  to_value_result.Set("issuedTo", this->issued_to);

  if (this->pem) {
    to_value_result.Set("pem", *this->pem);

  }
  if (this->pkcs11_id) {
    to_value_result.Set("PKCS11Id", *this->pkcs11_id);

  }
  to_value_result.Set("hardwareBacked", this->hardware_backed);

  to_value_result.Set("deviceWide", this->device_wide);


  return to_value_result;
}


CertificateLists::CertificateLists()
 {}

CertificateLists::~CertificateLists() = default;
CertificateLists::CertificateLists(CertificateLists&& rhs) = default;
CertificateLists& CertificateLists::operator=(CertificateLists&& rhs) = default;
// static
bool CertificateLists::Populate(
    const base::Value& value, CertificateLists* out) {
  if (!value.is_dict()) {
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* server_ca_certificates_value = dict.Find("serverCaCertificates");
  if (!server_ca_certificates_value) {
    return false;
  }
  {
    if (!(*server_ca_certificates_value).is_list()) {
      return false;
    }
    else {
      if (!json_schema_compiler::util::PopulateArrayFromList((*server_ca_certificates_value).GetList(), &out->server_ca_certificates)) {
        return false;
      }
    }
  }

  const base::Value* user_certificates_value = dict.Find("userCertificates");
  if (!user_certificates_value) {
    return false;
  }
  {
    if (!(*user_certificates_value).is_list()) {
      return false;
    }
    else {
      if (!json_schema_compiler::util::PopulateArrayFromList((*user_certificates_value).GetList(), &out->user_certificates)) {
        return false;
      }
    }
  }

  return true;
}

// static
std::unique_ptr<CertificateLists> CertificateLists::FromValue(const base::Value& value) {
  auto out = std::make_unique<CertificateLists>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict CertificateLists::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("serverCaCertificates", json_schema_compiler::util::CreateValueFromArray(this->server_ca_certificates));

  to_value_result.Set("userCertificates", json_schema_compiler::util::CreateValueFromArray(this->user_certificates));


  return to_value_result;
}



//
// Functions
//

namespace GetProperties {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create(const NetworkProperties& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append((result).ToValue());

  return create_results;
}
}  // namespace GetProperties

namespace GetManagedProperties {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create(const ManagedProperties& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append((result).ToValue());

  return create_results;
}
}  // namespace GetManagedProperties

namespace GetState {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create(const NetworkStateProperties& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append((result).ToValue());

  return create_results;
}
}  // namespace GetState

namespace SetProperties {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& properties_value = args[1];
    {
      if (!properties_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!NetworkConfigProperties::Populate(properties_value, &params->properties)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace SetProperties

namespace CreateNetwork {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& shared_value = args[0];
    {
      auto temp = shared_value.GetIfBool();
      if (!temp.has_value()) {
        return std::unique_ptr<Params>();
      }
      params->shared = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& properties_value = args[1];
    {
      if (!properties_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!NetworkConfigProperties::Populate(properties_value, &params->properties)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create(const std::string& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append(result);

  return create_results;
}
}  // namespace CreateNetwork

namespace ForgetNetwork {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace ForgetNetwork

namespace GetNetworks {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& filter_value = args[0];
    {
      if (!filter_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!NetworkFilter::Populate(filter_value, &params->filter)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create(const std::vector<NetworkStateProperties>& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append(json_schema_compiler::util::CreateValueFromArray(result));

  return create_results;
}
}  // namespace GetNetworks

namespace GetVisibleNetworks {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_type_value = args[0];
    {
      const std::string* network_type_as_string = network_type_value.GetIfString();
      if (!network_type_as_string) {
        return std::unique_ptr<Params>();
      }
      params->network_type = ParseNetworkType(*network_type_as_string);
      if (params->network_type == NETWORK_TYPE_NONE) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create(const std::vector<NetworkStateProperties>& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append(json_schema_compiler::util::CreateValueFromArray(result));

  return create_results;
}
}  // namespace GetVisibleNetworks

namespace GetEnabledNetworkTypes {

base::Value::List Results::Create(const std::vector<NetworkType>& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  {
    std::vector<std::string> result_list;
    for (const auto& it : (result)) {
    result_list.push_back(networking_private::ToString(it));
  }
  create_results.Append(json_schema_compiler::util::CreateValueFromArray(result_list));
  }

  return create_results;
}
}  // namespace GetEnabledNetworkTypes

namespace GetDeviceStates {

base::Value::List Results::Create(const std::vector<DeviceStateProperties>& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append(json_schema_compiler::util::CreateValueFromArray(result));

  return create_results;
}
}  // namespace GetDeviceStates

namespace EnableNetworkType {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_type_value = args[0];
    {
      const std::string* network_type_as_string = network_type_value.GetIfString();
      if (!network_type_as_string) {
        return std::unique_ptr<Params>();
      }
      params->network_type = ParseNetworkType(*network_type_as_string);
      if (params->network_type == NETWORK_TYPE_NONE) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace EnableNetworkType

namespace DisableNetworkType {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_type_value = args[0];
    {
      const std::string* network_type_as_string = network_type_value.GetIfString();
      if (!network_type_as_string) {
        return std::unique_ptr<Params>();
      }
      params->network_type = ParseNetworkType(*network_type_as_string);
      if (params->network_type == NETWORK_TYPE_NONE) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace DisableNetworkType

namespace RequestNetworkScan {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() > 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());
  params->network_type = NETWORK_TYPE_NONE;

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_type_value = args[0];
    {
      const std::string* network_type_as_string = network_type_value.GetIfString();
      if (!network_type_as_string) {
        return std::unique_ptr<Params>();
      }
      params->network_type = ParseNetworkType(*network_type_as_string);
      if (params->network_type == NETWORK_TYPE_NONE) {
        return std::unique_ptr<Params>();
      }
    }
  }

  return params;
}


}  // namespace RequestNetworkScan

namespace StartConnect {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace StartConnect

namespace StartDisconnect {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace StartDisconnect

namespace StartActivate {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() < 1 || args.size() > 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& carrier_value = args[1];
    {
      auto* temp = carrier_value.GetIfString();
      if (!temp) {
        params->carrier = absl::nullopt;
        return std::unique_ptr<Params>();
      }
      params->carrier = *temp;
    }
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace StartActivate

namespace GetCaptivePortalStatus {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create(const CaptivePortalStatus& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append(networking_private::ToString(result));

  return create_results;
}
}  // namespace GetCaptivePortalStatus

namespace UnlockCellularSim {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() < 2 || args.size() > 3) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& pin_value = args[1];
    {
      auto* temp = pin_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->pin = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (2 < args.size() &&
      !args[2].is_none()) {
    const base::Value& puk_value = args[2];
    {
      auto* temp = puk_value.GetIfString();
      if (!temp) {
        params->puk = absl::nullopt;
        return std::unique_ptr<Params>();
      }
      params->puk = *temp;
    }
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace UnlockCellularSim

namespace SetCellularSimState {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& sim_state_value = args[1];
    {
      if (!sim_state_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!CellularSimState::Populate(sim_state_value, &params->sim_state)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace SetCellularSimState

namespace SelectCellularMobileNetwork {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& network_guid_value = args[0];
    {
      auto* temp = network_guid_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_guid = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& network_id_value = args[1];
    {
      auto* temp = network_id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->network_id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


base::Value::List Results::Create() {
  base::Value::List create_results;

  return create_results;
}
}  // namespace SelectCellularMobileNetwork

namespace GetGlobalPolicy {

base::Value::List Results::Create(const GlobalPolicy& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append((result).ToValue());

  return create_results;
}
}  // namespace GetGlobalPolicy

namespace GetCertificateLists {

base::Value::List Results::Create(const CertificateLists& result) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append((result).ToValue());

  return create_results;
}
}  // namespace GetCertificateLists

//
// Events
//

namespace OnNetworksChanged {

const char kEventName[] = "networkingPrivate.onNetworksChanged";

base::Value::List Create(const std::vector<std::string>& changes) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append(json_schema_compiler::util::CreateValueFromArray(changes));

  return create_results;
}

}  // namespace OnNetworksChanged

namespace OnNetworkListChanged {

const char kEventName[] = "networkingPrivate.onNetworkListChanged";

base::Value::List Create(const std::vector<std::string>& changes) {
  base::Value::List create_results;
  create_results.reserve(1);
  create_results.Append(json_schema_compiler::util::CreateValueFromArray(changes));

  return create_results;
}

}  // namespace OnNetworkListChanged

namespace OnDeviceStateListChanged {

const char kEventName[] = "networkingPrivate.onDeviceStateListChanged";

base::Value::List Create() {
  base::Value::List create_results;

  return create_results;
}

}  // namespace OnDeviceStateListChanged

namespace OnPortalDetectionCompleted {

const char kEventName[] = "networkingPrivate.onPortalDetectionCompleted";

base::Value::List Create(const std::string& network_guid, const CaptivePortalStatus& status) {
  base::Value::List create_results;
  create_results.reserve(2);
  create_results.Append(network_guid);

  create_results.Append(networking_private::ToString(status));

  return create_results;
}

}  // namespace OnPortalDetectionCompleted

namespace OnCertificateListsChanged {

const char kEventName[] = "networkingPrivate.onCertificateListsChanged";

base::Value::List Create() {
  base::Value::List create_results;

  return create_results;
}

}  // namespace OnCertificateListsChanged

}  // namespace networking_private
}  // namespace api
}  // namespace extensions

